// $ANTLR 2.7.2: "AsmKeyParser.g" -> "AsmKeyParser.java"$


    package de.uka.ilkd.asmkey.parser.antlr;

    import de.uka.ilkd.asmkey.parser.*;
    import de.uka.ilkd.asmkey.parser.ast.*;
    import de.uka.ilkd.key.parser.Location;

    import java.util.*;


import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class AsmKeyParser extends antlr.LLkParser       implements AsmKeyParserTokenTypes
 {


    /* --- static methods --- */

    private static final Location getLocation(AstDeclaration[] decls) {
        if (decls.length == 0) {
            return null;
        } else {
            return decls[0].getLocation();
        }
    }

    private static final Location getLocation(AstTerm[] terms) {
        if (terms.length == 0) {
            return null;
        } else {
            return terms[0].getLocation();
        }
    }

    /** Return a new empty list. */
    private static List createList() {
        return new ArrayList();
    }

    private static Location createLocation(Token token) {
        return new Location(null, token.getLine(), token.getColumn());
    }

    /** return a new array 't # terms'. */
    private static AstTerm[] prependTerm(AstTerm t, AstTerm[] terms) {
        AstTerm[] a = new AstTerm[terms.length + 1];
        System.arraycopy(terms, 0, a, 1, terms.length);
        a[0] = t;
        return a;
    }


    /* --- static fields --- */

    private static final AstTerm[] EMPTY_TERMS = new AstTerm[]{ };

    private static final Identifier[] EMPTY_IDS = new Identifier[]{ };

    private static final AstCondition[] EMPTY_CONDITIONS = new AstCondition[]{ };

    private static final AstParameter[] EMPTY_PARAMETERS = new AstParameter[]{ };

    
    /* --- constructors --- */

    /** Create a parser with the given input and the given ast factory. */
    public AsmKeyParser(TokenStream lexer, AstFactory af) {
        this(lexer);
        this.af = af;
    }


    /* --- fields --- */

    /** The used AstFactory. */
    private AstFactory af = null;


    /* --- inner class --- */

    /** This class stores either a term or a sequent. It is needed
     * because some productions can't distinguish between terms and 
     * sequents without infinte lookahead.  */
    private static final class TermSequent {
        
        final AstTerm term;
        
        final AstSequent sequent;


        TermSequent(AstTerm term) {
            this(term, null);
        }

        TermSequent(AstSequent sequent) {
            this(null, sequent);
        }

        TermSequent(AstTerm term, AstSequent sequent) {
            this.term = term;
            this.sequent = sequent;
        }

    }
    

protected AsmKeyParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public AsmKeyParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected AsmKeyParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public AsmKeyParser(TokenStream lexer) {
  this(lexer,2);
}

public AsmKeyParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final AstTerm  top_formula() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		
		t=term();
		match(Token.EOF_TYPE);
		return t;
	}
	
	protected final AstTerm  term() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		
		t=term20();
		return t;
	}
	
	public final AstTerm  top_term() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		
		t=term();
		match(Token.EOF_TYPE);
		return t;
	}
	
	public final AstProblem  top_problem() throws RecognitionException, TokenStreamException {
		AstProblem p;
		
		
		p=problem();
		match(Token.EOF_TYPE);
		return p;
	}
	
	protected final AstProblem  problem() throws RecognitionException, TokenStreamException {
		AstProblem p;
		
		
		AstDeclaration[] l;
		AstTerm a;
		AstProofExpression pe = null;
		
		
		l=decls();
		match(PROBLEM);
		match(LBRACE);
		a=formula();
		match(RBRACE);
		{
		switch ( LA(1)) {
		case PROOF:
		{
			pe=proof();
			break;
		}
		case EOF:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		p = new AstProblem(getLocation(l), l, a, pe);
		
		return p;
	}
	
	public final AstDeclaration[]  top_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		decls=decls();
		match(Token.EOF_TYPE);
		return decls;
	}
	
	protected final AstDeclaration[]  decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		List list = createList();
		AstDeclaration[] l;
		
		
		{
		_loop86:
		do {
			if ((_tokenSet_0.member(LA(1)))) {
				{
				switch ( LA(1)) {
				case SORTS:
				{
					l=sort_decls();
					break;
				}
				case SCHEMA:
				{
					l=schema_var_decls();
					break;
				}
				case PREDICATES:
				{
					l=pred_decls();
					break;
				}
				case FUNCTIONS:
				{
					l=func_decls();
					break;
				}
				case HEURISTICS:
				{
					l=heur_decls();
					break;
				}
				case RULES:
				{
					l=taclet_decls();
					break;
				}
				case PROCEDURES:
				{
					l=procedure_decls();
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				
				list.addAll(Arrays.asList(l));
				
			}
			else {
				break _loop86;
			}
			
		} while (true);
		}
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	public final AstAsmRule  top_asm_rule() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		
		r=asm_rule();
		match(Token.EOF_TYPE);
		return r;
	}
	
	protected final AstAsmRule  asm_rule() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		
		r=asm_rule_seq();
		return r;
	}
	
	protected final Identifier  ident() throws RecognitionException, TokenStreamException {
		Identifier s;
		
		Token  id = null;
		Token  plus = null;
		
		switch ( LA(1)) {
		case IDENT:
		{
			id = LT(1);
			match(IDENT);
			
						s = new Identifier(createLocation(id), id.getText());
					
			break;
		}
		case PLUS:
		{
			plus = LT(1);
			match(PLUS);
			
			s = new Identifier(createLocation(plus), "+");
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return s;
	}
	
	protected final Identifier[]  id_list() throws RecognitionException, TokenStreamException {
		Identifier[] ids;
		
		
		Identifier id;
		List list = createList();
		
		
		id=ident();
		
		list.add(id);
		
		{
		_loop9:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				id=ident();
				
				list.add(id);
				
			}
			else {
				break _loop9;
			}
			
		} while (true);
		}
		
		ids = (Identifier[]) list.toArray(new Identifier[list.size()]);
		
		return ids;
	}
	
/**
 * In the special but important case of Taclets, we don't yet know
 * whether we are going to have a term or a formula, and it is hard
 * to decide a priori what we are looking at.  So the `term'
 * non-terminal will recognize a term or a formula.  The `formula'
 * reads a formula/term and throws an error if it wasn't a formula.
 * This gives a rather late error message. */
	protected final AstTerm  formula() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		
		t=term();
		return t;
	}
	
	protected final AstTerm  term20() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  eqv = null;
		
		AstTerm t2;
		
		
		t1=term30();
		{
		switch ( LA(1)) {
		case EQV:
		{
			eqv = LT(1);
			match(EQV);
			t2=term20();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(eqv), Operator.EQV),
			new AstTerm[]{ t1, t2 });
			
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMEND:
		case ASMIN:
		case ASMDO:
		case ASMAND:
		case SEMI:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case GT:
		case SEQARROW:
		case UPDATE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term30() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  imp = null;
		
		AstTerm t2;
		
		
		t1=term40();
		{
		switch ( LA(1)) {
		case IMP:
		{
			imp = LT(1);
			match(IMP);
			t2=term30();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(imp), Operator.IMP), 
			new AstTerm[]{ t1, t2 });
			
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMEND:
		case ASMIN:
		case ASMDO:
		case ASMAND:
		case SEMI:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case EQV:
		case GT:
		case SEQARROW:
		case UPDATE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term40() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  or = null;
		
		AstTerm t2;
		
		
		t1=term50();
		{
		switch ( LA(1)) {
		case OR:
		{
			or = LT(1);
			match(OR);
			t2=term40();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(or), Operator.OR), 
			new AstTerm[]{ t1, t2 });
			
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMEND:
		case ASMIN:
		case ASMDO:
		case ASMAND:
		case SEMI:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case IMP:
		case EQV:
		case GT:
		case SEQARROW:
		case UPDATE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term50() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  and = null;
		
		AstTerm t2;
		
		
		t1=term60();
		{
		switch ( LA(1)) {
		case AND:
		{
			and = LT(1);
			match(AND);
			t2=term50();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(and), Operator.AND), 
			new AstTerm[]{ t1, t2});
			
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMEND:
		case ASMIN:
		case ASMDO:
		case ASMAND:
		case SEMI:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case OR:
		case IMP:
		case EQV:
		case GT:
		case SEQARROW:
		case UPDATE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term60() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		Token  not = null;
		
		switch ( LA(1)) {
		case TRUE:
		case FALSE:
		case LPAREN:
		case AT:
		case PLUS:
		case IDENT:
		{
			t=term70();
			break;
		}
		case FORALL:
		case EXISTS:
		case LBRACE:
		{
			t=bindingterm();
			break;
		}
		case ASMDEF:
		case ASMUPD:
		case ASMCON:
		case ASMINV:
		case ASMEQUI:
		case ASMEQUIS:
		case ASMJOINABLE:
		case LBRACK:
		case LT:
		{
			t=dl_term();
			break;
		}
		case NOT:
		{
			not = LT(1);
			match(NOT);
			t=term60();
			
			t = af.createTerm(createLocation(not), 
			new AstOperator(createLocation(not), Operator.NOT), 
			new AstTerm[]{ t });
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return t;
	}
	
	protected final AstTerm  term70() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  equals = null;
		
		AstTerm t2;
		
		
		t1=term80();
		{
		switch ( LA(1)) {
		case EQUALS:
		{
			equals = LT(1);
			match(EQUALS);
			t2=term80();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(equals), Operator.EQUALS), 
			new AstTerm[]{ t1, t2 });
			
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMEND:
		case ASMIN:
		case ASMDO:
		case ASMAND:
		case SEMI:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case OR:
		case AND:
		case IMP:
		case EQV:
		case GT:
		case SEQARROW:
		case UPDATE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  bindingterm() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		
		AstQuantifier q;
		Identifier var;
		AstTerm t1, t2;
		Identifier sort = null;
		
		
		{
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		{
			q=quantifier();
			var=ident();
			{
			switch ( LA(1)) {
			case COLON:
			{
				match(COLON);
				sort=ident();
				break;
			}
			case DOT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(DOT);
			t1=term60();
			
			t = af.createTerm(q.getLocation(), q, var, sort, t1);
			
			break;
		}
		case LBRACE:
		{
			match(LBRACE);
			var=ident();
			{
			switch ( LA(1)) {
			case COLON:
			{
				match(COLON);
				sort=ident();
				break;
			}
			case FORALL:
			case EXISTS:
			case TRUE:
			case FALSE:
			case NOT:
			case ASMDEF:
			case ASMUPD:
			case ASMCON:
			case ASMINV:
			case ASMEQUI:
			case ASMEQUIS:
			case ASMJOINABLE:
			case LPAREN:
			case LBRACE:
			case LBRACK:
			case AT:
			case LT:
			case PLUS:
			case IDENT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			t1=term();
			match(RBRACE);
			t2=term60();
			
			t = af.createSubstitutionTerm(var.getLocation(), var, sort, t1, t2);
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t;
	}
	
	protected final AstTerm  dl_term() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		Token  lbrack = null;
		Token  lt = null;
		Token  def = null;
		Token  upd = null;
		Token  con = null;
		Token  inv = null;
		Token  joinable = null;
		Token  equi = null;
		Token  equiS = null;
		
		AstAsmRule r, s;
		AstTerm t1, t2;
		
		
		switch ( LA(1)) {
		case LBRACK:
		{
			lbrack = LT(1);
			match(LBRACK);
			r=asm_rule();
			match(RBRACK);
			t=term60();
			
			t = af.createDlBox(createLocation(lbrack), r, t);
			
			break;
		}
		case LT:
		{
			lt = LT(1);
			match(LT);
			r=asm_rule();
			match(GT);
			t=term60();
			
			t = af.createDlDiamond(createLocation(lt), r, t);
			
			break;
		}
		case ASMDEF:
		{
			def = LT(1);
			match(ASMDEF);
			match(LPAREN);
			r=asm_rule();
			match(RPAREN);
			
			t = af.createDlDef(createLocation(def), r);
			
			break;
		}
		case ASMUPD:
		{
			upd = LT(1);
			match(ASMUPD);
			match(LPAREN);
			t1=term();
			match(UPDATE);
			t2=term();
			match(ASMIN);
			r=asm_rule();
			match(RPAREN);
			
			t = af.createDlUpd(createLocation(upd), t1, t2, r);
			
			break;
		}
		case ASMCON:
		{
			con = LT(1);
			match(ASMCON);
			match(LPAREN);
			r=asm_rule();
			match(RPAREN);
			
			t = af.createDlCon(createLocation(con), r);
			
			break;
		}
		case ASMINV:
		{
			inv = LT(1);
			match(ASMINV);
			match(LPAREN);
			t=term();
			match(ASMIN);
			r=asm_rule();
			match(RPAREN);
			
			t = af.createDlInv(createLocation(inv), t, r);
			
			break;
		}
		case ASMJOINABLE:
		{
			joinable = LT(1);
			match(ASMJOINABLE);
			match(LPAREN);
			r=asm_rule();
			match(ASMAND);
			s=asm_rule();
			match(RPAREN);
			
			t = af.createDlJoinable(createLocation(joinable), r, s);
			
			break;
		}
		case ASMEQUI:
		{
			equi = LT(1);
			match(ASMEQUI);
			match(LPAREN);
			r=asm_rule();
			match(ASMAND);
			s=asm_rule();
			match(RPAREN);
			
			t = af.createDlEqui(createLocation(equi), r, s);
			
			break;
		}
		case ASMEQUIS:
		{
			equiS = LT(1);
			match(ASMEQUIS);
			match(LPAREN);
			r=asm_rule();
			match(ASMAND);
			s=asm_rule();
			match(RPAREN);
			
			t = af.createDlEquiS(createLocation(equiS), r, s);
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return t;
	}
	
	protected final AstTerm  term80() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  asterix = null;
		Token  slash = null;
		
		AstTerm t2;
		
		
		t1=term90();
		{
		switch ( LA(1)) {
		case ASTERIX:
		{
			{
			asterix = LT(1);
			match(ASTERIX);
			t2=term80();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(asterix), Operator.MULT),
			new AstTerm[]{ t1, t2 });
			
			}
			break;
		}
		case SLASH:
		{
			{
			slash = LT(1);
			match(SLASH);
			t2=term80();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(slash), Operator.DIV),
			new AstTerm[]{ t1, t2 });
			
			}
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMEND:
		case ASMIN:
		case ASMDO:
		case ASMAND:
		case SEMI:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case OR:
		case AND:
		case IMP:
		case EQV:
		case EQUALS:
		case GT:
		case SEQARROW:
		case UPDATE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term90() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  plus = null;
		Token  minus = null;
		
		AstTerm t2;
		
		
		t1=term100();
		{
		switch ( LA(1)) {
		case PLUS:
		{
			{
			plus = LT(1);
			match(PLUS);
			t2=term90();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(plus), Operator.ADD),
			new AstTerm[]{ t1, t2 });
			
			}
			break;
		}
		case MINUS:
		{
			{
			minus = LT(1);
			match(MINUS);
			t2=term90();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(minus), Operator.SUB),
			new AstTerm[]{ t1, t2 });
			
			}
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMEND:
		case ASMIN:
		case ASMDO:
		case ASMAND:
		case SEMI:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case OR:
		case AND:
		case IMP:
		case EQV:
		case EQUALS:
		case GT:
		case SEQARROW:
		case ASTERIX:
		case SLASH:
		case UPDATE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term100() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		Token  true_ = null;
		Token  false_ = null;
		Token  at = null;
		
		Location location;
		Identifier abbr;
		
		
		switch ( LA(1)) {
		case PLUS:
		case IDENT:
		{
			t=funcpredvarterm();
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			t=term();
			match(RPAREN);
			break;
		}
		case TRUE:
		{
			true_ = LT(1);
			match(TRUE);
			
			t = af.createTerm(createLocation(true_), 
			new AstOperator(createLocation(true_), Operator.TRUE),
			null);
			
			break;
		}
		case FALSE:
		{
			false_ = LT(1);
			match(FALSE);
			
			t = af.createTerm(createLocation(false_), 
			new AstOperator(createLocation(false_), Operator.FALSE), 
			null);
			
			break;
		}
		case AT:
		{
			at = LT(1);
			match(AT);
			abbr=ident();
			
			t = af.createAbbreviationTerm(createLocation(at), abbr);
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return t;
	}
	
	protected final AstTerm  funcpredvarterm() throws RecognitionException, TokenStreamException {
		AstTerm a;
		
		
		Identifier id;
		AstTerm[] l;
		
		
		id=ident();
		l=term_args();
		
		a = af.createTerm(id.getLocation(), id, l);
		
		return a;
	}
	
	protected final AstQuantifier  quantifier() throws RecognitionException, TokenStreamException {
		AstQuantifier q;
		
		Token  all = null;
		Token  ex = null;
		
		switch ( LA(1)) {
		case FORALL:
		{
			all = LT(1);
			match(FORALL);
			
			q = new AstQuantifier(createLocation(all), Quantifier.ALL);
			
			break;
		}
		case EXISTS:
		{
			ex = LT(1);
			match(EXISTS);
			
			q = new AstQuantifier(createLocation(ex), Quantifier.EX);
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return q;
	}
	
	protected final AstTerm[]  term_list() throws RecognitionException, TokenStreamException {
		AstTerm[] terms;
		
		
		List list = createList();
		AstTerm t;
		
		
		t=term();
		
		list.add(t);
		
		{
		_loop40:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				t=term();
				
				list.add(t);
				
			}
			else {
				break _loop40;
			}
			
		} while (true);
		}
		
		terms = (AstTerm[]) list.toArray(new AstTerm[list.size()]);
		
		return terms;
	}
	
	protected final AstTerm[]  term_args() throws RecognitionException, TokenStreamException {
		AstTerm[] terms = null;
		
		
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			{
			switch ( LA(1)) {
			case FORALL:
			case EXISTS:
			case TRUE:
			case FALSE:
			case NOT:
			case ASMDEF:
			case ASMUPD:
			case ASMCON:
			case ASMINV:
			case ASMEQUI:
			case ASMEQUIS:
			case ASMJOINABLE:
			case LPAREN:
			case LBRACE:
			case LBRACK:
			case AT:
			case LT:
			case PLUS:
			case IDENT:
			{
				terms=term_list();
				match(RPAREN);
				break;
			}
			case RPAREN:
			{
				match(RPAREN);
				
				terms = EMPTY_TERMS;
				
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMEND:
		case ASMIN:
		case ASMDO:
		case ASMAND:
		case SEMI:
		case ASSIGN:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case OR:
		case AND:
		case IMP:
		case EQV:
		case EQUALS:
		case GT:
		case SEQARROW:
		case PLUS:
		case MINUS:
		case ASTERIX:
		case SLASH:
		case UPDATE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return terms;
	}
	
	protected final AstSequent  seq() throws RecognitionException, TokenStreamException {
		AstSequent s;
		
		
		AstTerm[] ant = EMPTY_TERMS, suc = EMPTY_TERMS;
		
		
		{
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		case TRUE:
		case FALSE:
		case NOT:
		case ASMDEF:
		case ASMUPD:
		case ASMCON:
		case ASMINV:
		case ASMEQUI:
		case ASMEQUIS:
		case ASMJOINABLE:
		case LPAREN:
		case LBRACE:
		case LBRACK:
		case AT:
		case LT:
		case PLUS:
		case IDENT:
		{
			ant=term_list();
			break;
		}
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(SEQARROW);
		{
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		case TRUE:
		case FALSE:
		case NOT:
		case ASMDEF:
		case ASMUPD:
		case ASMCON:
		case ASMINV:
		case ASMEQUI:
		case ASMEQUIS:
		case ASMJOINABLE:
		case LPAREN:
		case LBRACE:
		case LBRACK:
		case AT:
		case LT:
		case PLUS:
		case IDENT:
		{
			suc=term_list();
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		s = new AstSequent(getLocation(ant), ant, suc);
		
		return s;
	}
	
	protected final TermSequent  termorseq() throws RecognitionException, TokenStreamException {
		TermSequent ts;
		
		Token  seqarrow = null;
		
		AstTerm t;
		AstTerm[] ant, suc = EMPTY_TERMS;
		
		
		{
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		case TRUE:
		case FALSE:
		case NOT:
		case ASMDEF:
		case ASMUPD:
		case ASMCON:
		case ASMINV:
		case ASMEQUI:
		case ASMEQUIS:
		case ASMJOINABLE:
		case LPAREN:
		case LBRACE:
		case LBRACK:
		case AT:
		case LT:
		case PLUS:
		case IDENT:
		{
			t=term();
			{
			switch ( LA(1)) {
			case RPAREN:
			{
				
				ts = new TermSequent(t);
				
				break;
			}
			case SEQARROW:
			{
				match(SEQARROW);
				{
				switch ( LA(1)) {
				case FORALL:
				case EXISTS:
				case TRUE:
				case FALSE:
				case NOT:
				case ASMDEF:
				case ASMUPD:
				case ASMCON:
				case ASMINV:
				case ASMEQUI:
				case ASMEQUIS:
				case ASMJOINABLE:
				case LPAREN:
				case LBRACE:
				case LBRACK:
				case AT:
				case LT:
				case PLUS:
				case IDENT:
				{
					suc=term_list();
					break;
				}
				case RPAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				
				ts = new TermSequent(new AstSequent(t.getLocation(), new AstTerm[]{ t }, suc));
				
				break;
			}
			case COMMA:
			{
				match(COMMA);
				ant=term_list();
				match(SEQARROW);
				{
				switch ( LA(1)) {
				case FORALL:
				case EXISTS:
				case TRUE:
				case FALSE:
				case NOT:
				case ASMDEF:
				case ASMUPD:
				case ASMCON:
				case ASMINV:
				case ASMEQUI:
				case ASMEQUIS:
				case ASMJOINABLE:
				case LPAREN:
				case LBRACE:
				case LBRACK:
				case AT:
				case LT:
				case PLUS:
				case IDENT:
				{
					suc=term_list();
					break;
				}
				case RPAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				
				ts = new TermSequent(new AstSequent(t.getLocation(), prependTerm(t, ant), suc));
				
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case SEQARROW:
		{
			seqarrow = LT(1);
			match(SEQARROW);
			{
			switch ( LA(1)) {
			case FORALL:
			case EXISTS:
			case TRUE:
			case FALSE:
			case NOT:
			case ASMDEF:
			case ASMUPD:
			case ASMCON:
			case ASMINV:
			case ASMEQUI:
			case ASMEQUIS:
			case ASMJOINABLE:
			case LPAREN:
			case LBRACE:
			case LBRACK:
			case AT:
			case LT:
			case PLUS:
			case IDENT:
			{
				suc=term_list();
				break;
			}
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			
			ts = new TermSequent(new AstSequent(createLocation(seqarrow), EMPTY_TERMS, suc));
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return ts;
	}
	
	protected final AstTaclet  taclet() throws RecognitionException, TokenStreamException {
		AstTaclet r;
		
		Token  if_ = null;
		Token  find = null;
		
		AstSequent s = null;
		TermSequent ts;
		AstCondition[] conds = EMPTY_CONDITIONS;
		AstGoal[] goals;
		AstTacletModifier[] mods;
		Location location = null;
		
		
		{
		switch ( LA(1)) {
		case IF:
		{
			if_ = LT(1);
			match(IF);
			match(LPAREN);
			s=seq();
			match(RPAREN);
			
			location = createLocation(if_);
			
			break;
		}
		case FIND:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		find = LT(1);
		match(FIND);
		match(LPAREN);
		ts=termorseq();
		match(RPAREN);
		
		if (location == null) {
		location = createLocation(find);
		}
		
		}
		{
		switch ( LA(1)) {
		case VARCOND:
		case COND:
		{
			{
			switch ( LA(1)) {
			case VARCOND:
			{
				match(VARCOND);
				break;
			}
			case COND:
			{
				match(COND);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			conds=conditions();
			match(RPAREN);
			break;
		}
		case CLOSE:
		case REPLACEWITH:
		case ADDRULES:
		case ADD:
		case NONINTERACTIVE:
		case RECURSIVE:
		case DISPLAYNAME:
		case HELPTEXT:
		case HEURISTICS:
		case SEMI:
		case RBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		goals=goalspecs();
		mods=modifiers();
		
		if (ts.term != null) {
		r = new AstTaclet(location, s, ts.term, conds, goals, mods);
		} else {
		r = new AstTaclet(location, s, ts.sequent, conds, goals, mods);
		}
		
		return r;
	}
	
	protected final AstCondition[]  conditions() throws RecognitionException, TokenStreamException {
		AstCondition[] conds;
		
		
		AstCondition cond;
		List list = createList();
		
		
		cond=condition();
		
		list.add(cond);
		
		{
		_loop61:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				cond=condition();
				
				list.add(cond);
				
			}
			else {
				break _loop61;
			}
			
		} while (true);
		}
		
		conds = (AstCondition[]) list.toArray(new AstCondition[list.size()]);
		
		return conds;
	}
	
	protected final AstGoal[]  goalspecs() throws RecognitionException, TokenStreamException {
		AstGoal[] goals;
		
		
		switch ( LA(1)) {
		case CLOSE:
		{
			match(CLOSE);
			match(GOAL);
			
			goals = new AstGoal[]{ };
			
			break;
		}
		case REPLACEWITH:
		case ADDRULES:
		case ADD:
		case NONINTERACTIVE:
		case RECURSIVE:
		case DISPLAYNAME:
		case HELPTEXT:
		case HEURISTICS:
		case SEMI:
		case RBRACE:
		{
			goals=goalspec_list();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return goals;
	}
	
	protected final AstTacletModifier[]  modifiers() throws RecognitionException, TokenStreamException {
		AstTacletModifier[] l;
		
		
		List list = createList();
		AstTacletModifier tm;
		
		
		{
		_loop79:
		do {
			if ((_tokenSet_1.member(LA(1)))) {
				tm=modifier();
				
				list.add(tm);
				
			}
			else {
				break _loop79;
			}
			
		} while (true);
		}
		
		l = (AstTacletModifier[]) list.toArray(new AstTacletModifier[list.size()]);
		
		return l;
	}
	
	protected final AstCondition  condition() throws RecognitionException, TokenStreamException {
		AstCondition cond;
		
		Token  op = null;
		Token  pure = null;
		Token  static_ = null;
		Token  staticargs = null;
		Token  dynamic = null;
		Token  call = null;
		
		Identifier v, w;
		
		
		switch ( LA(1)) {
		case OP:
		{
			op = LT(1);
			match(OP);
			v=ident();
			{
			switch ( LA(1)) {
			case EQUALS:
			{
				match(EQUALS);
				w=ident();
				
				cond = af.createOperatorEqualsCondition(createLocation(op), true, v, w);
				
				break;
			}
			case NOTEQUALS:
			{
				match(NOTEQUALS);
				w=ident();
				
				cond = af.createOperatorEqualsCondition(createLocation(op), false, v, w);
				
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case PURE:
		{
			pure = LT(1);
			match(PURE);
			v=ident();
			
			cond = af.createPureCondition(createLocation(pure), v);
			
			break;
		}
		case STATIC:
		{
			static_ = LT(1);
			match(STATIC);
			v=ident();
			
			cond = af.createStaticCondition(createLocation(static_), v);
			
			break;
		}
		case STATICARGS:
		{
			staticargs = LT(1);
			match(STATICARGS);
			v=ident();
			
			cond = af.createStaticArgsCondition(createLocation(staticargs), v);
			
			break;
		}
		case DYNAMIC:
		{
			dynamic = LT(1);
			match(DYNAMIC);
			v=ident();
			
			cond = af.createDynamicCondition(createLocation(dynamic), v);
			
			break;
		}
		case CALL:
		{
			call = LT(1);
			match(CALL);
			v=ident();
			
			cond = af.createCallCondition(createLocation(call), v);
			
			break;
		}
		default:
			if ((LA(1)==PLUS||LA(1)==IDENT) && (LA(2)==NOT)) {
				v=ident();
				match(NOT);
				match(FREE);
				match(ASMIN);
				w=ident();
				
				cond = af.createNotFreeCondition(v.getLocation(), v, w);
				
			}
			else if ((LA(1)==PLUS||LA(1)==IDENT) && (LA(2)==NEW)) {
				v=ident();
				match(NEW);
				match(DEPENDING);
				match(ON);
				w=ident();
				
				cond = af.createSkolemCondition(v.getLocation(), v, w);
				
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return cond;
	}
	
	protected final AstGoal[]  goalspec_list() throws RecognitionException, TokenStreamException {
		AstGoal[] goals;
		
		
		List list = createList();
		AstGoal g;
		
		
		g=goalspec();
		
		list.add(g);
		
		{
		_loop67:
		do {
			if ((LA(1)==SEMI)) {
				match(SEMI);
				g=goalspec();
				
				list.add(g);
				
			}
			else {
				break _loop67;
			}
			
		} while (true);
		}
		
		goals = (AstGoal[]) list.toArray(new AstGoal[list.size()]);
		
		return goals;
	}
	
	protected final AstGoal  goalspec() throws RecognitionException, TokenStreamException {
		AstGoal goal;
		
		
		goal=replacewith();
		return goal;
	}
	
	protected final AstGoal  replacewith() throws RecognitionException, TokenStreamException {
		AstGoal goal;
		
		Token  rw = null;
		Token  str = null;
		Token  add = null;
		Token  addrules = null;
		
		Location location = null;
		TermSequent ts = null;
		AstSequent s = null;
		AstTacletDeclaration[] l = null;
		String name = null;
		
		
		{
		switch ( LA(1)) {
		case REPLACEWITH:
		{
			rw = LT(1);
			match(REPLACEWITH);
			{
			switch ( LA(1)) {
			case STRING_LITERAL:
			{
				str = LT(1);
				match(STRING_LITERAL);
				
				name = str.getText();
				
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			ts=termorseq();
			match(RPAREN);
			
			if (location == null) {
			location = createLocation(rw);
			}
			
			break;
		}
		case ADDRULES:
		case ADD:
		case NONINTERACTIVE:
		case RECURSIVE:
		case DISPLAYNAME:
		case HELPTEXT:
		case HEURISTICS:
		case SEMI:
		case RBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case ADD:
		{
			add = LT(1);
			match(ADD);
			match(LPAREN);
			s=seq();
			match(RPAREN);
			
			if (location == null) {
			location = createLocation(add);
			}
			
			break;
		}
		case ADDRULES:
		case NONINTERACTIVE:
		case RECURSIVE:
		case DISPLAYNAME:
		case HELPTEXT:
		case HEURISTICS:
		case SEMI:
		case RBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case ADDRULES:
		{
			addrules = LT(1);
			match(ADDRULES);
			match(LPAREN);
			l=taclet_decl_list();
			match(RPAREN);
			
			if (location == null) {
			location = createLocation(addrules);
			}
			
			break;
		}
		case NONINTERACTIVE:
		case RECURSIVE:
		case DISPLAYNAME:
		case HELPTEXT:
		case HEURISTICS:
		case SEMI:
		case RBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		if (ts == null) {
		goal = af.createReplaceGoal(location, name, (AstTerm) null, s, l);
		} else if (ts.term != null) {
		goal = af.createReplaceGoal(location, name, ts.term, s, l);
		} else {
		goal = af.createReplaceGoal(location, name, ts.sequent, s, l);
		}
		
		return goal;
	}
	
	protected final AstTacletDeclaration[]  taclet_decl_list() throws RecognitionException, TokenStreamException {
		AstTacletDeclaration[] l;
		
		
		AstTacletDeclaration decl;
		List list = createList();
		
		
		decl=taclet_decl();
		
		list.add(decl);
		
		{
		_loop76:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				decl=taclet_decl();
				
				list.add(decl);
				
			}
			else {
				break _loop76;
			}
			
		} while (true);
		}
		
		l = (AstTacletDeclaration[]) list.toArray(new AstTacletDeclaration[list.size()]);
		
		return l;
	}
	
	protected final AstTacletDeclaration  taclet_decl() throws RecognitionException, TokenStreamException {
		AstTacletDeclaration decl;
		
		
		Identifier id;
		AstTaclet t;
		
		
		id=ident();
		match(LBRACE);
		t=taclet();
		match(RBRACE);
		
		decl = new AstTacletDeclaration(id.getLocation(), id, t);
		
		return decl;
	}
	
	protected final AstTacletModifier  modifier() throws RecognitionException, TokenStreamException {
		AstTacletModifier tm;
		
		Token  heurs = null;
		Token  ni = null;
		Token  re = null;
		Token  dn = null;
		Token  dname = null;
		Token  ht = null;
		Token  htext = null;
		
		Identifier[] ids;
		
		
		switch ( LA(1)) {
		case HEURISTICS:
		{
			heurs = LT(1);
			match(HEURISTICS);
			match(LPAREN);
			ids=id_list();
			match(RPAREN);
			
			tm = af.createTacletHeuristics(createLocation(heurs), ids);
			
			break;
		}
		case NONINTERACTIVE:
		{
			ni = LT(1);
			match(NONINTERACTIVE);
			
			tm = af.createTacletNonInteractiveModifier(createLocation(ni));
			
			break;
		}
		case RECURSIVE:
		{
			re = LT(1);
			match(RECURSIVE);
			
			tm = af.createTacletRecursiveModifier(createLocation(re));
			
			break;
		}
		case DISPLAYNAME:
		{
			dn = LT(1);
			match(DISPLAYNAME);
			dname = LT(1);
			match(STRING_LITERAL);
			
			tm = af.createTacletDisplayNameModifier(createLocation(dn), dname.getText());
			
			break;
		}
		case HELPTEXT:
		{
			ht = LT(1);
			match(HELPTEXT);
			htext = LT(1);
			match(STRING_LITERAL);
			
			tm = af.createTacletHelpTextModifier(createLocation(ht), htext.getText());
			// b.setHelpText(htext.getText());
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return tm;
	}
	
	public final AstProofExpression  proof() throws RecognitionException, TokenStreamException {
		AstProofExpression pe;
		
		
		match(PROOF);
		match(LBRACE);
		pe=proof_expr();
		match(RBRACE);
		return pe;
	}
	
	protected final AstDeclaration[]  sort_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
			List list = createList();
		AstDeclaration decl;
		
		
		match(SORTS);
		match(LBRACE);
		{
		_loop89:
		do {
			if ((LA(1)==PLUS||LA(1)==IDENT)) {
				decl=sort_decl();
				
				list.add(decl);
				
			}
			else {
				break _loop89;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration[]  schema_var_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
			List list = createList();
		AstDeclaration[] decl;
		
		
		match(SCHEMA);
		match(VARIABLES);
		match(LBRACE);
		{
		_loop93:
		do {
			if ((_tokenSet_2.member(LA(1)))) {
				decl=schema_var_decl();
				
				list.addAll(Arrays.asList(decl));
				
			}
			else {
				break _loop93;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration[]  pred_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		List list = createList();
		AstDeclaration decl;
		
		
		match(PREDICATES);
		match(LBRACE);
		{
		_loop100:
		do {
			if ((LA(1)==PLUS||LA(1)==IDENT)) {
				decl=pred_decl();
				
				list.add(decl);
				
			}
			else {
				break _loop100;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration[]  func_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		List list = createList();
		AstDeclaration decl;
		
		
		match(FUNCTIONS);
		match(LBRACE);
		{
		_loop104:
		do {
			if ((LA(1)==DYNAMIC||LA(1)==PLUS||LA(1)==IDENT)) {
				decl=func_decl();
				
				list.add(decl);
				
			}
			else {
				break _loop104;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration[]  heur_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		List list = createList();
		AstDeclaration decl;
		
		
		match(HEURISTICS);
		match(LBRACE);
		{
		_loop109:
		do {
			if ((LA(1)==PLUS||LA(1)==IDENT)) {
				decl=heur_decl();
				
				list.add(decl);
				
			}
			else {
				break _loop109;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration[]  taclet_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
			List list = createList();
		AstDeclaration d;
		
		
		match(RULES);
		match(LBRACE);
		{
		_loop116:
		do {
			if ((LA(1)==PLUS||LA(1)==IDENT)) {
				d=taclet_decl();
				match(SEMI);
				
				list.add(d);
				
			}
			else {
				break _loop116;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration[]  procedure_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
			List list = createList();
		AstDeclaration d;
		
		
		match(PROCEDURES);
		match(LBRACE);
		{
		_loop120:
		do {
			if ((LA(1)==PLUS||LA(1)==IDENT)) {
				d=procedure_decl();
				match(SEMI);
				
				list.add(d);
				
			}
			else {
				break _loop120;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration  sort_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration decl;
		
		
		Identifier id;
		
		
		id=ident();
		match(SEMI);
		
		decl = af.createSortDeclaration(id.getLocation(), id);
		
		return decl;
	}
	
	protected final AstDeclaration[]  schema_var_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
			AstSchemaType r;
		Identifier[] l;
		
		
		r=schema_type_ref();
		l=id_list();
		match(SEMI);
		
		decls = new AstDeclaration[l.length];
		for (int i = 0; i < l.length; ++i) {
		decls[i] = af.createSchemaVariableDeclaration(r.getLocation(), l[i], r);
		}
		
		return decls;
	}
	
	protected final AstSchemaType  schema_type_ref() throws RecognitionException, TokenStreamException {
		AstSchemaType r;
		
		Token  asm = null;
		Token  formula = null;
		
		Identifier sort;
		boolean variable = false;
		boolean depending = false;
		
		
		{
		switch ( LA(1)) {
		case ASM:
		{
			asm = LT(1);
			match(ASM);
			match(RULE);
			
			r = af.createSchemaType(createLocation(asm), PrimitiveSchemaType.ASMRULE);
			
			break;
		}
		case FORMULA:
		{
			formula = LT(1);
			match(FORMULA);
			
			r = af.createSchemaType(createLocation(formula), PrimitiveSchemaType.FORMULA);
			
			break;
		}
		case PLUS:
		case IDENT:
		{
			sort=ident();
			{
			switch ( LA(1)) {
			case VARIABLES:
			{
				match(VARIABLES);
				
				variable = true; 
				
				break;
			}
			case DEPENDING:
			{
				match(DEPENDING);
				
				depending = true;
				
				break;
			}
			case PLUS:
			case IDENT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			
			if (depending) {
			r = af.createDependingSchemaType(sort.getLocation(), sort);
			} else {
			r = af.createSchemaType(sort.getLocation(), sort, variable);
			}
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return r;
	}
	
	protected final AstDeclaration  pred_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration decl;
		
		
		Identifier id;
		Identifier[] args;
		
		
		id=ident();
		args=arg_ids();
		match(SEMI);
		
		decl = af.createPredicateDeclaration(id.getLocation(), id, args);
		
		return decl;
	}
	
	protected final Identifier[]  arg_ids() throws RecognitionException, TokenStreamException {
		Identifier[] sorts = null;
		
		
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			{
			switch ( LA(1)) {
			case PLUS:
			case IDENT:
			{
				sorts=id_list();
				match(RPAREN);
				break;
			}
			case RPAREN:
			{
				match(RPAREN);
				
				sorts = EMPTY_IDS;
				
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return sorts;
	}
	
	protected final AstDeclaration  func_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration decl;
		
		Token  d = null;
		
		Identifier ret;
		Identifier id;
			Identifier[] args;
		boolean dynamic = false;
		Location location = null;
		
		
		{
		switch ( LA(1)) {
		case DYNAMIC:
		{
			d = LT(1);
			match(DYNAMIC);
			
			dynamic = true;
			location = createLocation(d);
			
			break;
		}
		case PLUS:
		case IDENT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		ret=ident();
		id=ident();
		args=arg_ids();
		match(SEMI);
		
		decl = af.createFunctionDeclaration(location != null ? location : ret.getLocation(),
		id, args, ret, dynamic);
		
		return decl;
	}
	
	protected final AstDeclaration  heur_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration decl;
		
		
		Identifier id;
		
		
		id=ident();
		match(SEMI);
		
		decl = af.createHeuristicDeclaration(id.getLocation(), id);
		
		return decl;
	}
	
	protected final AstDeclaration  procedure_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration d;
		
		
		Identifier id;
		AstParameter[] params = EMPTY_PARAMETERS;
		AstAsmRule r;
		
		
		id=ident();
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			{
			switch ( LA(1)) {
			case PLUS:
			case IDENT:
			{
				params=param_list();
				break;
			}
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RPAREN);
			break;
		}
		case LBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(LBRACE);
		r=asm_rule();
		match(RBRACE);
		
		d = af.createProcedureDeclaration(id.getLocation(), id, params, r);
		
		return d;
	}
	
	protected final AstParameter[]  param_list() throws RecognitionException, TokenStreamException {
		AstParameter[] l;
		
		
		AstParameter p;
		List list = createList();
		
		
		p=param();
		
		list.add(p);
		
		{
		_loop145:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				p=param();
				
				list.add(p);
				
			}
			else {
				break _loop145;
			}
			
		} while (true);
		}
		
		l = (AstParameter[]) list.toArray(new AstParameter[list.size()]);
		
		return l;
	}
	
	protected final AstAsmRule  asm_rule_seq() throws RecognitionException, TokenStreamException {
		AstAsmRule r1;
		
		
		AstAsmRule r2;
		
		
		r1=asm_rule_par();
		{
		switch ( LA(1)) {
		case SEMI:
		{
			match(SEMI);
			r2=asm_rule_seq();
			
			r1 = af.createAsmSeq(r1.getLocation(), r1, r2);
			
			break;
		}
		case EOF:
		case ASMELSE:
		case ASMEND:
		case ASMAND:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case GT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return r1;
	}
	
	protected final AstAsmRule  asm_rule_par() throws RecognitionException, TokenStreamException {
		AstAsmRule r1;
		
		
		AstAsmRule r2;
		
		
		r1=asm_rule_atom();
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			r2=asm_rule_par();
			
			r1 = af.createAsmPar(r1.getLocation(), r1, r2);
			
			break;
		}
		case EOF:
		case ASMELSE:
		case ASMEND:
		case ASMAND:
		case SEMI:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case GT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return r1;
	}
	
	protected final AstAsmRule  asm_rule_atom() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		
		Identifier id;
		
		
		{
		switch ( LA(1)) {
		case ASMSKIP:
		{
			r=asm_rule_skip();
			break;
		}
		case CALL:
		{
			r=asm_rule_call();
			break;
		}
		case IF:
		{
			r=asm_rule_if();
			break;
		}
		case ASMLET:
		{
			r=asm_rule_let();
			break;
		}
		case ASMFORALL:
		{
			r=asm_rule_forall();
			break;
		}
		case ASMTRY:
		{
			r=asm_rule_try();
			break;
		}
		case LBRACE:
		{
			r=asm_rule_subst();
			break;
		}
		case AT:
		{
			r=asm_rule_meta();
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			r=asm_rule();
			match(RPAREN);
			break;
		}
		default:
			if ((LA(1)==PLUS||LA(1)==IDENT) && (LA(2)==ASSIGN||LA(2)==LPAREN)) {
				r=asm_rule_assign();
			}
			else if ((LA(1)==PLUS||LA(1)==IDENT) && (_tokenSet_3.member(LA(2)))) {
				id=ident();
				
				r = af.createAsmSchemaVariable(id.getLocation(), id);
				
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return r;
	}
	
	protected final AstAsmRule  asm_rule_skip() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  skip = null;
		
		skip = LT(1);
		match(ASMSKIP);
		
		r = af.createAsmSkip(createLocation(skip));
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_assign() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		
		AstTerm t1, t2;
		
		
		t1=funcpredvarterm();
		match(ASSIGN);
		t2=term();
		
		r = af.createAsmAssign(t1.getLocation(), t1, t2);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_call() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		
		Identifier id;
		AstTerm[] l;
		
		
		match(CALL);
		id=ident();
		l=term_args();
		
		r = af.createAsmCall(id.getLocation(), id, l);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_if() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  if_ = null;
		
		AstTerm t;
		AstAsmRule r1, r2;
		
		
		if_ = LT(1);
		match(IF);
		t=formula();
		match(ASMTHEN);
		r1=asm_rule();
		match(ASMELSE);
		r2=asm_rule();
		match(ASMEND);
		
		r = af.createAsmIf(createLocation(if_), t, r1, r2);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_let() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  let = null;
		
		Identifier v;
		Identifier sort = null;
		AstTerm t;
		
		
		let = LT(1);
		match(ASMLET);
		v=ident();
		{
		switch ( LA(1)) {
		case COLON:
		{
			match(COLON);
			sort=ident();
			break;
		}
		case EQUALS:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(EQUALS);
		t=funcpredvarterm();
		match(ASMIN);
		r=asm_rule();
		match(ASMEND);
		
		r = af.createAsmLet(createLocation(let), v, sort, t, r);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_forall() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  forall = null;
		
		Identifier v;
		Identifier sort = null;
		AstTerm t;
		
		
		forall = LT(1);
		match(ASMFORALL);
		v=ident();
		{
		switch ( LA(1)) {
		case COLON:
		{
			match(COLON);
			sort=ident();
			break;
		}
		case ASMWITH:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(ASMWITH);
		t=formula();
		match(ASMDO);
		r=asm_rule();
		match(ASMEND);
		
		r = af.createAsmForall(createLocation(forall), v, sort, t, r);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_try() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  try_ = null;
		
		AstAsmRule r1, r2;
		
		
		try_ = LT(1);
		match(ASMTRY);
		r1=asm_rule();
		match(ASMELSE);
		r2=asm_rule();
		match(ASMEND);
		
		r = af.createAsmTry(createLocation(try_), r1, r2);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_subst() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  lbrace = null;
		
		Identifier var;
		Identifier sort = null;
		AstTerm t;
		
		
		lbrace = LT(1);
		match(LBRACE);
		var=ident();
		{
		switch ( LA(1)) {
		case COLON:
		{
			match(COLON);
			sort=ident();
			break;
		}
		case FORALL:
		case EXISTS:
		case TRUE:
		case FALSE:
		case NOT:
		case ASMDEF:
		case ASMUPD:
		case ASMCON:
		case ASMINV:
		case ASMEQUI:
		case ASMEQUIS:
		case ASMJOINABLE:
		case LPAREN:
		case LBRACE:
		case LBRACK:
		case AT:
		case LT:
		case PLUS:
		case IDENT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		t=term();
		match(RBRACE);
		r=asm_rule_atom();
		
		r = af.createAsmSubstitution(createLocation(lbrace), var, sort, t, r);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_meta() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  at = null;
		
		Identifier id;
		
		
		at = LT(1);
		match(AT);
		id=ident();
		match(LPAREN);
		r=asm_rule();
		match(RPAREN);
		
		r = af.createAsmRuleMeta(createLocation(at), id, r);
		
		return r;
	}
	
	protected final AstParameter  param() throws RecognitionException, TokenStreamException {
		AstParameter p;
		
		
		Identifier id;
		Identifier sort;
		
		
		id=ident();
		match(COLON);
		sort=ident();
		
		p = new AstParameter(id.getLocation(), id, sort);
		
		return p;
	}
	
	protected final AstProofExpression  proof_expr() throws RecognitionException, TokenStreamException {
		AstProofExpression pe = null;
		
		Token  paren = null;
		Token  str = null;
		
		AstProofExpression child;
		AstProofExpressionType type;
		List list = createList();
		String id = null;
		
		
		paren = LT(1);
		match(LPAREN);
		{
		switch ( LA(1)) {
		case TERM:
		case BRANCH:
		case INST:
		case IFSEQFORMULA:
		case INTERACTIVE:
		case HEUR:
		case FORMULA:
		case RULE:
		case IDENT:
		{
			type=proof_expr_type();
			{
			switch ( LA(1)) {
			case STRING_LITERAL:
			{
				str = LT(1);
				match(STRING_LITERAL);
				
				id = str.getText();
				
				break;
			}
			case LPAREN:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			_loop152:
			do {
				if ((LA(1)==LPAREN)) {
					child=proof_expr();
					
					list.add(child);
					
				}
				else {
					break _loop152;
				}
				
			} while (true);
			}
			
			AstProofExpression[] children = (AstProofExpression[]) list.toArray(new AstProofExpression[list.size()]);
			pe = new AstProofExpression(createLocation(paren), type, id, children);
			
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(RPAREN);
		return pe;
	}
	
	protected final AstProofExpressionType  proof_expr_type() throws RecognitionException, TokenStreamException {
		AstProofExpressionType type;
		
		
		{
		switch ( LA(1)) {
		case FORMULA:
		{
			match(FORMULA);
			
			type = AstProofExpressionType.FORMULA;
			
			break;
		}
		case TERM:
		{
			match(TERM);
			
			type = AstProofExpressionType.TERM;
			
			break;
		}
		case RULE:
		{
			match(RULE);
			
			type = AstProofExpressionType.RULE;
			
			break;
		}
		case BRANCH:
		{
			match(BRANCH);
			
			type = AstProofExpressionType.BRANCH;
			
			break;
		}
		case INST:
		{
			match(INST);
			
			type = AstProofExpressionType.INST;
			
			break;
		}
		case IFSEQFORMULA:
		{
			match(IFSEQFORMULA);
			
			type = AstProofExpressionType.IFSEQFORMULA;
			
			break;
		}
		case INTERACTIVE:
		{
			match(INTERACTIVE);
			
			type = AstProofExpressionType.INTERACTIVE;
			
			break;
		}
		case HEUR:
		{
			match(HEUR);
			
			type = AstProofExpressionType.HEURISTICS;
			
			break;
		}
		case IDENT:
		{
			match(IDENT);
			
			type = AstProofExpressionType.IDENT;
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return type;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"all\"",
		"\"ex\"",
		"\"true\"",
		"\"false\"",
		"\"find\"",
		"\"if\"",
		"\"close\"",
		"\"goal\"",
		"\"replacewith\"",
		"\"addrules\"",
		"\"add\"",
		"\"varcond\"",
		"\"cond\"",
		"\"typeof\"",
		"\"new\"",
		"\"op\"",
		"\"not\"",
		"\"free\"",
		"\"pure\"",
		"\"depending\"",
		"\"on\"",
		"\"noninteractive\"",
		"\"recursive\"",
		"\"displayname\"",
		"\"helptext\"",
		"\"proof\"",
		"\"term\"",
		"\"branch\"",
		"\"inst\"",
		"\"ifseqformula\"",
		"\"interactive\"",
		"\"heur\"",
		"\"problem\"",
		"\"procedures\"",
		"\"call\"",
		"\"is\"",
		"\"sorts\"",
		"\"schema\"",
		"\"variables\"",
		"\"consts\"",
		"\"predicates\"",
		"\"functions\"",
		"\"formula\"",
		"\"rules\"",
		"\"heuristics\"",
		"\"rule\"",
		"\"asm\"",
		"\"dynamic\"",
		"\"static\"",
		"\"staticargs\"",
		"\"def\"",
		"\"upd\"",
		"\"Con\"",
		"\"inv\"",
		"\"skip\"",
		"\"equi\"",
		"\"equiS\"",
		"\"then\"",
		"\"else\"",
		"\"end\"",
		"\"in\"",
		"\"let\"",
		"\"forall\"",
		"\"with\"",
		"\"do\"",
		"\"try\"",
		"\"joinable\"",
		"\"and\"",
		"SEMI",
		"COLON",
		"ASSIGN",
		"DOT",
		"COMMA",
		"LPAREN",
		"RPAREN",
		"LBRACE",
		"RBRACE",
		"LBRACK",
		"RBRACK",
		"AT",
		"OR",
		"AND",
		"IMP",
		"EQV",
		"EQUALS",
		"NOTEQUALS",
		"LT",
		"GT",
		"SEQARROW",
		"PLUS",
		"MINUS",
		"ASTERIX",
		"SLASH",
		"UPDATE",
		"a digit",
		"a letter",
		"an admissible character for identifiers",
		"an identifer",
		"white space",
		"a comment",
		"a comment",
		"a string in double quotes",
		"ESC"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 478424997036032L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 281475480027136L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 1196268651020288L, 137975824384L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { -4611686018427387902L, 134566272L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	
	}
