// $ANTLR 2.7.2: "expandedtaclets.g" -> "TacletParser.java"$


    package de.uka.ilkd.key.parser;

    import java.io.*;
    import antlr.*;
    import de.uka.ilkd.key.parser.*;
    import de.uka.ilkd.key.logic.*;
    import de.uka.ilkd.key.logic.sort.*;    
    import de.uka.ilkd.key.logic.op.*;
    import de.uka.ilkd.key.rule.metaconstruct.*;
    import de.uka.ilkd.key.rule.*;

    import de.uka.ilkd.key.java.SchemaJavaReader;
    import java.util.Vector;
    import java.util.HashMap;
    import java.util.HashSet;
    import java.util.Iterator;
    import de.uka.ilkd.key.java.visitor.ProgramVariableCollector;
    import de.uka.ilkd.key.java.JavaInfo;
    import de.uka.ilkd.key.proof.UseInsteadMap;
    import de.uka.ilkd.key.java.Services;
    import de.uka.ilkd.key.gui.AbbrevMap;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class TacletParser extends antlr.LLkParser       implements TacletParserTokenTypes
 {

    static final Sort[] AN_ARRAY_OF_SORTS = new Sort[0];
    static final Term[] AN_ARRAY_OF_TERMS = new Term[0];
    protected boolean minus=false;
    protected Namespace var_ns;
    protected Namespace func_ns;
    protected Namespace sort_ns;
    protected Namespace heur_ns;
    protected JavaInfo javaInfo;  
    protected AbbrevMap scm = new AbbrevMap();

    // these variables are set if a file is read in step by
    // step. This used when reading in LDTs because of cyclic
    // dependencies.
    protected boolean skip_functions;
    protected boolean skip_predicates;
    protected boolean skip_sorts;
    protected boolean skip_schemavariables;
    protected boolean skip_heuristics;
    protected UseInsteadMap useInstead=new UseInsteadMap();

    protected TermFactory tf;
    protected SchemaJavaReader javaReader;
    boolean schematicJava;	

    public boolean errors = false;

    public TacletParser(TokenStream lexer,
		      String filename,
		      TermFactory tf,
		      SchemaJavaReader jr,
		      Namespace var_ns,
		      Namespace func_ns,
		      Namespace sort_ns,
		      Namespace heur_ns) {
	this(lexer,2);
	setFilename(filename);
	this.tf = tf;
	this.javaReader = jr;
	this.var_ns  = var_ns;
	this.func_ns = func_ns;
	this.sort_ns = sort_ns;
	this.heur_ns = heur_ns;
	schematicJava=true;	
    }

    public TacletParser(TokenStream lexer,
		      String filename,
		      SchemaJavaReader jr,
		      Namespace var_ns,
		      Namespace func_ns,
		      Namespace sort_ns,
		      Namespace heur_ns) {
	this(lexer, filename, TermFactory.DEFAULT, 
	     jr, var_ns, func_ns, sort_ns, heur_ns);
    }


    public TacletParser(TokenStream lexer,
		      String filename,
		      TermFactory tf,
		      JavaInfo javaInfo,
		      Namespace var_ns,
		      Namespace func_ns,
		      Namespace sort_ns,
		      Namespace heur_ns) {
	this(lexer, filename, tf, 
	     new de.uka.ilkd.key.java.SchemaRecoder2KeY(javaInfo.rec2key(),
						javaInfo.getTypeConverter(),
						new NamespaceSet(var_ns, func_ns, 
							sort_ns, heur_ns)), 	     
	     var_ns, func_ns, sort_ns,heur_ns);
    }

    public TacletParser(TokenStream lexer,
		      String filename,
	              JavaInfo javaInfo,
		      Namespace var_ns,
		      Namespace func_ns,
		      Namespace sort_ns,
		      Namespace heur_ns) {
	this(lexer, filename,TermFactory.DEFAULT,
	     new de.uka.ilkd.key.java.SchemaRecoder2KeY(javaInfo.rec2key(),
						javaInfo.getTypeConverter(),
						new NamespaceSet(var_ns, func_ns, 
							sort_ns, heur_ns)),
	     var_ns, func_ns, sort_ns, heur_ns);
    }


    private TacletBuilder createTacletBuilderFor
                (Object find, boolean sameUpdatePrefix) 
	throws InvalidFindException {
        if ( sameUpdatePrefix && !( find instanceof Term ) )
		throw new InvalidFindException
		    ("\"sameUpdateLevel\" may only be used for rewrite taclets:"+find,
		     getFilename(), getLine(), getColumn());
	if ( find == null ) {
	    return new NoFindTacletBuilder();
        } else if ( find instanceof Term ) {
	    return new RewriteTacletBuilder().setFind((Term)find)
	                     .setSameUpdatePrefix(sameUpdatePrefix);
        } else if ( find instanceof Sequent ) {
	    Sequent findSeq = (Sequent) find;
	    if ( findSeq == Sequent.EMPTY_SEQUENT ) {
		return new NoFindTacletBuilder();
	    } else if (   findSeq.antecedent().size() == 1
			  && findSeq.succedent().size() == 0 ) {
		Term findFma = findSeq.antecedent().get(0).formula();
		return new AntecTacletBuilder().setFind(findFma);
	    } else if (   findSeq.antecedent().size() == 0
			  && findSeq.succedent().size() == 1 ) {
		Term findFma = findSeq.succedent().get(0).formula();
		return new SuccTacletBuilder().setFind(findFma);
	    } else {
		throw new InvalidFindException
		    ("Unknown find-sequent (perhaps null?):"+findSeq,
		     getFilename(), getLine(), getColumn());
	    }
        } else {
	    throw new RuntimeException("createTacletBuilderFor called with"
				       + find.getClass().getName() + "object");
        }
    }	    

	protected static HashSet progVars(JavaBlock jb) {
		ProgramVariableCollector pvc
			= new ProgramVariableCollector(jb.program());
		pvc.start();
		return pvc.result();
	}


	protected void bindProgVars(HashSet progVars) {
		var_ns=new Namespace(var_ns);
		Iterator it=progVars.iterator();
		while (it.hasNext()) {
			var_ns.add((ProgramVariable)it.next());
		}
	}

	protected void unbindProgVars() {
		var_ns = var_ns.parent();
	}

    protected boolean isNumber(String s){
	      boolean num=true;
          if(s==null){
            num=false;
          }else{
	        for(int i=s.length()-1;i>=0;i--){
		     if(s.charAt(i)<'0'||s.charAt(i)>'9')
			    num=false;
	        }
         }
	     return num;
    }

    
    public Term toZNotation(String s, boolean minus){
	Term[] t1=new Term[1];
	Operator v;
	Term a;
	v=(Function) func_ns.lookup(new Name("#"));
	t1[0] = tf.createFunctionTerm((Function)v);
	v = (Function) func_ns.lookup(new Name(s.substring(0,1)));
	a = tf.createFunctionTerm((Function)v,t1);
	for(int i=1;i<s.length();i++){
		t1[0]=a;
		v = (Function)func_ns.lookup(new Name(s.substring(i,i+1)));
		a = tf.createFunctionTerm((Function)v,t1);
	}
	if(minus){
		t1[0]=a;
		v = (Function) func_ns.lookup(new Name("neg"));
		a = tf.createFunctionTerm((Function)v,t1);
	}
	t1[0]=a;
	v = (Function) func_ns.lookup(new Name("Z"));
	a = tf.createFunctionTerm((Function)v,t1);
	return a;
    }



    private static ListOfRulevariable NO_RULE_VARIABLES =
	SLListOfRulevariable.EMPTY_LIST;

    private void addGoalTemplate(TacletBuilder b,
                                 String id,
				 Object rwObj,
				 Sequent addSeq,
				 ListOfTaclet addRList,
				 SetOfSchemaVariable pvs) 
	throws SemanticException
	{
	    TacletGoalTemplate gt = null;
	    if ( rwObj == null ) {
		// there is no replacewith, so we take
		gt = new TacletGoalTemplate(addSeq,
					  addRList,
					  NO_RULE_VARIABLES,
					  pvs);
	    } else {
		if ( b instanceof NoFindTacletBuilder ) {
		    // there is a replacewith without a find.
		    throw 
			new UnfittingReplacewithException
			("Replacewith without find", getFilename(),
			 getLine(), getColumn());
		} else if ( b instanceof SuccTacletBuilder
			    || b instanceof AntecTacletBuilder ) {
		    if ( rwObj instanceof Sequent ) {
			gt = new AntecSuccTacletGoalTemplate(addSeq,
							   addRList,
							   NO_RULE_VARIABLES,
							   (Sequent)rwObj,
							   pvs);  
		    } else {
			throw new UnfittingReplacewithException
			    ("Replacewith in a Antec-or SuccTaclet has "+
			     "to contain a sequent (not a term)", 
			     getFilename(), getLine(), getColumn());
		    }
		} else if ( b instanceof RewriteTacletBuilder ) {
		    if ( rwObj instanceof Term ) {
			gt = new RewriteTacletGoalTemplate(addSeq,
							 addRList,
							 NO_RULE_VARIABLES,
							 (Term)rwObj,
							 pvs);  
		    } else {
			throw new UnfittingReplacewithException
			    ("Replacewith in a RewriteTaclet has "+
			     "to contain a term (not a sequent)", 
			     getFilename(), getLine(), getColumn());
		    }
		}
	    }
            gt.setName(id); 
	    b.addTacletGoalTemplate(gt);
	}
						


    protected int getLine() {
	int line = -1;
	try {
	    line = LT(0).getLine();
	} 
	catch (TokenStreamException e) {
	    System.err.println("No further token in stream");
	}
	return line;
    }   

    protected int getColumn() {
	int col = -1;
	try {
	    col = LT(0).getColumn();
	} 
	catch (TokenStreamException e) {
	    System.err.println("No further token in stream");
	}
	return col;
    }   


    protected Term termForParsedVariable(ParsableVariable v) 
	throws antlr.SemanticException 
	{
		if ( v instanceof LogicVariable ) {
			return tf.createVariableTerm((LogicVariable)v);
		} else if ( v instanceof SchemaVariable ) {
			return tf.createVariableTerm((SchemaVariable)v);
		} else if ( v instanceof ProgramVariable ) {
			return tf.createVariableTerm((ProgramVariable)v);
//		} else if ( v instanceof ParsableVariable ) {
//			return tf.createVariableTerm((ParsableVariable)v);

		} else {
			throw new antlr.SemanticException
			    (""+ v +" is not a logic or schema or program variable");
		}
	}

    protected TermSymbol progVar(Token id,Sort s) throws NotDeclException{
	TermSymbol v = (TermSymbol)
	    var_ns.lookup(new Name(id.getText()));

	if (v == null) {
		throw new NotDeclException("program variable", id,
						getFilename());
	}
	return v;
    }

    protected LogicVariable bindVar(Token id,Sort s) {
	LogicVariable v=new LogicVariable(new Name(id.getText()), s);
	var_ns=var_ns.extended(v);
	return v;
    }
	
    protected void unbindVars() {
	var_ns = var_ns.parent();
    }

    protected JavaBlock getJavaBlock(Token t) throws antlr.SemanticException {
	String s=t.getText();
	if (!schematicJava) {
		try {
			return javaReader.readBlockWithProgramVariables(var_ns, s);
		} catch (Exception e) {
			if (s.length()>10) {
				s=s.substring(0,10)+"...";
			}
			throw new antlr.SemanticException("Reading Java block "
				+ s + " failed. "
				+e.getMessage());	
		}
	}
	javaReader.setSVNamespace(var_ns);
	return javaReader.readBlockWithEmptyContext(s);
    }

    /** returns the java information object */
    public JavaInfo getJavaInfo() {
	if (javaInfo==null) {
           javaInfo=javaReader.createJavaInfo(new Services());
        }
	return javaInfo;
    }

protected TacletParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public TacletParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected TacletParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public TacletParser(TokenStream lexer) {
  this(lexer,2);
}

public TacletParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final void top() throws RecognitionException, TokenStreamException {
		
		Taclet r;
		
		r=taclet();
	}
	
	public final Taclet  taclet() throws RecognitionException, TokenStreamException {
		Taclet r;
		
		Token  name = null;
		
			Sequent ifSeq = Sequent.EMPTY_SEQUENT;
			Object  find = null;
			r = null;
			TacletBuilder b = null;
		boolean sameUpdatePrefix = false;
		
		
		name = LT(1);
		match(IDENT);
		match(LBRACE);
		{
		switch ( LA(1)) {
		case IF:
		{
			match(IF);
			match(LPAREN);
			ifSeq=seq();
			match(RPAREN);
			break;
		}
		case FIND:
		case VARCOND:
		case CLOSE:
		case REPLACEWITH:
		case ADD:
		case ADDRULES:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case FIND:
		{
			match(FIND);
			match(LPAREN);
			find=termorseq();
			match(RPAREN);
			{
			switch ( LA(1)) {
			case SAME_UPDATE_LEVEL:
			{
				match(SAME_UPDATE_LEVEL);
				if ( inputState.guessing==0 ) {
					sameUpdatePrefix = true;
				}
				break;
			}
			case VARCOND:
			case CLOSE:
			case REPLACEWITH:
			case ADD:
			case ADDRULES:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case VARCOND:
		case CLOSE:
		case REPLACEWITH:
		case ADD:
		case ADDRULES:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
						b = createTacletBuilderFor(find, sameUpdatePrefix);
						b.setName(new Name(name.getText()));
						b.setIfSequent(ifSeq);
					
		}
		{
		switch ( LA(1)) {
		case VARCOND:
		{
			match(VARCOND);
			match(LPAREN);
			varexplist(b);
			match(RPAREN);
			break;
		}
		case CLOSE:
		case REPLACEWITH:
		case ADD:
		case ADDRULES:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		goalspecs(b);
		modifiers(b);
		match(RBRACE);
		if ( inputState.guessing==0 ) {
			r = b.getTaclet();
		}
		return r;
	}
	
	public final Sequent  seq() throws RecognitionException, TokenStreamException {
		Sequent s;
		
		Semisequent ant,suc; s = null;
		
		ant=semisequent();
		match(SEQARROW);
		suc=semisequent();
		if ( inputState.guessing==0 ) {
			s = Sequent.createSequent(ant, suc);
		}
		return s;
	}
	
	public final Object  termorseq() throws RecognitionException, TokenStreamException {
		Object o;
		
		
			Term head = null;
			Sequent s = null;
			Semisequent ss = null;
			o = null; 
		
		
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		case TRUE:
		case FALSE:
		case NOT:
		case IN_TYPE:
		case IS_OBJECT:
		case IS_CLONABLE:
		case META_IN_LONG:
		case META_IN_INT:
		case META_IN_CHAR:
		case META_IN_SHORT:
		case META_IN_BYTE:
		case META_ADD:
		case META_SUB:
		case META_MUL:
		case META_DIV:
		case META_MOD:
		case META_LESS:
		case META_GREATER:
		case META_LEQ:
		case META_GEQ:
		case META_EQ:
		case META_INT_UNARY_MINUS:
		case META_INT_ADD:
		case META_INT_SUB:
		case META_INT_MUL:
		case META_INT_DIV:
		case META_INT_MOD:
		case META_INT_AND:
		case META_INT_OR:
		case META_INT_XOR:
		case META_INT_COMPLEMENT:
		case META_INT_SHIFTRIGHT:
		case META_INT_SHIFTLEFT:
		case META_INT_UNSIGNEDSHIFTRIGHT:
		case META_LONG_UNARY_MINUS:
		case META_LONG_ADD:
		case META_LONG_SUB:
		case META_LONG_MUL:
		case META_LONG_DIV:
		case META_LONG_MOD:
		case META_LONG_AND:
		case META_LONG_OR:
		case META_LONG_XOR:
		case META_LONG_COMPLEMENT:
		case META_LONG_SHIFTRIGHT:
		case META_LONG_SHIFTLEFT:
		case META_LONG_UNSIGNEDSHIFTRIGHT:
		case META_MODULO_BYTE:
		case META_MODULO_SHORT:
		case META_MODULO_INTEGER:
		case META_MODULO_LONG:
		case STATIC_ANALYSIS:
		case META_LENGTH:
		case LPAREN:
		case LBRACE:
		case AT:
		case CTRL:
		case ARITH_OP:
		case CHAR_LITERAL:
		case DIAMOND:
		case BOX:
		case IDENT:
		{
			head=term();
			{
			switch ( LA(1)) {
			case COMMA:
			{
				match(COMMA);
				s=seq();
				break;
			}
			case SEQARROW:
			{
				match(SEQARROW);
				ss=semisequent();
				break;
			}
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
							if ( s == null ) {
								if ( ss == null ) {
									// Just a term
									o = head;
								} else {
									// A sequent with only head in the antecedent.
									Semisequent ant = Semisequent.EMPTY_SEMISEQUENT;
									ant = ant.insertFirst(
										new ConstrainedFormula(head, Constraint.BOTTOM)).semisequent();
									o = Sequent.createSequent(ant,ss);
								}
							} else {
								// A sequent.  Prepend head to the antecedent.
								Semisequent newAnt = s.antecedent();
								newAnt = newAnt .insertFirst(
									new ConstrainedFormula(head, Constraint.BOTTOM)).semisequent();
								o = Sequent.createSequent(newAnt,s.succedent());
							}
						
			}
			break;
		}
		case SEQARROW:
		{
			match(SEQARROW);
			ss=semisequent();
			if ( inputState.guessing==0 ) {
				
							o = Sequent.createSequent(Semisequent.EMPTY_SEMISEQUENT,ss);
						
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return o;
	}
	
	public final void varexplist(
		TacletBuilder b
	) throws RecognitionException, TokenStreamException {
		
		
		varexp(b);
		{
		_loop17:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				varexp(b);
			}
			else {
				break _loop17;
			}
			
		} while (true);
		}
	}
	
	public final void goalspecs(
		TacletBuilder b
	) throws RecognitionException, TokenStreamException {
		
		
		switch ( LA(1)) {
		case CLOSE:
		{
			match(CLOSE);
			match(GOAL);
			break;
		}
		case REPLACEWITH:
		case ADD:
		case ADDRULES:
		{
			goalspec(b);
			{
			_loop27:
			do {
				if ((LA(1)==SEMI)) {
					match(SEMI);
					goalspec(b);
				}
				else {
					break _loop27;
				}
				
			} while (true);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
	}
	
	public final void modifiers(
		TacletBuilder b
	) throws RecognitionException, TokenStreamException {
		
		Token  dname = null;
		Token  htext = null;
		
		{
		_loop9:
		do {
			switch ( LA(1)) {
			case HEURISTICS:
			{
				heuristics(b);
				break;
			}
			case NONINTERACTIVE:
			{
				match(NONINTERACTIVE);
				if ( inputState.guessing==0 ) {
					
					//      b.setNoninteractive(true);  
					// "noninteractive" (as it is now) is confusing
					// dropped this completely until a better solution (->Uwe)
					
				}
				break;
			}
			case RECURSIVE:
			{
				match(RECURSIVE);
				if ( inputState.guessing==0 ) {
					b.setRecursive(true);
				}
				break;
			}
			case DISPLAYNAME:
			{
				match(DISPLAYNAME);
				dname = LT(1);
				match(STRING_LITERAL);
				if ( inputState.guessing==0 ) {
					b.setDisplayName(dname.getText());
				}
				break;
			}
			case HELPTEXT:
			{
				match(HELPTEXT);
				htext = LT(1);
				match(STRING_LITERAL);
				if ( inputState.guessing==0 ) {
					b.setHelpText(htext.getText());
				}
				break;
			}
			default:
			{
				break _loop9;
			}
			}
		} while (true);
		}
	}
	
	public final void heuristics(
		TacletBuilder b
	) throws RecognitionException, TokenStreamException {
		
		
		match(HEURISTICS);
		match(LPAREN);
		heuristic(b);
		{
		_loop47:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				heuristic(b);
			}
			else {
				break _loop47;
			}
			
		} while (true);
		}
		match(RPAREN);
	}
	
	public final Semisequent  semisequent() throws RecognitionException, TokenStreamException {
		Semisequent ss;
		
		
			Term head = null;
			ss = Semisequent.EMPTY_SEMISEQUENT; 
		
		
		switch ( LA(1)) {
		case RPAREN:
		case SEQARROW:
		{
			break;
		}
		case FORALL:
		case EXISTS:
		case TRUE:
		case FALSE:
		case NOT:
		case IN_TYPE:
		case IS_OBJECT:
		case IS_CLONABLE:
		case META_IN_LONG:
		case META_IN_INT:
		case META_IN_CHAR:
		case META_IN_SHORT:
		case META_IN_BYTE:
		case META_ADD:
		case META_SUB:
		case META_MUL:
		case META_DIV:
		case META_MOD:
		case META_LESS:
		case META_GREATER:
		case META_LEQ:
		case META_GEQ:
		case META_EQ:
		case META_INT_UNARY_MINUS:
		case META_INT_ADD:
		case META_INT_SUB:
		case META_INT_MUL:
		case META_INT_DIV:
		case META_INT_MOD:
		case META_INT_AND:
		case META_INT_OR:
		case META_INT_XOR:
		case META_INT_COMPLEMENT:
		case META_INT_SHIFTRIGHT:
		case META_INT_SHIFTLEFT:
		case META_INT_UNSIGNEDSHIFTRIGHT:
		case META_LONG_UNARY_MINUS:
		case META_LONG_ADD:
		case META_LONG_SUB:
		case META_LONG_MUL:
		case META_LONG_DIV:
		case META_LONG_MOD:
		case META_LONG_AND:
		case META_LONG_OR:
		case META_LONG_XOR:
		case META_LONG_COMPLEMENT:
		case META_LONG_SHIFTRIGHT:
		case META_LONG_SHIFTLEFT:
		case META_LONG_UNSIGNEDSHIFTRIGHT:
		case META_MODULO_BYTE:
		case META_MODULO_SHORT:
		case META_MODULO_INTEGER:
		case META_MODULO_LONG:
		case STATIC_ANALYSIS:
		case META_LENGTH:
		case LPAREN:
		case LBRACE:
		case AT:
		case CTRL:
		case ARITH_OP:
		case CHAR_LITERAL:
		case DIAMOND:
		case BOX:
		case IDENT:
		{
			head=term();
			{
			switch ( LA(1)) {
			case COMMA:
			{
				match(COMMA);
				ss=semisequent();
				break;
			}
			case RPAREN:
			case SEQARROW:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				ss = ss.insertFirst(new ConstrainedFormula(head, Constraint.BOTTOM)).semisequent();
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return ss;
	}
	
	public final Term  term() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		a=term20();
		return a;
	}
	
	public final void varexp(
		TacletBuilder b
	) throws RecognitionException, TokenStreamException {
		
		
			ParsableVariable x;
			ParsableVariable y;
			Sort s = null;
		
		
		{
		switch ( LA(1)) {
		case TYPEOF:
		{
			{
			match(TYPEOF);
			match(LPAREN);
			y=var_id();
			match(RPAREN);
			x=var_id();
			match(NEW);
			}
			if ( inputState.guessing==0 ) {
				b.addVarsNew((SchemaVariable) x, (SchemaVariable) y, false);
			}
			break;
		}
		case LITERAL_elemtypeof:
		{
			{
			match(LITERAL_elemtypeof);
			match(LPAREN);
			y=var_id();
			match(RPAREN);
			x=var_id();
			match(NEW);
			}
			if ( inputState.guessing==0 ) {
				b.addVarsNew((SchemaVariable) x, (SchemaVariable) y, true);
			}
			break;
		}
		default:
			if ((LA(1)==IDENT) && (LA(2)==LBRACKET||LA(2)==IDENT)) {
				{
				s=sort_id_check(true);
				x=var_id();
				match(NEW);
				}
				if ( inputState.guessing==0 ) {
					b.addVarsNew((SchemaVariable) x, s);
				}
			}
			else if ((LA(1)==IDENT) && (LA(2)==NOT)) {
				{
				x=var_id();
				match(NOT);
				match(FREE);
				match(IN);
				y=var_id();
				}
				if ( inputState.guessing==0 ) {
					b.addVarsNotFreeIn((SchemaVariable)x,(SchemaVariable)y);
				}
			}
			else if ((LA(1)==IDENT) && (LA(2)==NEW)) {
				{
				x=var_id();
				match(NEW);
				match(DEPENDING);
				match(ON);
				y=var_id();
				}
				if ( inputState.guessing==0 ) {
					b.addVarsNewDependingOn((SchemaVariable)x,(SchemaVariable)y);
				}
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
	}
	
	public final ParsableVariable  var_id() throws RecognitionException, TokenStreamException {
		ParsableVariable v = null;
		
		Token  id = null;
		
		id = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			
						v = (ParsableVariable) var_ns.lookup(new Name(id.getText()));
						if (v == null) {
							throw new NotDeclException("variable", id, 
										   getFilename());
						}
					
		}
		return v;
	}
	
	public final Sort  sort_id_check(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		Sort t;
		
		
		t=sort_id_check_help(checkSort);
		s=array_decls(t);
		return s;
	}
	
	public final void goalspec(
		TacletBuilder b
	) throws RecognitionException, TokenStreamException {
		
		Token  id = null;
		
			Object rwObj = null;
			Sequent addSeq = Sequent.EMPTY_SEQUENT;
			ListOfTaclet addRList = SLListOfTaclet.EMPTY_LIST;
			SetOfSchemaVariable addpv = SetAsListOfSchemaVariable.EMPTY_SET;
		String name = null;
		
		
		{
		switch ( LA(1)) {
		case REPLACEWITH:
		{
			{
			match(REPLACEWITH);
			{
			switch ( LA(1)) {
			case STRING_LITERAL:
			{
				id = LT(1);
				match(STRING_LITERAL);
				if ( inputState.guessing==0 ) {
					name = id.getText();
				}
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			rwObj=termorseq();
			match(RPAREN);
			{
			switch ( LA(1)) {
			case ADD:
			{
				addSeq=add();
				break;
			}
			case NONINTERACTIVE:
			case RECURSIVE:
			case DISPLAYNAME:
			case HELPTEXT:
			case ADDRULES:
			case ADDPROGVARS:
			case HEURISTICS:
			case SEMI:
			case RBRACE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case ADDRULES:
			{
				addRList=addrules();
				break;
			}
			case NONINTERACTIVE:
			case RECURSIVE:
			case DISPLAYNAME:
			case HELPTEXT:
			case ADDPROGVARS:
			case HEURISTICS:
			case SEMI:
			case RBRACE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case ADDPROGVARS:
			{
				addpv=addprogvar();
				break;
			}
			case NONINTERACTIVE:
			case RECURSIVE:
			case DISPLAYNAME:
			case HELPTEXT:
			case HEURISTICS:
			case SEMI:
			case RBRACE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			}
			break;
		}
		case ADD:
		{
			{
			addSeq=add();
			{
			switch ( LA(1)) {
			case ADDRULES:
			{
				addRList=addrules();
				break;
			}
			case NONINTERACTIVE:
			case RECURSIVE:
			case DISPLAYNAME:
			case HELPTEXT:
			case HEURISTICS:
			case SEMI:
			case RBRACE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			}
			break;
		}
		case ADDRULES:
		{
			{
			addRList=addrules();
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
						addGoalTemplate(b,name,rwObj,addSeq,addRList,addpv);
					
		}
	}
	
	public final Sequent  add() throws RecognitionException, TokenStreamException {
		Sequent s;
		
		s = null;
		
		match(ADD);
		match(LPAREN);
		s=seq();
		match(RPAREN);
		return s;
	}
	
	public final ListOfTaclet  addrules() throws RecognitionException, TokenStreamException {
		ListOfTaclet lor;
		
		lor = null;
		
		match(ADDRULES);
		match(LPAREN);
		lor=tacletlist();
		match(RPAREN);
		return lor;
	}
	
	public final SetOfSchemaVariable  addprogvar() throws RecognitionException, TokenStreamException {
		SetOfSchemaVariable pvs;
		
		pvs = null;
		
		match(ADDPROGVARS);
		match(LPAREN);
		pvs=pvset();
		match(RPAREN);
		return pvs;
	}
	
	public final ListOfTaclet  tacletlist() throws RecognitionException, TokenStreamException {
		ListOfTaclet lor;
		
		
			Taclet head = null;
			lor = SLListOfTaclet.EMPTY_LIST; 
		
		
		head=taclet();
		{
		switch ( LA(1)) {
		case RPAREN:
		{
			break;
		}
		case COMMA:
		{
			match(COMMA);
			lor=tacletlist();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			lor = lor.prepend(head);
		}
		return lor;
	}
	
	public final SetOfSchemaVariable  pvset() throws RecognitionException, TokenStreamException {
		SetOfSchemaVariable pvs;
		
		
		ParsableVariable pv = null;
			pvs = SetAsListOfSchemaVariable.EMPTY_SET;
		
		
		pv=var_id();
		{
		switch ( LA(1)) {
		case RPAREN:
		{
			break;
		}
		case COMMA:
		{
			match(COMMA);
			pvs=pvset();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			pvs = pvs.add
										((SchemaVariable)pv);
		}
		return pvs;
	}
	
	public final void heuristic(
		TacletBuilder b
	) throws RecognitionException, TokenStreamException {
		
		Token  id = null;
		
		id = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			
						Heuristic h = (Heuristic) heur_ns.lookup(new Name(id.getText()));
						if (h == null) {
							throw new NotDeclException("heuristic", id,
										   getFilename());
						}
						b.addHeuristic(h);
					
		}
	}
	
	public final Term  bindingterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		a=sv_or_local_bindingterm();
		return a;
	}
	
	public final Term  sv_or_local_bindingterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Token  v0 = null;
		
			Operator op = null;
			QuantifiableVariable v = null;
			TermSymbol ts = null;
			Term a1;
			Sort s = null;
			boolean bound = false;
		
		
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		{
			{
			{
			switch ( LA(1)) {
			case FORALL:
			{
				match(FORALL);
				if ( inputState.guessing==0 ) {
					op = Op.ALL;
				}
				break;
			}
			case EXISTS:
			{
				match(EXISTS);
				if ( inputState.guessing==0 ) {
					op = Op.EX;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			v0 = LT(1);
			match(IDENT);
			{
			switch ( LA(1)) {
			case COLON:
			{
				match(COLON);
				s=sort_id();
				if ( inputState.guessing==0 ) {
					
									v=bindVar(v0,s);
									bound = true;
								
				}
				break;
			}
			case DOT:
			{
				if ( inputState.guessing==0 ) {
					
									ts = (TermSymbol) var_ns.lookup(new Name(v0.getText()));	
									if (   ts == null
									    || ts instanceof LogicVariable ) {
										throw new SemanticException(
											"Quantified variables need a sort.");
									}
									if ( ! (ts instanceof SchemaVariable && 
										((SchemaVariable)ts).isVariableSV())) {
										throw new SemanticException(
											""+ts+" is not allowed in a quantifier.");
									}
									v = (SchemaVariable) ts;
									bound = false;
								
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(DOT);
			a1=term60();
			if ( inputState.guessing==0 ) {
				
							a = tf.createQuantifierTerm((Quantifier)op, v, a1);
							if (bound) {unbindVars();}
						
			}
			}
			break;
		}
		case LBRACE:
		{
			a=update_or_substitution();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return a;
	}
	
	public final Sort  sort_id() throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		s=sort_id_check(true);
		return s;
	}
	
	public final Term  term60() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		Term a1,a2;
			Sort s;
		
		
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		case LBRACE:
		{
			a=bindingterm();
			break;
		}
		case DIAMOND:
		case BOX:
		{
			a=dl_term();
			break;
		}
		case NOT:
		{
			match(NOT);
			a1=term60();
			if ( inputState.guessing==0 ) {
				a = tf.createJunctorTerm(Op.NOT,new Term[]{a1});
			}
			break;
		}
		case CTRL:
		{
			match(CTRL);
			a1=term60();
			if ( inputState.guessing==0 ) {
				a = tf.createJunctorTerm(Op.CTRL,new Term[]{a1});
			}
			break;
		}
		default:
			boolean synPredMatched97 = false;
			if (((LA(1)==LPAREN) && (_tokenSet_0.member(LA(2))))) {
				int _m97 = mark();
				synPredMatched97 = true;
				inputState.guessing++;
				try {
					{
					match(LPAREN);
					match(IDENT);
					{
					switch ( LA(1)) {
					case COMMA:
					{
						match(COMMA);
						match(IDENT);
						match(COLON);
						match(IDENT);
						break;
					}
					case GUARD:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					match(GUARD);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched97 = false;
				}
				rewind(_m97);
				inputState.guessing--;
			}
			if ( synPredMatched97 ) {
				a=condterm();
			}
			else if ((_tokenSet_0.member(LA(1))) && (_tokenSet_1.member(LA(2)))) {
				a=term70();
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return a;
	}
	
	public final Term  update_or_substitution() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		
		
		
		boolean synPredMatched56 = false;
		if (((LA(1)==LBRACE) && (_tokenSet_2.member(LA(2))))) {
			int _m56 = mark();
			synPredMatched56 = true;
			inputState.guessing++;
			try {
				{
				match(LBRACE);
				attrterm();
				match(ASSIGN);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched56 = false;
			}
			rewind(_m56);
			inputState.guessing--;
		}
		if ( synPredMatched56 ) {
			result=updateterm();
		}
		else {
			boolean synPredMatched60 = false;
			if (((LA(1)==LBRACE) && (_tokenSet_2.member(LA(2))))) {
				int _m60 = mark();
				synPredMatched60 = true;
				inputState.guessing++;
				try {
					{
					match(LBRACE);
					match(IDENT);
					{
					_loop59:
					do {
						if ((LA(1)==LBRACKET)) {
							match(LBRACKET);
							funcpredvarterm();
							match(RBRACKET);
						}
						else {
							break _loop59;
						}
						
					} while (true);
					}
					match(ASSIGN);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched60 = false;
				}
				rewind(_m60);
				inputState.guessing--;
			}
			if ( synPredMatched60 ) {
				result=updateterm();
			}
			else if ((LA(1)==LBRACE) && (LA(2)==IDENT)) {
				result=substitutionterm();
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			return result;
		}
		
	public final Term  attrterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
			Vector vec=new Vector();
			ParsableVariable v=null;
			Term t=null;
			ParsableVariable v0=null;
		Sort so=null;
		
		
		
		{
		t=funcpredvarterm();
		if ( inputState.guessing==0 ) {
				so=t.sort();
			
		}
		{
		int _cnt77=0;
		_loop77:
		do {
			if ((LA(1)==DOT)) {
				match(DOT);
				v=attrid(so);
				if ( inputState.guessing==0 ) {
					vec.add(v); if(v!=null) so=v.sort();
				}
			}
			else {
				if ( _cnt77>=1 ) { break _loop77; } else {throw new NoViableAltException(LT(1), getFilename());}
			}
			
			_cnt77++;
		} while (true);
		}
		}
		if ( inputState.guessing==0 ) {
			
				if (!schematicJava) {
					for (int i=0; i<vec.size(); i++) {
						if(vec.get(i)!=null){
			t=tf.createAttributeTerm((ProgramVariable)vec.get(i), t);
			}
					}
				} else {
			t=tf.createAttributeTerm((SchemaVariable)v,t);         
				}
				a=t;
			
		}
		return a;
	}
	
	public final Term  updateterm() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		Token  v0 = null;
		Token  v1 = null;
		Term a0 = null;
		Term a1, a2;
		Vector subs = new Vector();  
		Vector index = new Vector();
		TermSymbol pv,pv1;
		ArraySort as;
		int n=0;
		
		
		match(LBRACE);
		{
		boolean synPredMatched66 = false;
		if (((_tokenSet_2.member(LA(1))) && (_tokenSet_3.member(LA(2))))) {
			int _m66 = mark();
			synPredMatched66 = true;
			inputState.guessing++;
			try {
				{
				match(IDENT);
				{
				_loop65:
				do {
					if ((LA(1)==LBRACKET)) {
						match(LBRACKET);
						match(IDENT);
						match(RBRACKET);
					}
					else {
						break _loop65;
					}
					
				} while (true);
				}
				match(DOT);
				match(IDENT);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched66 = false;
			}
			rewind(_m66);
			inputState.guessing--;
		}
		if ( synPredMatched66 ) {
			a0=attrterm();
		}
		else if ((LA(1)==IDENT) && (LA(2)==ASSIGN||LA(2)==LBRACKET)) {
			v0 = LT(1);
			match(IDENT);
			{
			_loop68:
			do {
				if ((LA(1)==LBRACKET)) {
					match(LBRACKET);
					v1 = LT(1);
					match(IDENT);
					match(RBRACKET);
					if ( inputState.guessing==0 ) {
						pv1 = progVar(v1, (Sort) sort_ns.lookup(new Name("int")));
						index.add(tf.createFunctionTerm(pv1));n++;
					}
				}
				else {
					break _loop68;
				}
				
			} while (true);
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		match(ASSIGN);
		a1=term60();
		if ( inputState.guessing==0 ) {
			
			if(n>0){
			as=ArraySortImpl.getArraySort(a1.sort());
			for(int i=1;i<n;i++){
			as=ArraySortImpl.getArraySort(as);
			}
			pv = progVar(v0, as);
			a0 = tf.createFunctionTerm(pv);
			Term[] t1 = (Term[]) index.toArray(new Term[index.size()]);
			a0 = tf.createArrayTerm(Op.ARRAY,a0,t1);
			n=0;
							}else if (a0 == null) {
						     	pv = progVar(v0, a1.sort()); 
				 			    a0 = tf.createFunctionTerm(pv); 
			}
					  	   subs.add(a0); 
				  		   subs.add(a1); 
					
		}
		{
		_loop70:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				a0=term60();
				match(ASSIGN);
				a1=term60();
				if ( inputState.guessing==0 ) {
					
										    subs.add(a0); 
										    subs.add(a1);
										
				}
			}
			else {
				break _loop70;
			}
			
		} while (true);
		}
		match(RBRACE);
		a2=term60();
		if ( inputState.guessing==0 ) {
			subs.add(a2);
		}
		if ( inputState.guessing==0 ) {
			
				result = tf.createUpdateTerm((Term[])subs.toArray(new Term[subs.size()]));
				subs = new Vector();
			
		}
		return result;
	}
	
	public final Term  funcpredvarterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
			Operator vf;
			int n = 0;
			Vector al = null;
			Term t;
			Sort as=null;
		
		
		{
		switch ( LA(1)) {
		case IN_TYPE:
		case IS_OBJECT:
		case IS_CLONABLE:
		case META_IN_LONG:
		case META_IN_INT:
		case META_IN_CHAR:
		case META_IN_SHORT:
		case META_IN_BYTE:
		case META_ADD:
		case META_SUB:
		case META_MUL:
		case META_DIV:
		case META_MOD:
		case META_LESS:
		case META_GREATER:
		case META_LEQ:
		case META_GEQ:
		case META_EQ:
		case META_INT_UNARY_MINUS:
		case META_INT_ADD:
		case META_INT_SUB:
		case META_INT_MUL:
		case META_INT_DIV:
		case META_INT_MOD:
		case META_INT_AND:
		case META_INT_OR:
		case META_INT_XOR:
		case META_INT_COMPLEMENT:
		case META_INT_SHIFTRIGHT:
		case META_INT_SHIFTLEFT:
		case META_INT_UNSIGNEDSHIFTRIGHT:
		case META_LONG_UNARY_MINUS:
		case META_LONG_ADD:
		case META_LONG_SUB:
		case META_LONG_MUL:
		case META_LONG_DIV:
		case META_LONG_MOD:
		case META_LONG_AND:
		case META_LONG_OR:
		case META_LONG_XOR:
		case META_LONG_COMPLEMENT:
		case META_LONG_SHIFTRIGHT:
		case META_LONG_SHIFTLEFT:
		case META_LONG_UNSIGNEDSHIFTRIGHT:
		case META_MODULO_BYTE:
		case META_MODULO_SHORT:
		case META_MODULO_INTEGER:
		case META_MODULO_LONG:
		case STATIC_ANALYSIS:
		case META_LENGTH:
		case IDENT:
		{
			if ( inputState.guessing==0 ) {
				
						String s=LT(0)+" ";
						s=LT(1)+" "; 
						s=LT(2)+" ";
						s=LT(3)+" ";        
						if(LT(1)!=null && isNumber(LT(1).getText())){
							if(LT(0)==null || LT(2)==null){
							    a=toZNotation(LT(1).getText(), minus);
							    minus=false;  		
							    match(IDENT);
							    return a;
							}else if(!LT(0).getText().equals("(")|| !LT(2).getText().equals("(")){ 
							    a=toZNotation(LT(1).getText(), minus);
							    minus=false;  		
							    match(IDENT);
							    return a;
							}
						}  
						
			}
			break;
		}
		case CHAR_LITERAL:
		{
			match(CHAR_LITERAL);
			if ( inputState.guessing==0 ) {
				
								String s=LT(0).getText();
								int intVal=0;
								if (s.length()==3) {
									intVal=(int)LT(0).getText().charAt(1);
								} else {
									try {
									intVal = Integer.parseInt(s.substring(3,s.length()-1),16);
									} catch (NumberFormatException ex) {
									 throw new KeYSemanticException
									   ("Expected '"+s+"' to be a character", LT(0), getFilename());
									} 		
								}
								t=toZNotation(""+intVal,false);
						     		vf = (Function) func_ns.lookup(new Name("C"));
								return a=tf.createFunctionTerm((Function)vf, t.sub(0));
							
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		vf=varfunc_id();
		{
		if (((LA(1)==LPAREN))&&( vf.arity() > 0 )) {
			match(LPAREN);
			t=term();
			if ( inputState.guessing==0 ) {
				
									al = new Vector();
									n=1;
									al.add(t);
								
			}
			{
			_loop115:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					t=term();
					if ( inputState.guessing==0 ) {
						
												n++;
												al.add(t);
											
					}
				}
				else {
					break _loop115;
				}
				
			} while (true);
			}
			match(RPAREN);
		}
		else if ((_tokenSet_4.member(LA(1)))) {
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		{
		boolean synPredMatched118 = false;
		if ((((LA(1)==LBRACKET))&&(vf instanceof ParsableVariable))) {
			int _m118 = mark();
			synPredMatched118 = true;
			inputState.guessing++;
			try {
				{
				match(LBRACKET);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched118 = false;
			}
			rewind(_m118);
			inputState.guessing--;
		}
		if ( synPredMatched118 ) {
			if ( inputState.guessing==0 ) {
				a = termForParsedVariable((ParsableVariable)vf);
			}
			if ( inputState.guessing==0 ) {
				as = a.sort();
			}
			if (!(as instanceof ArraySort || as == ProgramSVSort.VARIABLE))
			  throw new SemanticException("as instanceof ArraySort || as == ProgramSVSort.VARIABLE");
			{
			int _cnt120=0;
			_loop120:
			do {
				if ((LA(1)==LBRACKET)) {
					match(LBRACKET);
					t=term60();
					if ( inputState.guessing==0 ) {
						
						if (as!=null && as!=ProgramSVSort.VARIABLE){
						if (!(as instanceof ArraySort)){
						throw new NotDeclException
						("array "+vf.name()+" declared with a different"+
						" dimension than required here", vf.name().toString(), 
						getFilename(), getLine(), getColumn());
						} else {
						as = ((ArraySort) as).elementSort();
						} 
						}
						a=tf.createArrayTerm(Op.ARRAY,a,t);
						
					}
					match(RBRACKET);
				}
				else {
					if ( _cnt120>=1 ) { break _loop120; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt120++;
			} while (true);
			}
		}
		else if ((_tokenSet_5.member(LA(1)))) {
			if ( inputState.guessing==0 ) {
				if (vf instanceof ParsableVariable) {
						      a = termForParsedVariable((ParsableVariable)vf);
						    } else if (vf instanceof Function) {
							if ( al == null ) {	
								a = tf.createFunctionTerm((Function)vf);
							} else {
								a = tf.createFunctionTerm((Function)vf,
									   (Term[])al.toArray(AN_ARRAY_OF_TERMS));
								}
				
						    } else if (vf instanceof MetaOperator) {
				
							if ( al == null ) {	
								a = tf.createMetaTerm((MetaOperator)vf, new Term[0]);
							} else {	
								a = tf.createMetaTerm((MetaOperator)vf,
									   (Term[])al.toArray(AN_ARRAY_OF_TERMS));
							}
						    }
						    if (minus) {
					              Term[] t1 = new Term[1];
					      t1[0] = a;
					      vf = (Function) func_ns.lookup(new Name("~m"));
				a = tf.createFunctionTerm((Function)vf,t1);
				minus = false;
					    }	
					
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		return a;
	}
	
	public final Term  substitutionterm() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		Token  v1 = null;
		Term a1, a2;
		Sort s = null;
		TermSymbol ts;
		QuantifiableVariable v = null;
		boolean bound = false;
		boolean waryAll = false;
		boolean waryEx = false;
		
		
		match(LBRACE);
		v1 = LT(1);
		match(IDENT);
		{
		if ((LA(1)==COLON)) {
			match(COLON);
			s=sort_id();
			if ( inputState.guessing==0 ) {
				
						       bound = true;
						
			}
		}
		else if (((_tokenSet_6.member(LA(1))))&&( func_ns.lookup(new Name(v1.getText())) == null )) {
			if ( inputState.guessing==0 ) {
				
					  ts = (TermSymbol) var_ns.lookup(new Name(v1.getText()));
					  if (   ts == null
					      || ts instanceof LogicVariable ) {
					    throw new SemanticException("Substituted variables need a sort.");
					  }
					  if ( ! (ts instanceof SchemaVariable &&
						((SchemaVariable)ts).isVariableSV()) ) {
							throw new SemanticException(
							"	"+ts+" is not allowed as bound variable "
								+"in a substitution term.");
					  }
					  v = (SchemaVariable) ts;
					  bound = false;
				
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		a1=term();
		{
		switch ( LA(1)) {
		case WARY_ALL:
		{
			match(WARY_ALL);
			if ( inputState.guessing==0 ) {
				waryAll = true;
			}
			break;
		}
		case WARY_EX:
		{
			match(WARY_EX);
			if ( inputState.guessing==0 ) {
				waryEx  = true;
			}
			break;
		}
		case RBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(RBRACE);
		if ( inputState.guessing==0 ) {
			
				if (bound) {v = bindVar(v1,s);} 
			
		}
		a2=term60();
		if ( inputState.guessing==0 ) {
			
					    if ( waryAll )
					        result = tf.createSubstitutionTerm ( Op.WARY_SUBST_ALL,
					                                             v, a1, a2 );
					    else if ( waryEx )
					        result = tf.createSubstitutionTerm ( Op.WARY_SUBST_EX,
					                                             v, a1, a2 );
					    else
					        result = tf.createSubstitutionTerm ( Op.SUBST,
					                                             v, a1, a2 );
				if (bound) {unbindVars();}
			
		}
		return result;
	}
	
	public final ParsableVariable  attrid(
		Sort s
	) throws RecognitionException, TokenStreamException {
		ParsableVariable v = null;
		
		Token  attr = null;
		
		
		
		
		attr = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			if (!schematicJava) {
					v = getJavaInfo().getAttribute(attr.getText(), (ObjectSort)s);
				} else {
					v = (SchemaVariable)var_ns.lookup(new Name(attr.getText()));
				}
			if ( v == null && !("length").equals(attr.getText()) ) {
				throw new NotDeclException
					("Attribute ", attr.getText(),getFilename(), 
					  getLine(), getColumn());
			
			}
			
			
		}
		return v;
	}
	
	public final Term  condterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Term cond1_1 = null;
		Term cond1_2 = null;
		Term cond2_1 = null;
		Term cond2_2 = null;
		Term c_then = null;
		Term c_else = null;
		ParsableVariable v=null;
		
		
		boolean synPredMatched81 = false;
		if (((LA(1)==LPAREN) && (_tokenSet_0.member(LA(2))))) {
			int _m81 = mark();
			synPredMatched81 = true;
			inputState.guessing++;
			try {
				{
				match(LPAREN);
				term80();
				match(COMMA);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched81 = false;
			}
			rewind(_m81);
			inputState.guessing--;
		}
		if ( synPredMatched81 ) {
			{
			match(LPAREN);
			cond1_1=term80();
			match(COMMA);
			cond1_2=term80();
			match(COLON);
			c_else=term60();
			match(GUARD);
			cond2_1=term80();
			match(COMMA);
			cond2_2=term80();
			match(COLON);
			c_then=term60();
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				
					a = tf.createConjCondTerm(new Term[]{cond1_1, cond1_2, c_else, 
					  cond2_1, cond2_2, c_then});
				
			}
			}
		}
		else if ((LA(1)==LPAREN) && (_tokenSet_0.member(LA(2)))) {
			match(LPAREN);
			cond1_1=term80();
			match(GUARD);
			cond2_1=term80();
			match(RPAREN);
			{
			switch ( LA(1)) {
			case DOT:
			{
				match(DOT);
				v=var_id();
				match(CONDUP);
				c_then=term60();
				if ( inputState.guessing==0 ) {
					
							  a = tf.createIfElseTerm((SchemaVariable)v, cond1_1, 
										  cond2_1, c_then);
						
				}
				break;
			}
			case FORALL:
			case EXISTS:
			case TRUE:
			case FALSE:
			case NOT:
			case IN_TYPE:
			case IS_OBJECT:
			case IS_CLONABLE:
			case META_IN_LONG:
			case META_IN_INT:
			case META_IN_CHAR:
			case META_IN_SHORT:
			case META_IN_BYTE:
			case META_ADD:
			case META_SUB:
			case META_MUL:
			case META_DIV:
			case META_MOD:
			case META_LESS:
			case META_GREATER:
			case META_LEQ:
			case META_GEQ:
			case META_EQ:
			case META_INT_UNARY_MINUS:
			case META_INT_ADD:
			case META_INT_SUB:
			case META_INT_MUL:
			case META_INT_DIV:
			case META_INT_MOD:
			case META_INT_AND:
			case META_INT_OR:
			case META_INT_XOR:
			case META_INT_COMPLEMENT:
			case META_INT_SHIFTRIGHT:
			case META_INT_SHIFTLEFT:
			case META_INT_UNSIGNEDSHIFTRIGHT:
			case META_LONG_UNARY_MINUS:
			case META_LONG_ADD:
			case META_LONG_SUB:
			case META_LONG_MUL:
			case META_LONG_DIV:
			case META_LONG_MOD:
			case META_LONG_AND:
			case META_LONG_OR:
			case META_LONG_XOR:
			case META_LONG_COMPLEMENT:
			case META_LONG_SHIFTRIGHT:
			case META_LONG_SHIFTLEFT:
			case META_LONG_UNSIGNEDSHIFTRIGHT:
			case META_MODULO_BYTE:
			case META_MODULO_SHORT:
			case META_MODULO_INTEGER:
			case META_MODULO_LONG:
			case STATIC_ANALYSIS:
			case META_LENGTH:
			case LPAREN:
			case LBRACE:
			case AT:
			case CTRL:
			case ARITH_OP:
			case CHAR_LITERAL:
			case DIAMOND:
			case BOX:
			case IDENT:
			{
				c_then=term60();
				match(COLON);
				c_else=term60();
				if ( inputState.guessing==0 ) {
					
							  a = tf.createIfElseTerm(cond1_1, cond2_1, c_then, c_else);
							
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		return a;
	}
	
	public final Term  term80() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case AT:
			{
				match(AT);
				a=abbreviation();
				break;
			}
			case ARITH_OP:
			{
				match(ARITH_OP);
				if ( inputState.guessing==0 ) {
					minus = !minus; a=term80();
				}
				break;
			}
			case LPAREN:
			{
				match(LPAREN);
				a=term();
				match(RPAREN);
				break;
			}
			case TRUE:
			{
				match(TRUE);
				if ( inputState.guessing==0 ) {
					a = tf.createJunctorTerm(Op.TRUE);
				}
				break;
			}
			case FALSE:
			{
				match(FALSE);
				if ( inputState.guessing==0 ) {
					a = tf.createJunctorTerm(Op.FALSE);
				}
				break;
			}
			default:
				boolean synPredMatched104 = false;
				if (((_tokenSet_2.member(LA(1))) && (_tokenSet_3.member(LA(2))))) {
					int _m104 = mark();
					synPredMatched104 = true;
					inputState.guessing++;
					try {
						{
						match(IDENT);
						{
						_loop103:
						do {
							if ((LA(1)==LBRACKET)) {
								match(LBRACKET);
								funcpredvarterm();
								match(RBRACKET);
							}
							else {
								break _loop103;
							}
							
						} while (true);
						}
						match(DOT);
						match(IDENT);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched104 = false;
					}
					rewind(_m104);
					inputState.guessing--;
				}
				if ( synPredMatched104 ) {
					a=attrterm();
				}
				else if ((_tokenSet_2.member(LA(1))) && (_tokenSet_7.member(LA(2)))) {
					a=funcpredvarterm();
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
				throw new RecognitionException("Not a valid logical term.\n"+ex.toString());
				
			} else {
				throw ex;
			}
		}
		return a;
	}
	
	public final Term  formula() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		a=term();
		if ( inputState.guessing==0 ) {
			
						if ( a.sort() != Sort.FORMULA ) {
							throw new antlr.SemanticException(
								"Just Parsed a Term where a Formula was expected");
						}
					
		}
		return a;
	}
	
	public final Term  term20() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Term a1;
		
		a=term30();
		{
		switch ( LA(1)) {
		case EQV:
		{
			match(EQV);
			a1=term20();
			if ( inputState.guessing==0 ) {
				a = tf.createJunctorTerm(Op.EQV,new Term[]{a,a1});
			}
			break;
		}
		case EOF:
		case WARY_ALL:
		case WARY_EX:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return a;
	}
	
	public final Term  term30() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Term a1;
		
		a=term40();
		{
		switch ( LA(1)) {
		case IMP:
		{
			match(IMP);
			a1=term30();
			if ( inputState.guessing==0 ) {
				a = tf.createJunctorTerm(Op.IMP,new Term[]{a,a1});
			}
			break;
		}
		case EOF:
		case WARY_ALL:
		case WARY_EX:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case EQV:
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return a;
	}
	
	public final Term  term40() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Term a1;
		
		a=term50();
		{
		switch ( LA(1)) {
		case OR:
		{
			match(OR);
			a1=term40();
			if ( inputState.guessing==0 ) {
				a = tf.createJunctorTerm(Op.OR, new Term[]{a,a1});
			}
			break;
		}
		case EOF:
		case WARY_ALL:
		case WARY_EX:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case IMP:
		case EQV:
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return a;
	}
	
	public final Term  term50() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Term a1;
		
		a=term60();
		{
		switch ( LA(1)) {
		case AND:
		{
			match(AND);
			a1=term50();
			if ( inputState.guessing==0 ) {
				a = tf.createJunctorTerm(Op.AND,new Term[]{a,a1});
			}
			break;
		}
		case EOF:
		case WARY_ALL:
		case WARY_EX:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case OR:
		case IMP:
		case EQV:
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return a;
	}
	
	public final Term  term70() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Term a1;
		
		a=term80();
		{
		switch ( LA(1)) {
		case EQUALS:
		{
			match(EQUALS);
			a1=term80();
			if ( inputState.guessing==0 ) {
				a = tf.createEqualityTerm(a,a1);
			}
			break;
		}
		case EOF:
		case GUARD:
		case WARY_ALL:
		case WARY_EX:
		case COLON:
		case ASSIGN:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACKET:
		case OR:
		case AND:
		case IMP:
		case EQV:
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return a;
	}
	
	public final Term  dl_term() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		a=normal_dl_term();
		return a;
	}
	
	public final Term  abbreviation() throws RecognitionException, TokenStreamException {
		Term a=null;
		
		
			String sc = null;
		
		
		{
		sc=id();
		if ( inputState.guessing==0 ) {
			
						a =  scm.getTerm(sc);
					    if(a==null){
							throw new NotDeclException
							("abbreviation", sc, 
							getFilename(), getLine(), getColumn());
						}
						
			
					
		}
		}
		return a;
	}
	
	public final String  id() throws RecognitionException, TokenStreamException {
		String name = null;
		
		Token  classID = null;
		Token  nameID = null;
		Token  pureID = null;
		
		boolean synPredMatched199 = false;
		if (((LA(1)==IDENT) && (LA(2)==COLON))) {
			int _m199 = mark();
			synPredMatched199 = true;
			inputState.guessing++;
			try {
				{
				match(IDENT);
				match(COLON);
				match(COLON);
				match(IDENT);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched199 = false;
			}
			rewind(_m199);
			inputState.guessing--;
		}
		if ( synPredMatched199 ) {
			classID = LT(1);
			match(IDENT);
			match(COLON);
			match(COLON);
			nameID = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				
							 name = classID.getText() + "::" + nameID.getText();
							
			}
		}
		else if ((LA(1)==IDENT) && (_tokenSet_8.member(LA(2)))) {
			pureID = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				name = pureID.getText();
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		return name;
	}
	
	public final Term  local_bindingterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Token  v0 = null;
		
			Operator op = null;
			LogicVariable v = null;
			Term a1;
			Sort s;
		
		
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		{
			{
			switch ( LA(1)) {
			case FORALL:
			{
				match(FORALL);
				if ( inputState.guessing==0 ) {
					op = Op.ALL;
				}
				break;
			}
			case EXISTS:
			{
				match(EXISTS);
				if ( inputState.guessing==0 ) {
					op = Op.EX;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			v0 = LT(1);
			match(IDENT);
			match(COLON);
			s=sort_id();
			match(DOT);
			if ( inputState.guessing==0 ) {
				v = bindVar(v0,s);
			}
			a1=term60();
			if ( inputState.guessing==0 ) {
				
							a = tf.createQuantifierTerm((Quantifier)op, v,a1);
							unbindVars();
						
			}
			break;
		}
		case LBRACE:
		{
			a=update_or_substitution();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return a;
	}
	
	public final Term  normal_dl_term() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Token  d1 = null;
		Token  d2 = null;
			JavaBlock jb=null;
			Term a1;
		
		
		switch ( LA(1)) {
		case DIAMOND:
		{
			d1 = LT(1);
			match(DIAMOND);
			if ( inputState.guessing==0 ) {
				
							jb=getJavaBlock(d1);
							HashSet progVars=progVars(jb);
							bindProgVars(progVars);
						
			}
			a1=term60();
			if ( inputState.guessing==0 ) {
				
							a = tf.createDiamondTerm(jb, a1);
							unbindProgVars();
						
			}
			break;
		}
		case BOX:
		{
			d2 = LT(1);
			match(BOX);
			if ( inputState.guessing==0 ) {
				
							jb=getJavaBlock(d2);
							HashSet progVars=progVars(jb);
							bindProgVars(progVars);
						
			}
			a1=term60();
			if ( inputState.guessing==0 ) {
				
							a = tf.createBoxTerm(jb, a1);
							unbindProgVars();
						
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return a;
	}
	
	public final Operator  varfunc_id() throws RecognitionException, TokenStreamException {
		Operator v = null;
		
		
			String varfunc_name = null;
		
		
		{
		switch ( LA(1)) {
		case IN_TYPE:
		case IS_OBJECT:
		case IS_CLONABLE:
		{
			v=expr_op();
			break;
		}
		case IDENT:
		{
			varfunc_name=id();
			if ( inputState.guessing==0 ) {
				
							v = (TermSymbol) var_ns.lookup(new Name(varfunc_name));
							if (v == null) {
							   v = (Function) func_ns.lookup(new Name(varfunc_name));
							   if(v==null) {
					v = (ProgramVariable)
					getJavaInfo().programVariables().lookup(
					new Name(varfunc_name));
				if(v==null) {
									throw new NotDeclException
									("variable or function", varfunc_name, 
									getFilename(), getLine(), getColumn());
				}
							   }
							}
				
						
			}
			break;
		}
		case META_INT_UNARY_MINUS:
		{
			match(META_INT_UNARY_MINUS);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_UNARY_MINUS ;
			}
			break;
		}
		case META_LONG_UNARY_MINUS:
		{
			match(META_LONG_UNARY_MINUS);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_UNARY_MINUS ;
			}
			break;
		}
		case META_ADD:
		{
			match(META_ADD);
			if ( inputState.guessing==0 ) {
				v = Op.META_ADD;
			}
			break;
		}
		case META_SUB:
		{
			match(META_SUB);
			if ( inputState.guessing==0 ) {
				v = Op.META_SUB;
			}
			break;
		}
		case META_MUL:
		{
			match(META_MUL);
			if ( inputState.guessing==0 ) {
				v = Op.META_MUL;
			}
			break;
		}
		case META_DIV:
		{
			match(META_DIV);
			if ( inputState.guessing==0 ) {
				v = Op.META_DIV;
			}
			break;
		}
		case META_MOD:
		{
			match(META_MOD);
			if ( inputState.guessing==0 ) {
				v = Op.META_MOD;
			}
			break;
		}
		case META_LESS:
		{
			match(META_LESS);
			if ( inputState.guessing==0 ) {
				v = Op.META_LESS;
			}
			break;
		}
		case META_GREATER:
		{
			match(META_GREATER);
			if ( inputState.guessing==0 ) {
				v = Op.META_GREATER;
			}
			break;
		}
		case META_LEQ:
		{
			match(META_LEQ);
			if ( inputState.guessing==0 ) {
				v = Op.META_LEQ;
			}
			break;
		}
		case META_GEQ:
		{
			match(META_GEQ);
			if ( inputState.guessing==0 ) {
				v = Op.META_GEQ;
			}
			break;
		}
		case META_EQ:
		{
			match(META_EQ);
			if ( inputState.guessing==0 ) {
				v = Op.META_EQ;
			}
			break;
		}
		case META_INT_ADD:
		{
			match(META_INT_ADD);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_ADD;
			}
			break;
		}
		case META_INT_SUB:
		{
			match(META_INT_SUB);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_SUB;
			}
			break;
		}
		case META_INT_MUL:
		{
			match(META_INT_MUL);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_MUL;
			}
			break;
		}
		case META_INT_DIV:
		{
			match(META_INT_DIV);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_DIV;
			}
			break;
		}
		case META_INT_MOD:
		{
			match(META_INT_MOD);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_MOD;
			}
			break;
		}
		case META_INT_AND:
		{
			match(META_INT_AND);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_AND;
			}
			break;
		}
		case META_INT_OR:
		{
			match(META_INT_OR);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_OR;
			}
			break;
		}
		case META_INT_XOR:
		{
			match(META_INT_XOR);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_XOR;
			}
			break;
		}
		case META_INT_COMPLEMENT:
		{
			match(META_INT_COMPLEMENT);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_COMPLEMENT;
			}
			break;
		}
		case META_INT_SHIFTRIGHT:
		{
			match(META_INT_SHIFTRIGHT);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_SHIFTRIGHT;
			}
			break;
		}
		case META_INT_SHIFTLEFT:
		{
			match(META_INT_SHIFTLEFT);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_SHIFTLEFT;
			}
			break;
		}
		case META_INT_UNSIGNEDSHIFTRIGHT:
		{
			match(META_INT_UNSIGNEDSHIFTRIGHT);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_UNSIGNEDSHIFTRIGHT;
			}
			break;
		}
		case META_LONG_ADD:
		{
			match(META_LONG_ADD);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_ADD;
			}
			break;
		}
		case META_LONG_SUB:
		{
			match(META_LONG_SUB);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_SUB;
			}
			break;
		}
		case META_LONG_MUL:
		{
			match(META_LONG_MUL);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_MUL;
			}
			break;
		}
		case META_LONG_DIV:
		{
			match(META_LONG_DIV);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_DIV;
			}
			break;
		}
		case META_LONG_MOD:
		{
			match(META_LONG_MOD);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_MOD;
			}
			break;
		}
		case META_LONG_AND:
		{
			match(META_LONG_AND);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_AND;
			}
			break;
		}
		case META_LONG_OR:
		{
			match(META_LONG_OR);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_OR;
			}
			break;
		}
		case META_LONG_XOR:
		{
			match(META_LONG_XOR);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_XOR;
			}
			break;
		}
		case META_LONG_COMPLEMENT:
		{
			match(META_LONG_COMPLEMENT);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_COMPLEMENT;
			}
			break;
		}
		case META_LONG_SHIFTRIGHT:
		{
			match(META_LONG_SHIFTRIGHT);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_SHIFTRIGHT;
			}
			break;
		}
		case META_LONG_SHIFTLEFT:
		{
			match(META_LONG_SHIFTLEFT);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_SHIFTLEFT;
			}
			break;
		}
		case META_LONG_UNSIGNEDSHIFTRIGHT:
		{
			match(META_LONG_UNSIGNEDSHIFTRIGHT);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_UNSIGNEDSHIFTRIGHT;
			}
			break;
		}
		case META_IN_LONG:
		{
			match(META_IN_LONG);
			if ( inputState.guessing==0 ) {
				v = Op.META_IN_LONG;
			}
			break;
		}
		case META_IN_INT:
		{
			match(META_IN_INT);
			if ( inputState.guessing==0 ) {
				v = Op.META_IN_INT;
			}
			break;
		}
		case META_IN_CHAR:
		{
			match(META_IN_CHAR);
			if ( inputState.guessing==0 ) {
				v = Op.META_IN_CHAR;
			}
			break;
		}
		case META_IN_SHORT:
		{
			match(META_IN_SHORT);
			if ( inputState.guessing==0 ) {
				v = Op.META_IN_SHORT;
			}
			break;
		}
		case META_IN_BYTE:
		{
			match(META_IN_BYTE);
			if ( inputState.guessing==0 ) {
				v = Op.META_IN_BYTE;
			}
			break;
		}
		case META_MODULO_BYTE:
		{
			match(META_MODULO_BYTE);
			if ( inputState.guessing==0 ) {
				v = Op.META_MODULO_BYTE;
			}
			break;
		}
		case META_MODULO_SHORT:
		{
			match(META_MODULO_SHORT);
			if ( inputState.guessing==0 ) {
				v = Op.META_MODULO_SHORT;
			}
			break;
		}
		case META_MODULO_INTEGER:
		{
			match(META_MODULO_INTEGER);
			if ( inputState.guessing==0 ) {
				v = Op.META_MODULO_INTEGER;
			}
			break;
		}
		case META_MODULO_LONG:
		{
			match(META_MODULO_LONG);
			if ( inputState.guessing==0 ) {
				v = Op.META_MODULO_LONG;
			}
			break;
		}
		case STATIC_ANALYSIS:
		{
			match(STATIC_ANALYSIS);
			if ( inputState.guessing==0 ) {
				v = Op.STATIC_ANALYSIS;
			}
			break;
		}
		case META_LENGTH:
		{
			match(META_LENGTH);
			if ( inputState.guessing==0 ) {
				v = Op.META_LENGTH;
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return v;
	}
	
	public final Operator  expr_op() throws RecognitionException, TokenStreamException {
		Operator v = null;
		
		Token  id = null;
		Token  id1 = null;
		Token  id2 = null;
		
			ParsableVariable left_var0 = null;
			ParsableVariable right_var0 = null;
			ParsableVariable unary_var0 = null;
		
		
		switch ( LA(1)) {
		case IN_TYPE:
		{
			match(IN_TYPE);
			match(LPAREN);
			{
			switch ( LA(1)) {
			case IDENT:
			{
				{
				left_var0=var_id();
				{
				switch ( LA(1)) {
				case SLASH:
				case ARITH_OP:
				case IDENT:
				{
					{
					switch ( LA(1)) {
					case ARITH_OP:
					{
						id = LT(1);
						match(ARITH_OP);
						break;
					}
					case SLASH:
					{
						id1 = LT(1);
						match(SLASH);
						break;
					}
					case IDENT:
					{
						id2 = LT(1);
						match(IDENT);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					right_var0=var_id();
					break;
				}
				case RPAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
				break;
			}
			case 188:
			{
				{
				match(188);
				unary_var0=var_id();
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				
				if (id==null) id=id1;	
					   if (unary_var0!=null) {
					      // can only be unary minus
					      SchemaVariable unary_var = (SchemaVariable) unary_var0;
					      Sort type = de.uka.ilkd.key.logic.sort.Sort.FORMULA;
					      return new InTypeOperator
						(type, new de.uka.ilkd.key.java.expression.operator.Negative(unary_var));
					   }
					   else {
					      SchemaVariable left_var = (SchemaVariable) left_var0;
					      Sort type = de.uka.ilkd.key.logic.sort.Sort.FORMULA;
					      if (right_var0 != null) {
					         SchemaVariable right_var = (SchemaVariable) right_var0;
					         String op_str = (id == null ? id2.getText() : id.getText());
					   if ("+".equals(op_str)) {
						     return new InTypeOperator
						       (type, new de.uka.ilkd.key.java.expression.operator.Plus(left_var, right_var));
					         } else if ("-".equals(op_str)) {
						     return new InTypeOperator
						       (type, new de.uka.ilkd.key.java.expression.operator.Minus(left_var, right_var));
					         } else if ("*".equals(op_str)) {
						     return new InTypeOperator
						       (type, new de.uka.ilkd.key.java.expression.operator.Times(left_var, right_var));
					         } else if ("/".equals(op_str)) {
					    	     return new InTypeOperator
						       (type, new de.uka.ilkd.key.java.expression.operator.Divide(left_var, right_var));
						} else if ("%".equals(op_str)) {
					    	     return new InTypeOperator
						       (type, new de.uka.ilkd.key.java.expression.operator.Modulo(left_var, right_var));
					         } 
					      }
					      else {
					         return new InTypeOperator(type, left_var);
					      }
					   }
					
			}
			break;
		}
		case IS_OBJECT:
		{
			match(IS_OBJECT);
			match(LPAREN);
			{
			left_var0=var_id();
			}
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				
					   SchemaVariable var = (SchemaVariable) left_var0;
					   return new IsObject(de.uka.ilkd.key.logic.sort.Sort.FORMULA, var);
					
			}
			break;
		}
		case IS_CLONABLE:
		{
			match(IS_CLONABLE);
			match(LPAREN);
			{
			left_var0=var_id();
			}
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				
					   SchemaVariable var = (SchemaVariable) left_var0;
					   return new IsClonable(de.uka.ilkd.key.logic.sort.Sort.FORMULA, var);
					
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return v;
	}
	
	public final void decls() throws RecognitionException, TokenStreamException {
		
		
		{
		_loop134:
		do {
			switch ( LA(1)) {
			case SORTS:
			{
				sort_decls();
				break;
			}
			case SCHEMA:
			{
				schema_var_decls();
				break;
			}
			case PROGRAM:
			{
				prog_var_decls();
				break;
			}
			case PREDICATES:
			{
				pred_decls();
				break;
			}
			case FUNCTIONS:
			{
				func_decls();
				break;
			}
			case HEURISTICS:
			{
				heur_decls();
				break;
			}
			default:
			{
				break _loop134;
			}
			}
		} while (true);
		}
	}
	
	public final void sort_decls() throws RecognitionException, TokenStreamException {
		
		
		boolean isObjectSort=false;
		boolean isGenericSort=false;
		Sort[] sortExt=new Sort [0];
		Sort[] sortOneOf=new Sort [0];
		ListOfName sort_ids;
		
		
		match(SORTS);
		match(LBRACE);
		{
		_loop140:
		do {
			if ((LA(1)==OBJECT||LA(1)==GENERIC||LA(1)==IDENT)) {
				if ( inputState.guessing==0 ) {
					
						       isObjectSort=false; 
						       isGenericSort=false; 
						       sortExt = new Sort[0];
						       sortOneOf = new Sort[0];
						
				}
				{
				switch ( LA(1)) {
				case OBJECT:
				{
					match(OBJECT);
					if ( inputState.guessing==0 ) {
						isObjectSort=true;
					}
					sort_ids=sort_identifiers();
					break;
				}
				case GENERIC:
				{
					match(GENERIC);
					if ( inputState.guessing==0 ) {
						isGenericSort=true;
					}
					sort_ids=sort_identifiers();
					{
					switch ( LA(1)) {
					case ONEOF:
					{
						match(ONEOF);
						sortOneOf=oneof_sorts();
						break;
					}
					case EXTENDS:
					case SEMI:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					{
					switch ( LA(1)) {
					case EXTENDS:
					{
						match(EXTENDS);
						sortExt=extends_sorts();
						break;
					}
					case SEMI:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					break;
				}
				case IDENT:
				{
					sort_ids=sort_identifiers();
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SEMI);
				if ( inputState.guessing==0 ) {
					
						    Name           sort_name;
						    IteratorOfName it         = sort_ids.iterator ();
						    while ( it.hasNext () ) {
						    sort_name = it.next ();
					
						    if (sort_ns.lookup(sort_name) == null) {
							Sort s;
							if (isObjectSort) {
							    if ("Object".equals(sort_name)) {
								if (sort_ns.lookup(new Name("Object"))
								    ==null) {
					
								    s = new ClassInstanceSortImpl(sort_name);
								}
								s=(Sort)sort_ns.lookup(new Name("Object"));
							    } else {
								s = new ClassInstanceSortImpl(sort_name, 
											      (Sort)sort_ns.lookup
											      (new Name("Object")));
							    }	
							} else if (isGenericSort) {
							    int        i;
							    SetOfSort  ext   = GenericSort.EMPTY_SORT_SET;
							    SetOfSort  oneOf = GenericSort.EMPTY_SORT_SET;
					
							    for ( i = 0; i != sortExt.length; ++i )
							        ext = ext.add ( sortExt[i] );
					
							    for ( i = 0; i != sortOneOf.length; ++i )
							        oneOf = oneOf.add ( sortOneOf[i] );
					
							    try {
							        s = new GenericSort ( sort_name,
							                              ext,
							                              oneOf );
							    } catch ( GenericSupersortException e ) {
							        throw new GenericSortException ( "sort",
							                   "Illegal sort given", e.getIllegalSort (),
							                   getFilename (), getLine (), getColumn () );
							    }
							} else {
							    s = new PrimitiveSort(sort_name);
							}
							sort_ns.add(s);
							if (s instanceof NonCollectionSort) {
							    NonCollectionSort ns
								= (NonCollectionSort)s;
							    sort_ns.add(ns.getSetSort());
							    sort_ns.add(ns.getSequenceSort());
							    sort_ns.add(ns.getBagSort());
							}
							if ( s instanceof SortDefiningSymbols )
							    ((SortDefiningSymbols)s).createSymbols ( func_ns, sort_ns );
						    }
					
						    }
						
				}
			}
			else {
				break _loop140;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void schema_var_decls() throws RecognitionException, TokenStreamException {
		
		
			Sort s = null;
			boolean makeVariableSV  = false;
			boolean makeDependingSV = false; // skolem functions
			boolean rigid           = false;
			boolean listModifier    = false;
		
		
		match(SCHEMA);
		match(VARIABLES);
		match(LBRACE);
		{
		_loop169:
		do {
			if ((LA(1)==PROGRAM||LA(1)==FORMULA||LA(1)==IDENT)) {
				if ( inputState.guessing==0 ) {
					makeVariableSV = false; makeDependingSV = false; rigid = false; listModifier=false;
				}
				{
				switch ( LA(1)) {
				case PROGRAM:
				{
					{
					match(PROGRAM);
					{
					switch ( LA(1)) {
					case SVLIST:
					{
						match(SVLIST);
						if ( inputState.guessing==0 ) {
							listModifier=true;
						}
						break;
					}
					case ARRAY:
					case STATEMENT:
					case EXPRESSION:
					case STATEMENTEXPRESSION:
					case BRANCH:
					case NONSIMPLE:
					case LEFTHANDSIDE:
					case SIMPLE:
					case LOOPINIT:
					case GUARD:
					case FORUPDATES:
					case TYPE:
					case JAVABOOL:
					case VARIABLE:
					case SWITCH:
					case BOOLEANVARIABLE:
					case CATCH:
					case METHODREFERENCE:
					case SPECIAL:
					case CLASSTYPE:
					case INTERFACETYPE:
					case ARRAYTYPE:
					case METHODBODY:
					case VARIABLEINIT:
					case LABEL:
					case MULTIPLEVARDECL:
					case NEW:
					case IMPLICIT:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					{
					switch ( LA(1)) {
					case STATEMENT:
					{
						match(STATEMENT);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.STATEMENT;
												
						}
						break;
					}
					case EXPRESSION:
					{
						match(EXPRESSION);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.EXPRESSION;
												
						}
						break;
					}
					case MULTIPLEVARDECL:
					{
						match(MULTIPLEVARDECL);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.MULTIPLEVARDECL;
												
						}
						break;
					}
					case JAVABOOL:
					{
						match(JAVABOOL);
						match(EXPRESSION);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.BOOLEANEXPRESSION;
												
						}
						break;
					}
					case LEFTHANDSIDE:
					{
						match(LEFTHANDSIDE);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.LEFTHANDSIDE;
												
						}
						break;
					}
					case LOOPINIT:
					{
						match(LOOPINIT);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.LOOPINIT;
												
						}
						break;
					}
					case GUARD:
					{
						match(GUARD);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.GUARD;
												
						}
						break;
					}
					case FORUPDATES:
					{
						match(FORUPDATES);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.FORUPDATES;
												
						}
						break;
					}
					case STATEMENTEXPRESSION:
					{
						match(STATEMENTEXPRESSION);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.STATEMENTEXPRESSION;
												
						}
						break;
					}
					case LABEL:
					{
						match(LABEL);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.LABEL;
												
						}
						break;
					}
					case TYPE:
					{
						match(TYPE);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.TYPE;
												
						}
						break;
					}
					case VARIABLE:
					{
						match(VARIABLE);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.VARIABLE;
												
						}
						break;
					}
					case VARIABLEINIT:
					{
						match(VARIABLEINIT);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.VARIABLEINIT;
												
						}
						break;
					}
					case SWITCH:
					{
						match(SWITCH);
						if ( inputState.guessing==0 ) {
							
									 	s=ProgramSVSort.SWITCH;
										
						}
						break;
					}
					case BOOLEANVARIABLE:
					{
						{
						match(BOOLEANVARIABLE);
						}
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.BOOLEANVARIABLE;
												
						}
						break;
					}
					case CATCH:
					{
						{
						match(CATCH);
						}
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.CATCH;
												
						}
						break;
					}
					case METHODREFERENCE:
					{
						{
						match(METHODREFERENCE);
						}
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.METHODREFERENCE;
												
						}
						break;
					}
					case SPECIAL:
					{
						match(SPECIAL);
						match(CONSTRUCTORREFERENCE);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.SPECIALCONSTRUCTORREFERENCE;				
												
						}
						break;
					}
					case ARRAYTYPE:
					{
						{
						match(ARRAYTYPE);
						}
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.ARRAYTYPE;
												
						}
						break;
					}
					case METHODBODY:
					{
						{
						match(METHODBODY);
						}
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.METHODBODY;
												
						}
						break;
					}
					case BRANCH:
					{
						{
						match(BRANCH);
						}
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.BRANCH;
												
						}
						break;
					}
					default:
						if ((LA(1)==SIMPLE) && (LA(2)==EXPRESSION)) {
							match(SIMPLE);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVABOOL)) {
							match(SIMPLE);
							match(JAVABOOL);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVABOOLEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVABYTE)) {
							match(SIMPLE);
							match(JAVABYTE);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVABYTEEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVACHAR)) {
							match(SIMPLE);
							match(JAVACHAR);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVACHAREXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVASHORT)) {
							match(SIMPLE);
							match(JAVASHORT);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVASHORTEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVAINT)) {
							match(SIMPLE);
							match(JAVAINT);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVAINTEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVALONG)) {
							match(SIMPLE);
							match(JAVALONG);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVALONGEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVABYTESHORTINT)) {
							match(SIMPLE);
							match(JAVABYTESHORTINT);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVABYTESHORTINTEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==ANYJAVATYPE)) {
							match(SIMPLE);
							match(ANYJAVATYPE);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEANYJAVATYPEEXPRESSION;
													
							}
						}
						else if ((LA(1)==CLASSTYPE) && (LA(2)==EXPRESSION)) {
							match(CLASSTYPE);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.CLASSTYPEEXPRESSION;
													
							}
						}
						else if ((LA(1)==INTERFACETYPE) && (LA(2)==EXPRESSION)) {
							match(INTERFACETYPE);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.INTERFACETYPEEXPRESSION;
													
							}
						}
						else if ((LA(1)==NONSIMPLE) && (LA(2)==EXPRESSION)) {
							match(NONSIMPLE);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.NONSIMPLEEXPRESSION;
													
							}
						}
						else if ((LA(1)==NONSIMPLE) && (LA(2)==JAVABOOL)) {
							match(NONSIMPLE);
							match(JAVABOOL);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.NONSIMPLEBOOLEANEXPRESSION;
													
							}
						}
						else if ((LA(1)==IMPLICIT) && (LA(2)==NEXT)) {
							match(IMPLICIT);
							match(NEXT);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.IMPLICITNEXT;
													
							}
						}
						else if ((LA(1)==IMPLICIT) && (LA(2)==REFERENCE)) {
							match(IMPLICIT);
							match(REFERENCE);
							match(FIELD);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.IMPLICITREFERENCE;
													
							}
						}
						else if ((LA(1)==NEW) && (LA(2)==IDENT)) {
							match(NEW);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.NEW;
													
							}
						}
						else if ((LA(1)==NEW) && (LA(2)==ARRAY)) {
							match(NEW);
							match(ARRAY);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.NEWARRAY;
													
							}
						}
						else if ((LA(1)==ARRAY) && (LA(2)==INITIALIZER)) {
							match(ARRAY);
							match(INITIALIZER);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.ARRAYINITIALIZER;
													
							}
						}
						else if ((LA(1)==ARRAY) && (LA(2)==LENGTH)) {
							match(ARRAY);
							match(LENGTH);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.ARRAYLENGTH;
													
							}
						}
						else if ((LA(1)==CLASSTYPE) && (LA(2)==IDENT)) {
							{
							match(CLASSTYPE);
							}
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.CLASSTYPE;
													
							}
						}
						else if ((LA(1)==INTERFACETYPE) && (LA(2)==IDENT)) {
							{
							match(INTERFACETYPE);
							}
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.INTERFACETYPE;
													
							}
						}
						else if ((LA(1)==ARRAY) && (LA(2)==IDENT)) {
							{
							match(ARRAY);
							}
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.ARRAY;
													
							}
						}
					else {
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					}
					break;
				}
				case FORMULA:
				{
					match(FORMULA);
					{
					switch ( LA(1)) {
					case RIGID:
					{
						match(RIGID);
						if ( inputState.guessing==0 ) {
							rigid = true;
						}
						break;
					}
					case IDENT:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					if ( inputState.guessing==0 ) {
						
											s = Sort.FORMULA;
										
					}
					break;
				}
				case IDENT:
				{
					s=any_sort_id_check(true);
					{
					switch ( LA(1)) {
					case VARIABLES:
					{
						match(VARIABLES);
						if ( inputState.guessing==0 ) {
							makeVariableSV = true;
						}
						break;
					}
					case DEPENDING:
					{
						match(DEPENDING);
						if ( inputState.guessing==0 ) {
							makeDependingSV = true;
						}
						break;
					}
					case RIGID:
					{
						match(RIGID);
						if ( inputState.guessing==0 ) {
							rigid = true;
						}
						break;
					}
					case IDENT:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				one_schema_var_decl(s,makeVariableSV,makeDependingSV,rigid,listModifier);
				{
				_loop168:
				do {
					if ((LA(1)==COMMA)) {
						match(COMMA);
						one_schema_var_decl(s,makeVariableSV,makeDependingSV,rigid,listModifier);
					}
					else {
						break _loop168;
					}
					
				} while (true);
				}
				match(SEMI);
			}
			else {
				break _loop169;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void prog_var_decls() throws RecognitionException, TokenStreamException {
		
		
			Sort s;
		String var_name;
		
		
		match(PROGRAM);
		match(VARIABLES);
		match(LBRACE);
		{
		_loop183:
		do {
			if ((LA(1)==IDENT)) {
				s=sort_id_check(true);
				var_name=id();
				if ( inputState.guessing==0 ) {
					
									ProgramVariable pv = new ProgramVariable(
					new ProgramElementName(var_name), 
					javaInfo.getKeYJavaType(s));
									javaInfo.programVariables().add(pv);
								
				}
				match(SEMI);
			}
			else {
				break _loop183;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void pred_decls() throws RecognitionException, TokenStreamException {
		
		
			Sort[] argSorts;
			String pred_name;
		
		
		match(PREDICATES);
		match(LBRACE);
		{
		_loop173:
		do {
			if ((LA(1)==IDENT)) {
				pred_name=id();
				argSorts=arg_sorts(!skip_predicates);
				if ( inputState.guessing==0 ) {
					
								    if (!skip_predicates) {
									Name predicate = new Name(pred_name);
									if (func_ns.lookup(predicate) != null) {
									    // throw new AmbigiousDeclException
									    //("predicate "+pred_name+" ", 
									    //getLine(), getColumn());
									} else {
									    Function p = new Function(predicate,
												      Sort.FORMULA, 
												      argSorts);
									    func_ns.add(p);			
									}
								    } 
								
				}
				match(SEMI);
			}
			else {
				break _loop173;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void func_decls() throws RecognitionException, TokenStreamException {
		
		
			Sort[] argSorts;
			Sort retSort;
		String func_name;
		
		
		match(FUNCTIONS);
		match(LBRACE);
		{
		_loop176:
		do {
			if ((LA(1)==IDENT)) {
				retSort=sort_id_check(!skip_functions);
				func_name=id();
				argSorts=arg_sorts(!skip_functions);
				if ( inputState.guessing==0 ) {
					
								    if (!skip_functions) {
					
									Name fct_name = new Name(func_name);
									if (func_ns.lookup(fct_name) != null) {
									    //throw new AmbigiousDeclException
									    //("function "+func_name, 
									    //getLine(), getColumn());
									} else {
									    Function f=new Function(fct_name,
												    retSort, 
												    argSorts);
									    func_ns.add(f);
									}
								    } 
								
				}
				match(SEMI);
			}
			else {
				break _loop176;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void heur_decls() throws RecognitionException, TokenStreamException {
		
		Token  id = null;
		
		match(HEURISTICS);
		match(LBRACE);
		{
		_loop186:
		do {
			if ((LA(1)==IDENT)) {
				id = LT(1);
				match(IDENT);
				match(SEMI);
				if ( inputState.guessing==0 ) {
					
								    if (!skip_heuristics) {
									Heuristic h = new Heuristic(new Name(id.getText()));
									heur_ns.add(h);
								    }
								
				}
			}
			else {
				break _loop186;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final ListOfName  sort_identifiers() throws RecognitionException, TokenStreamException {
		ListOfName ids = SLListOfName.EMPTY_LIST;
		
		Token  id = null;
		Token  id2 = null;
		
		id = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			ids = ids.append ( new Name(id.getText()) );
		}
		{
		_loop143:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				id2 = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					ids = ids.append ( new Name(id2.getText()) );
				}
			}
			else {
				break _loop143;
			}
			
		} while (true);
		}
		return ids;
	}
	
	public final Sort[]  oneof_sorts() throws RecognitionException, TokenStreamException {
		Sort[] oneOfSorts = null;
		
		
			Vector args = new Vector();
			Sort s;
		
		
		match(LBRACE);
		s=sort_id_check(true);
		if ( inputState.guessing==0 ) {
			args.add(s);
		}
		{
		_loop149:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				s=sort_id_check(true);
				if ( inputState.guessing==0 ) {
					args.add(s);
				}
			}
			else {
				break _loop149;
			}
			
		} while (true);
		}
		match(RBRACE);
		if ( inputState.guessing==0 ) {
			
						oneOfSorts = (Sort[])args.toArray(AN_ARRAY_OF_SORTS);
					
		}
		return oneOfSorts;
	}
	
	public final Sort[]  extends_sorts() throws RecognitionException, TokenStreamException {
		Sort[] extendsSorts = null;
		
		
			Vector args = new Vector();
			Sort s;
		
		
		s=any_sort_id_check(true);
		if ( inputState.guessing==0 ) {
			args.add(s);
		}
		{
		_loop146:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				s=any_sort_id_check(true);
				if ( inputState.guessing==0 ) {
					args.add(s);
				}
			}
			else {
				break _loop146;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
						extendsSorts = (Sort[])args.toArray(AN_ARRAY_OF_SORTS);
					
		}
		return extendsSorts;
	}
	
	public final Sort  any_sort_id_check(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		Sort t;
		
		
		t=any_sort_id_check_help(checkSort);
		s=array_decls(t);
		return s;
	}
	
	public final void one_schema_var_decl(
		Sort s, 
	            boolean makeVariableSV, 
	            boolean makeDependingSV,
	            boolean rigid, 
	            boolean listModifier
	) throws RecognitionException, TokenStreamException {
		
		Token  id = null;
		
		id = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			
					    if (!skip_schemavariables) {
						SchemaVariable v;
						if ( s == Sort.FORMULA ) {
						    v = SchemaVariable.createFormulaSV
							(new Name(id.getText()), listModifier, rigid);
						} else if ( s instanceof ProgramSVSort ) {
						    v = SchemaVariable.createProgramSV
						    (new ProgramElementName(id.getText()),(ProgramSVSort) s, listModifier);
						} else {
						    if ( makeVariableSV ) {
							v=SchemaVariable.createVariableSV
							(new Name(id.getText()), s, listModifier);
						    } else if ( makeDependingSV ) {
							v = SchemaVariable.createDependingSV
							(new Name(id.getText()), s, listModifier);
						    } else { v = SchemaVariable.createTermSV
							     (new Name(id.getText()), s, listModifier, rigid);
						    }
						}
						var_ns.add(v);
					    }
					
		}
	}
	
	public final Sort[]  arg_sorts(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort[] argSorts = null;
		
		
			Vector args = new Vector();
			Sort s;
		
		
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			s=sort_id_check(checkSort);
			if ( inputState.guessing==0 ) {
				args.add(s);
			}
			{
			_loop180:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					s=sort_id_check(checkSort);
					if ( inputState.guessing==0 ) {
						args.add(s);
					}
				}
				else {
					break _loop180;
				}
				
			} while (true);
			}
			match(RPAREN);
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
						argSorts = (Sort[])args.toArray(AN_ARRAY_OF_SORTS);
					
		}
		return argSorts;
	}
	
	public final Sort  sort_id_check_help(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		s=any_sort_id_check_help(checkSort);
		if ( inputState.guessing==0 ) {
			
			// don't allow generic sorts or collection sorts of
			// generic sorts at this point
			Sort t = s;
			while ( t instanceof CollectionSort )
			t = ((CollectionSort)t).elementSort ();
			if ( t instanceof GenericSort )
			throw new GenericSortException ( "sort",
			"Non-generic sort expected", t,
			getFilename (), getLine (), getColumn () );
			
		}
		return s;
	}
	
	public final Sort  array_decls(
		Sort p
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		int  n=0;
		
		
		{
		_loop194:
		do {
			if ((LA(1)==LBRACKET)) {
				match(LBRACKET);
				match(RBRACKET);
				if ( inputState.guessing==0 ) {
					n++;
				}
			}
			else {
				break _loop194;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			s = p;
			while(n>0){
			s=ArraySortImpl.getArraySort(s);
			n--;
			}
					
		}
		return s;
	}
	
	public final Sort  any_sort_id_check_help(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		Token  id = null;
		
		String name;
		
		
		id = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
				String idtext=(useInstead.get(id.getText()));
						s= (Sort) sort_ns.lookup(new Name(idtext));
						if (checkSort && s == null) {
						    throw 
							new NotDeclException("sort", id, 
									     getFilename());
						}
					
		}
		return s;
	}
	
	public final IdDeclaration  id_declaration() throws RecognitionException, TokenStreamException {
		 IdDeclaration idd = null ;
		
		Token  id = null;
		
		Sort s = null;
		
		
		id = LT(1);
		match(IDENT);
		{
		switch ( LA(1)) {
		case COLON:
		{
			match(COLON);
			s=sort_id_check(true);
			break;
		}
		case EOF:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			idd = new IdDeclaration ( id.getText (), s );
			
		}
		return idd;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"java\"",
		"\"array\"",
		"\"initializer\"",
		"\"statement\"",
		"\"expression\"",
		"\"statementexpression\"",
		"\"branch\"",
		"\"nonsimple\"",
		"\"lefthandside\"",
		"\"simple\"",
		"\"notsimple\"",
		"\"loopinit\"",
		"\"guard\"",
		"\"forupdates\"",
		"\"typeof\"",
		"\"type\"",
		"\"javaboolean\"",
		"\"object\"",
		"\"javabyte\"",
		"\"javashort\"",
		"\"javaint\"",
		"\"javalong\"",
		"\"javachar\"",
		"\"javabyteshortint\"",
		"\"anyjavatype\"",
		"\"number\"",
		"\"intliteral\"",
		"\"longliteral\"",
		"\"generic\"",
		"\"extends\"",
		"\"oneof\"",
		"\"variable\"",
		"\"switch\"",
		"\"booleanvariable\"",
		"\"catch\"",
		"\"methodreference\"",
		"\"constructorreference\"",
		"\"special\"",
		"\"classtype\"",
		"\"interfacetype\"",
		"\"arraytype\"",
		"\"methodbody\"",
		"\"variableinitializer\"",
		"\"label\"",
		"\"program\"",
		"\"multiplevardecl\"",
		"\"svlist\"",
		"\"all\"",
		"\"ex\"",
		"\"true\"",
		"\"false\"",
		"\"find\"",
		"\"if\"",
		"\"varcond\"",
		"\"noninteractive\"",
		"\"recursive\"",
		"\"displayname\"",
		"\"helptext\"",
		"\"new\"",
		"\"not\"",
		"\"free\"",
		"\"in\"",
		"\"depending\"",
		"\"on\"",
		"\"close\"",
		"\"goal\"",
		"\"replacewith\"",
		"\"add\"",
		"\"addrules\"",
		"\"addprogvars\"",
		"\"heuristics\"",
		"\"sorts\"",
		"\"schema\"",
		"\"variables\"",
		"\"implicit\"",
		"\"field\"",
		"\"reference\"",
		"\"next\"",
		"\"length\"",
		"\"rigid\"",
		"\"predicates\"",
		"\"functions\"",
		"\"formula\"",
		"\"rules\"",
		"\"proof\"",
		"\"rule\"",
		"\"term\"",
		"\"inst\"",
		"\"ifseqformula\"",
		"\"interactive\"",
		"\"heur\"",
		"\"problem\"",
		"\"#inType\"",
		"\"#isObject\"",
		"\"#isClonable\"",
		"\"#inLong\"",
		"\"#inInt\"",
		"\"#inChar\"",
		"\"#inShort\"",
		"\"#inByte\"",
		"\"#add\"",
		"\"#sub\"",
		"\"#mul\"",
		"\"#div\"",
		"\"#mod\"",
		"\"#less\"",
		"\"#greater\"",
		"\"#leq\"",
		"\"#geq\"",
		"\"#eq\"",
		"\"#JavaIntUnaryMinus\"",
		"\"#JavaIntAdd\"",
		"\"#JavaIntSub\"",
		"\"#JavaIntMul\"",
		"\"#JavaIntDiv\"",
		"\"#JavaIntMod\"",
		"\"#JavaIntAnd\"",
		"\"#JavaIntOr\"",
		"\"#JavaIntXor\"",
		"\"#JavaIntComplement\"",
		"\"#JavaIntShiftRight\"",
		"\"#JavaIntShiftLeft\"",
		"\"#JavaIntUnsignedShiftRight\"",
		"\"#JavaLongUnaryMinus\"",
		"\"#JavaLongAdd\"",
		"\"#JavaLongSub\"",
		"\"#JavaLongMul\"",
		"\"#JavaLongDiv\"",
		"\"#JavaLongMod\"",
		"\"#JavaLongAnd\"",
		"\"#JavaLongOr\"",
		"\"#JavaLongXor\"",
		"\"#JavaLongComplement\"",
		"\"#JavaLongShiftRight\"",
		"\"#JavaLongShiftLeft\"",
		"\"#JavaLongUnsignedShiftRight\"",
		"\"#moduloByte\"",
		"\"#moduloShort\"",
		"\"#moduloInteger\"",
		"\"#moduloLong\"",
		"\"#staticanalysis\"",
		"\"#lengthReference\"",
		"\"waryAll\"",
		"\"waryEx\"",
		"\"sameUpdateLevel\"",
		"VOCAB",
		"`;'",
		"`/'",
		"`:'",
		"`/->'",
		"`:='",
		"`.'",
		"`,'",
		"`('",
		"`)'",
		"`{'",
		"`}'",
		"`['",
		"']'",
		"`at'",
		"`|'",
		"`&'",
		"`->'",
		"`<->'",
		"`='",
		"`==>'",
		"'^'",
		"java operator",
		"white space",
		"a string in double quotes",
		"a char in single quotes",
		"ESC",
		"DIAMOND",
		"BOX",
		"BLOCK",
		"a string with double quotes",
		"a comment",
		"a comment",
		"a digit",
		"a hexadeciamal number",
		"a letter",
		"an admissible character for identifiers",
		"an identifer",
		"\"elemtypeof\"",
		"\"-\""
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 27021597764222976L, -4294967296L, 288309575885783039L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { -9189595039649431550L, -4294967296L, 289162761962782719L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 0L, -4294967296L, 288300744896151551L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 0L, -4294967296L, 288230385429774335L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 65538L, 0L, 4360952872960L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 65538L, 0L, 4352362938368L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { -9189595039649497088L, -4294967296L, 289158401009909759L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 65538L, -4294967296L, 288234737507500031L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { 65538L, 0L, 4361493938176L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	
	}
