// $ANTLR 2.7.2: "expandedterms.g" -> "TermParser.java"$


    package de.uka.ilkd.key.parser;

    import java.io.*;
    import antlr.*;
    import de.uka.ilkd.key.logic.*;
    import de.uka.ilkd.key.logic.sort.*;
    import de.uka.ilkd.key.logic.op.*;
    import de.uka.ilkd.key.rule.*;
    import de.uka.ilkd.key.gui.AbbrevMap;

    import de.uka.ilkd.key.rule.metaconstruct.*;
    import de.uka.ilkd.key.java.JavaReader;
    import de.uka.ilkd.key.java.JavaInfo;
    import java.util.Vector;
    import java.util.HashSet;
    import java.util.Iterator;
    import java.util.HashMap;
    import de.uka.ilkd.key.java.visitor.ProgramVariableCollector;
    import de.uka.ilkd.key.proof.UseInsteadMap;
    import de.uka.ilkd.key.java.Recoder2KeY;
    import de.uka.ilkd.key.java.Services;
    import de.uka.ilkd.key.java.recoderext.KeYCrossReferenceServiceConfiguration;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class TermParser extends antlr.LLkParser       implements TermParserTokenTypes
 {


    static final Sort[] AN_ARRAY_OF_SORTS = new Sort[0];
    static final Term[] AN_ARRAY_OF_TERMS = new Term[0];
    protected boolean minus=false;

    protected Namespace var_ns;
    protected Namespace func_ns;
    protected Namespace sort_ns;
    protected Namespace heur_ns;
    protected JavaInfo javaInfo;
    protected AbbrevMap scm;

    // these variables are set if a file is read in step by
    // step. This used when reading in LDTs because of cyclic
    // dependencies.
    protected boolean skip_functions;
    protected boolean skip_predicates;
    protected boolean skip_sorts;
    protected boolean skip_schemavariables;
    protected boolean skip_heuristics;

    protected int lineOffset=0;
    protected int colOffset=0;

    protected TermFactory tf;
    protected JavaReader javaReader;

    protected UseInsteadMap useInstead=new UseInsteadMap();	
    boolean schematicJava = false;	

    public boolean errors = false;


    public TermParser(TokenStream lexer,					
		      String filename,
		      TermFactory tf,
		      JavaReader jr,
		      Namespace var_ns,
		      Namespace func_ns,
		      Namespace sort_ns,
	              AbbrevMap scm) {
	this(lexer,2);
	setFilename(filename);
	this.javaReader = jr;
	this.tf = tf;
	this.var_ns = var_ns;
	this.func_ns = func_ns;
	this.sort_ns = sort_ns;
    	this.scm = scm;
    }

    public TermParser(TokenStream lexer,
		      String filename,
		      JavaReader jr,
		      Namespace var_ns,
		      Namespace func_ns,
		      Namespace sort_ns,
	              AbbrevMap scm) {

	this(lexer, filename, TermFactory.DEFAULT, jr, 
	     var_ns, func_ns, sort_ns, scm);
    }

    public TermParser(TokenStream lexer,
		      String filename,
		      TermFactory tf,
		      JavaInfo javaInfo,
		      Namespace var_ns,
		      Namespace func_ns,
		      Namespace sort_ns,
	              AbbrevMap scm) {

	this(lexer, filename, tf, getRecoder2KeY(javaInfo),	
	     var_ns, func_ns, sort_ns,scm);
    }

    static Recoder2KeY getRecoder2KeY(JavaInfo javaInfo) {
	 return new de.uka.ilkd.key.java.Recoder2KeY
		((KeYCrossReferenceServiceConfiguration)
			javaInfo.getKeYProgModelInfo().getServConf(),
		 javaInfo.rec2key(), javaInfo.getTypeConverter());	
    }

    public TermParser(TokenStream lexer,
		      String filename,
		      JavaInfo javaInfo,
		      Namespace var_ns,
		      Namespace func_ns,
		      Namespace sort_ns,
        	      AbbrevMap scm) {		

	this(lexer, filename, TermFactory.DEFAULT, getRecoder2KeY(javaInfo),
	     var_ns, func_ns, sort_ns, scm);
    }

    protected int getLine() {
	int line = -1;
	try {
	    line = LT(0).getLine()+lineOffset;
	} catch (TokenStreamException e) {
	    System.err.println("No further token in stream");
	}
	return line;
    }   


    public Term toZNotation(String s, boolean minus){
	Term[] t1=new Term[1];
	Operator v;
	Term a;
	v=(Function) func_ns.lookup(new Name("#"));
	t1[0] = tf.createFunctionTerm((Function)v);
	v = (Function) func_ns.lookup(new Name(s.substring(0,1)));
	a = tf.createFunctionTerm((Function)v,t1);
	for(int i=1;i<s.length();i++){
		t1[0]=a;
		v = (Function)func_ns.lookup(new Name(s.substring(i,i+1)));
		a = tf.createFunctionTerm((Function)v,t1);
	}
	if(minus){
		t1[0]=a;
		v = (Function) func_ns.lookup(new Name("neg"));
		a = tf.createFunctionTerm((Function)v,t1);
	}
	t1[0]=a;
	v = (Function) func_ns.lookup(new Name("Z"));
	a = tf.createFunctionTerm((Function)v,t1);
	return a;
    }

    protected int getColumn() {
	int 	col = -1;
	try {
	    col = LT(0).getColumn()+colOffset;
	} 
	catch (TokenStreamException e) {
	    System.err.println("No further token in stream");
	}
	return col;
    }   

    protected LogicVariable bindVar(Token id,Sort s) {
	LogicVariable v=new LogicVariable(new Name(id.getText()), s);
	var_ns=var_ns.extended(v);
	return v;
    }

    protected TermSymbol progVar(Token id,Sort s) throws NotDeclException{
	TermSymbol v = (TermSymbol)
	    var_ns.lookup(new Name(id.getText()));

	if (v == null) {
		throw new NotDeclException("program variable", id,
						getFilename());
	}
	return v;
    }


    /** returns the java information object */
    public JavaInfo getJavaInfo() {
	if (javaInfo==null) {
           javaInfo=javaReader.createJavaInfo(new Services());
        }
	return javaInfo;
    }


    protected boolean isNumber(String s){
	      boolean num=true;
          if(s==null){
            num=false;
          }else{
	        for(int i=s.length()-1;i>=0;i--){
		     if(s.charAt(i)<'0'||s.charAt(i)>'9')
			    num=false;
	        }
         }
	     return num;
    }


	
    protected void unbindVars() {
	var_ns = var_ns.parent();
    }

    protected void bindProgVars(HashSet progVars) {
	var_ns=new Namespace(var_ns);
	Iterator it=progVars.iterator();
	while (it.hasNext()) {
	    var_ns.add((ProgramVariable)it.next());
	}
    }

    protected void unbindProgVars() {
	var_ns = var_ns.parent();
    }

    protected static HashSet progVars(JavaBlock jb) {
	if (jb==JavaBlock.EMPTY_JAVABLOCK) {
		return new HashSet();
	}	
	ProgramVariableCollector pvc
	    = new ProgramVariableCollector(jb.program());
	pvc.start();
	return pvc.result();
    }


    protected Term termForParsedVariable(ParsableVariable v) 
	throws antlr.SemanticException 
	{

	    if ( v instanceof LogicVariable ) {
		return tf.createVariableTerm((LogicVariable)v);
	    } else if ( v instanceof ProgramVariable ) {
		return tf.createVariableTerm((ProgramVariable)v);
	    } else if ( v instanceof Metavariable ) {
		return tf.createFunctionTerm((Metavariable)v);
	    } else {
		throw new antlr.SemanticException(
						  ""+ v +" is not a logic variable");
	    }
	}

      

    protected JavaBlock getJavaBlock(Token t) throws antlr.SemanticException {
	String s=t.getText();
	try {
		return javaReader.readBlockWithProgramVariables(var_ns, s);
	} catch (de.uka.ilkd.key.java.PosConvertException e) {
		  lineOffset=e.getLine()-1;
		  colOffset=e.getColumn()+1;
		  throw new JavaParserException(e.getMessage(), t, 
			getFilename(), lineOffset, colOffset);  		  				
	} catch (de.uka.ilkd.key.java.ConvertException e) {	
		if (e.parseException()!=null) {		  		  
		  lineOffset=e.parseException().currentToken.next.beginLine;		  		 
		  colOffset=e.parseException().currentToken.next.beginColumn;
		  e.parseException().currentToken.next.beginLine=getLine()-1;
		  e.parseException().currentToken.next.beginColumn=getColumn();
		  throw new JavaParserException(e.parseException().getMessage(), t, 
			getFilename(), -1, -1);  // row/columns already in text
		}		
		throw new JavaParserException(e.getMessage(), t, getFilename(), 0, 1);
	}
    }


protected TermParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public TermParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected TermParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public TermParser(TokenStream lexer) {
  this(lexer,2);
}

public TermParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final void top() throws RecognitionException, TokenStreamException {
		
		Term t;
		
		t=formula();
	}
	
	public final Term  formula() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		a=term();
		if ( inputState.guessing==0 ) {
			
						if ( a.sort() != Sort.FORMULA ) {
							throw new antlr.SemanticException(
								"Just Parsed a Term where a Formula was expected");
						}
					
		}
		return a;
	}
	
	public final Term  term() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		a=term20();
		return a;
	}
	
	public final Term  term20() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Term a1;
		
		a=term30();
		{
		switch ( LA(1)) {
		case EQV:
		{
			match(EQV);
			a1=term20();
			if ( inputState.guessing==0 ) {
				a = tf.createJunctorTerm(Op.EQV,new Term[]{a,a1});
			}
			break;
		}
		case EOF:
		case WARY_ALL:
		case WARY_EX:
		case COMMA:
		case RPAREN:
		case RBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return a;
	}
	
	public final Term  term30() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Term a1;
		
		a=term40();
		{
		switch ( LA(1)) {
		case IMP:
		{
			match(IMP);
			a1=term30();
			if ( inputState.guessing==0 ) {
				a = tf.createJunctorTerm(Op.IMP,new Term[]{a,a1});
			}
			break;
		}
		case EOF:
		case WARY_ALL:
		case WARY_EX:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case EQV:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return a;
	}
	
	public final Term  term40() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Term a1;
		
		a=term50();
		{
		switch ( LA(1)) {
		case OR:
		{
			match(OR);
			a1=term40();
			if ( inputState.guessing==0 ) {
				a = tf.createJunctorTerm(Op.OR, new Term[]{a,a1});
			}
			break;
		}
		case EOF:
		case WARY_ALL:
		case WARY_EX:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case IMP:
		case EQV:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return a;
	}
	
	public final Term  term50() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Term a1;
		
		a=term60();
		{
		switch ( LA(1)) {
		case AND:
		{
			match(AND);
			a1=term50();
			if ( inputState.guessing==0 ) {
				a = tf.createJunctorTerm(Op.AND,new Term[]{a,a1});
			}
			break;
		}
		case EOF:
		case WARY_ALL:
		case WARY_EX:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case OR:
		case IMP:
		case EQV:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return a;
	}
	
	public final Term  term60() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		Term a1,a2;
			Sort s;
		
		
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		case LBRACE:
		{
			a=bindingterm();
			break;
		}
		case DIAMOND:
		case BOX:
		{
			a=dl_term();
			break;
		}
		case NOT:
		{
			match(NOT);
			a1=term60();
			if ( inputState.guessing==0 ) {
				a = tf.createJunctorTerm(Op.NOT,new Term[]{a1});
			}
			break;
		}
		case CTRL:
		{
			match(CTRL);
			a1=term60();
			if ( inputState.guessing==0 ) {
				a = tf.createJunctorTerm(Op.CTRL,new Term[]{a1});
			}
			break;
		}
		default:
			boolean synPredMatched15 = false;
			if (((LA(1)==LPAREN) && (_tokenSet_0.member(LA(2))))) {
				int _m15 = mark();
				synPredMatched15 = true;
				inputState.guessing++;
				try {
					{
					match(LPAREN);
					match(IDENT);
					{
					switch ( LA(1)) {
					case COMMA:
					{
						match(COMMA);
						match(IDENT);
						match(COLON);
						match(IDENT);
						break;
					}
					case GUARD:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					match(GUARD);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched15 = false;
				}
				rewind(_m15);
				inputState.guessing--;
			}
			if ( synPredMatched15 ) {
				a=condterm();
			}
			else if ((_tokenSet_0.member(LA(1))) && (_tokenSet_1.member(LA(2)))) {
				a=term70();
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return a;
	}
	
	public final Term  condterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Term cond1_1 = null;
		Term cond1_2 = null;
		Term cond2_1 = null;
		Term cond2_2 = null;
		Term c_then = null;
		Term c_else = null;
		ParsableVariable v=null;
		
		
		boolean synPredMatched27 = false;
		if (((LA(1)==LPAREN) && (_tokenSet_0.member(LA(2))))) {
			int _m27 = mark();
			synPredMatched27 = true;
			inputState.guessing++;
			try {
				{
				match(LPAREN);
				term80();
				match(COMMA);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched27 = false;
			}
			rewind(_m27);
			inputState.guessing--;
		}
		if ( synPredMatched27 ) {
			{
			match(LPAREN);
			cond1_1=term80();
			match(COMMA);
			cond1_2=term80();
			match(COLON);
			c_else=term60();
			match(GUARD);
			cond2_1=term80();
			match(COMMA);
			cond2_2=term80();
			match(COLON);
			c_then=term60();
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				
					a = tf.createConjCondTerm(new Term[]{cond1_1, cond1_2, c_else, 
					  cond2_1, cond2_2, c_then});
				
			}
			}
		}
		else if ((LA(1)==LPAREN) && (_tokenSet_0.member(LA(2)))) {
			match(LPAREN);
			cond1_1=term80();
			match(GUARD);
			cond2_1=term80();
			match(RPAREN);
			{
			switch ( LA(1)) {
			case DOT:
			{
				match(DOT);
				v=var_id();
				match(CONDUP);
				c_then=term60();
				if ( inputState.guessing==0 ) {
					
							  a = tf.createIfElseTerm((ProgramVariable)v, cond1_1, 
										  cond2_1, c_then);
						
				}
				break;
			}
			case FORALL:
			case EXISTS:
			case TRUE:
			case FALSE:
			case NOT:
			case IN_TYPE:
			case IS_OBJECT:
			case IS_CLONABLE:
			case META_IN_LONG:
			case META_IN_INT:
			case META_IN_CHAR:
			case META_IN_SHORT:
			case META_IN_BYTE:
			case META_ADD:
			case META_SUB:
			case META_MUL:
			case META_DIV:
			case META_MOD:
			case META_LESS:
			case META_GREATER:
			case META_LEQ:
			case META_GEQ:
			case META_EQ:
			case META_INT_UNARY_MINUS:
			case META_INT_ADD:
			case META_INT_SUB:
			case META_INT_MUL:
			case META_INT_DIV:
			case META_INT_MOD:
			case META_INT_AND:
			case META_INT_OR:
			case META_INT_XOR:
			case META_INT_COMPLEMENT:
			case META_INT_SHIFTRIGHT:
			case META_INT_SHIFTLEFT:
			case META_INT_UNSIGNEDSHIFTRIGHT:
			case META_LONG_UNARY_MINUS:
			case META_LONG_ADD:
			case META_LONG_SUB:
			case META_LONG_MUL:
			case META_LONG_DIV:
			case META_LONG_MOD:
			case META_LONG_AND:
			case META_LONG_OR:
			case META_LONG_XOR:
			case META_LONG_COMPLEMENT:
			case META_LONG_SHIFTRIGHT:
			case META_LONG_SHIFTLEFT:
			case META_LONG_UNSIGNEDSHIFTRIGHT:
			case META_MODULO_BYTE:
			case META_MODULO_SHORT:
			case META_MODULO_INTEGER:
			case META_MODULO_LONG:
			case STATIC_ANALYSIS:
			case META_LENGTH:
			case LPAREN:
			case LBRACE:
			case AT:
			case CTRL:
			case ARITH_OP:
			case CHAR_LITERAL:
			case DIAMOND:
			case BOX:
			case IDENT:
			{
				c_then=term60();
				match(COLON);
				c_else=term60();
				if ( inputState.guessing==0 ) {
					
							  a = tf.createIfElseTerm(cond1_1, cond2_1, c_then, c_else);
							
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		return a;
	}
	
	public final Term  term70() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Term a1;
		
		a=term80();
		{
		switch ( LA(1)) {
		case EQUALS:
		{
			match(EQUALS);
			a1=term80();
			if ( inputState.guessing==0 ) {
				a = tf.createEqualityTerm(a,a1);
			}
			break;
		}
		case EOF:
		case GUARD:
		case WARY_ALL:
		case WARY_EX:
		case COLON:
		case ASSIGN:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACKET:
		case OR:
		case AND:
		case IMP:
		case EQV:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return a;
	}
	
	public final Term  bindingterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		a=local_bindingterm();
		return a;
	}
	
	public final Term  dl_term() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		a=normal_dl_term();
		return a;
	}
	
	public final Term  term80() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case AT:
			{
				match(AT);
				a=abbreviation();
				break;
			}
			case ARITH_OP:
			{
				match(ARITH_OP);
				if ( inputState.guessing==0 ) {
					minus = !minus; a=term80();
				}
				break;
			}
			case LPAREN:
			{
				match(LPAREN);
				a=term();
				match(RPAREN);
				break;
			}
			case TRUE:
			{
				match(TRUE);
				if ( inputState.guessing==0 ) {
					a = tf.createJunctorTerm(Op.TRUE);
				}
				break;
			}
			case FALSE:
			{
				match(FALSE);
				if ( inputState.guessing==0 ) {
					a = tf.createJunctorTerm(Op.FALSE);
				}
				break;
			}
			default:
				boolean synPredMatched22 = false;
				if (((_tokenSet_2.member(LA(1))) && (_tokenSet_3.member(LA(2))))) {
					int _m22 = mark();
					synPredMatched22 = true;
					inputState.guessing++;
					try {
						{
						match(IDENT);
						{
						_loop21:
						do {
							if ((LA(1)==LBRACKET)) {
								match(LBRACKET);
								funcpredvarterm();
								match(RBRACKET);
							}
							else {
								break _loop21;
							}
							
						} while (true);
						}
						match(DOT);
						match(IDENT);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched22 = false;
					}
					rewind(_m22);
					inputState.guessing--;
				}
				if ( synPredMatched22 ) {
					a=attrterm();
				}
				else if ((_tokenSet_2.member(LA(1))) && (_tokenSet_4.member(LA(2)))) {
					a=funcpredvarterm();
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
				throw new RecognitionException("Not a valid logical term.\n"+ex.toString());
				
			} else {
				throw ex;
			}
		}
		return a;
	}
	
	public final Term  funcpredvarterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
			Operator vf;
			int n = 0;
			Vector al = null;
			Term t;
			Sort as=null;
		
		
		{
		switch ( LA(1)) {
		case IN_TYPE:
		case IS_OBJECT:
		case IS_CLONABLE:
		case META_IN_LONG:
		case META_IN_INT:
		case META_IN_CHAR:
		case META_IN_SHORT:
		case META_IN_BYTE:
		case META_ADD:
		case META_SUB:
		case META_MUL:
		case META_DIV:
		case META_MOD:
		case META_LESS:
		case META_GREATER:
		case META_LEQ:
		case META_GEQ:
		case META_EQ:
		case META_INT_UNARY_MINUS:
		case META_INT_ADD:
		case META_INT_SUB:
		case META_INT_MUL:
		case META_INT_DIV:
		case META_INT_MOD:
		case META_INT_AND:
		case META_INT_OR:
		case META_INT_XOR:
		case META_INT_COMPLEMENT:
		case META_INT_SHIFTRIGHT:
		case META_INT_SHIFTLEFT:
		case META_INT_UNSIGNEDSHIFTRIGHT:
		case META_LONG_UNARY_MINUS:
		case META_LONG_ADD:
		case META_LONG_SUB:
		case META_LONG_MUL:
		case META_LONG_DIV:
		case META_LONG_MOD:
		case META_LONG_AND:
		case META_LONG_OR:
		case META_LONG_XOR:
		case META_LONG_COMPLEMENT:
		case META_LONG_SHIFTRIGHT:
		case META_LONG_SHIFTLEFT:
		case META_LONG_UNSIGNEDSHIFTRIGHT:
		case META_MODULO_BYTE:
		case META_MODULO_SHORT:
		case META_MODULO_INTEGER:
		case META_MODULO_LONG:
		case STATIC_ANALYSIS:
		case META_LENGTH:
		case IDENT:
		{
			if ( inputState.guessing==0 ) {
				
						String s=LT(0)+" ";
						s=LT(1)+" "; 
						s=LT(2)+" ";
						s=LT(3)+" ";        
						if(LT(1)!=null && isNumber(LT(1).getText())){
							if(LT(0)==null || LT(2)==null){
							    a=toZNotation(LT(1).getText(), minus);
							    minus=false;  		
							    match(IDENT);
							    return a;
							}else if(!LT(0).getText().equals("(")|| !LT(2).getText().equals("(")){ 
							    a=toZNotation(LT(1).getText(), minus);
							    minus=false;  		
							    match(IDENT);
							    return a;
							}
						}  
						
			}
			break;
		}
		case CHAR_LITERAL:
		{
			match(CHAR_LITERAL);
			if ( inputState.guessing==0 ) {
				
								String s=LT(0).getText();
								int intVal=0;
								if (s.length()==3) {
									intVal=(int)LT(0).getText().charAt(1);
								} else {
									try {
									intVal = Integer.parseInt(s.substring(3,s.length()-1),16);
									} catch (NumberFormatException ex) {
									 throw new KeYSemanticException
									   ("Expected '"+s+"' to be a character", LT(0), getFilename());
									} 		
								}
								t=toZNotation(""+intVal,false);
						     		vf = (Function) func_ns.lookup(new Name("C"));
								return a=tf.createFunctionTerm((Function)vf, t.sub(0));
							
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		vf=varfunc_id();
		{
		if (((LA(1)==LPAREN))&&( vf.arity() > 0 )) {
			match(LPAREN);
			t=term();
			if ( inputState.guessing==0 ) {
				
									al = new Vector();
									n=1;
									al.add(t);
								
			}
			{
			_loop59:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					t=term();
					if ( inputState.guessing==0 ) {
						
												n++;
												al.add(t);
											
					}
				}
				else {
					break _loop59;
				}
				
			} while (true);
			}
			match(RPAREN);
		}
		else if ((_tokenSet_5.member(LA(1)))) {
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		{
		boolean synPredMatched62 = false;
		if ((((LA(1)==LBRACKET))&&(vf instanceof ParsableVariable))) {
			int _m62 = mark();
			synPredMatched62 = true;
			inputState.guessing++;
			try {
				{
				match(LBRACKET);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched62 = false;
			}
			rewind(_m62);
			inputState.guessing--;
		}
		if ( synPredMatched62 ) {
			if ( inputState.guessing==0 ) {
				a = termForParsedVariable((ParsableVariable)vf);
			}
			if ( inputState.guessing==0 ) {
				as = a.sort();
			}
			if (!(as instanceof ArraySort || as == ProgramSVSort.VARIABLE))
			  throw new SemanticException("as instanceof ArraySort || as == ProgramSVSort.VARIABLE");
			{
			int _cnt64=0;
			_loop64:
			do {
				if ((LA(1)==LBRACKET)) {
					match(LBRACKET);
					t=term60();
					if ( inputState.guessing==0 ) {
						
						if (as!=null && as!=ProgramSVSort.VARIABLE){
						if (!(as instanceof ArraySort)){
						throw new NotDeclException
						("array "+vf.name()+" declared with a different"+
						" dimension than required here", vf.name().toString(), 
						getFilename(), getLine(), getColumn());
						} else {
						as = ((ArraySort) as).elementSort();
						} 
						}
						a=tf.createArrayTerm(Op.ARRAY,a,t);
						
					}
					match(RBRACKET);
				}
				else {
					if ( _cnt64>=1 ) { break _loop64; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt64++;
			} while (true);
			}
		}
		else if ((_tokenSet_6.member(LA(1)))) {
			if ( inputState.guessing==0 ) {
				if (vf instanceof ParsableVariable) {
						      a = termForParsedVariable((ParsableVariable)vf);
						    } else if (vf instanceof Function) {
							if ( al == null ) {	
								a = tf.createFunctionTerm((Function)vf);
							} else {
								a = tf.createFunctionTerm((Function)vf,
									   (Term[])al.toArray(AN_ARRAY_OF_TERMS));
								}
				
						    } else if (vf instanceof MetaOperator) {
				
							if ( al == null ) {	
								a = tf.createMetaTerm((MetaOperator)vf, new Term[0]);
							} else {	
								a = tf.createMetaTerm((MetaOperator)vf,
									   (Term[])al.toArray(AN_ARRAY_OF_TERMS));
							}
						    }
						    if (minus) {
					              Term[] t1 = new Term[1];
					      t1[0] = a;
					      vf = (Function) func_ns.lookup(new Name("~m"));
				a = tf.createFunctionTerm((Function)vf,t1);
				minus = false;
					    }	
					
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		return a;
	}
	
	public final Term  attrterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
			Vector vec=new Vector();
			ParsableVariable v=null;
			Term t=null;
			ParsableVariable v0=null;
		Sort so=null;
		
		
		
		{
		t=funcpredvarterm();
		if ( inputState.guessing==0 ) {
			so=t.sort();
			
		}
		{
		int _cnt53=0;
		_loop53:
		do {
			if ((LA(1)==DOT)) {
				match(DOT);
				v=attrid(so);
				if ( inputState.guessing==0 ) {
					vec.add(v); if(v!=null) so=v.sort();
				}
			}
			else {
				if ( _cnt53>=1 ) { break _loop53; } else {throw new NoViableAltException(LT(1), getFilename());}
			}
			
			_cnt53++;
		} while (true);
		}
		}
		if ( inputState.guessing==0 ) {
			
				for (int i=0; i<vec.size(); i++) {
					if(vec.get(i)!=null){
						t=tf.createAttributeTerm((ProgramVariable)vec.get(i), t);
					}
				}
				a=t;
			
		}
		return a;
	}
	
	public final Term  abbreviation() throws RecognitionException, TokenStreamException {
		Term a=null;
		
		
			String sc = null;
		
		
		{
		sc=id();
		if ( inputState.guessing==0 ) {
			
						a =  scm.getTerm(sc);
					    if(a==null){
							throw new NotDeclException
							("abbreviation", sc, 
							getFilename(), getLine(), getColumn());
						}
						
			
					
		}
		}
		return a;
	}
	
	public final String  id() throws RecognitionException, TokenStreamException {
		String name = null;
		
		Token  classID = null;
		Token  nameID = null;
		Token  pureID = null;
		
		boolean synPredMatched143 = false;
		if (((LA(1)==IDENT) && (LA(2)==COLON))) {
			int _m143 = mark();
			synPredMatched143 = true;
			inputState.guessing++;
			try {
				{
				match(IDENT);
				match(COLON);
				match(COLON);
				match(IDENT);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched143 = false;
			}
			rewind(_m143);
			inputState.guessing--;
		}
		if ( synPredMatched143 ) {
			classID = LT(1);
			match(IDENT);
			match(COLON);
			match(COLON);
			nameID = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				
							 name = classID.getText() + "::" + nameID.getText();
							
			}
		}
		else if ((LA(1)==IDENT) && (_tokenSet_7.member(LA(2)))) {
			pureID = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				name = pureID.getText();
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		return name;
	}
	
	public final ParsableVariable  var_id() throws RecognitionException, TokenStreamException {
		ParsableVariable v = null;
		
		Token  id = null;
		
		id = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			
						v = (ParsableVariable) var_ns.lookup(new Name(id.getText()));
						if (v == null) {
							throw new NotDeclException("variable", id, 
										   getFilename());
						}
					
		}
		return v;
	}
	
	public final Term  local_bindingterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Token  v0 = null;
		
			Operator op = null;
			LogicVariable v = null;
			Term a1;
			Sort s;
		
		
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		{
			{
			switch ( LA(1)) {
			case FORALL:
			{
				match(FORALL);
				if ( inputState.guessing==0 ) {
					op = Op.ALL;
				}
				break;
			}
			case EXISTS:
			{
				match(EXISTS);
				if ( inputState.guessing==0 ) {
					op = Op.EX;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			v0 = LT(1);
			match(IDENT);
			match(COLON);
			s=sort_id();
			match(DOT);
			if ( inputState.guessing==0 ) {
				v = bindVar(v0,s);
			}
			a1=term60();
			if ( inputState.guessing==0 ) {
				
							a = tf.createQuantifierTerm((Quantifier)op, v,a1);
							unbindVars();
						
			}
			break;
		}
		case LBRACE:
		{
			a=update_or_substitution();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return a;
	}
	
	public final Sort  sort_id() throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		s=sort_id_check(true);
		return s;
	}
	
	public final Term  update_or_substitution() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		
		
		
		boolean synPredMatched35 = false;
		if (((LA(1)==LBRACE) && (LA(2)==IDENT))) {
			int _m35 = mark();
			synPredMatched35 = true;
			inputState.guessing++;
			try {
				{
				match(LBRACE);
				match(IDENT);
				match(COLON);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched35 = false;
			}
			rewind(_m35);
			inputState.guessing--;
		}
		if ( synPredMatched35 ) {
			result=substitutionterm();
		}
		else if ((LA(1)==LBRACE) && (_tokenSet_2.member(LA(2)))) {
			result=updateterm();
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		return result;
	}
	
	public final Term  substitutionterm() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		Token  v1 = null;
		Sort s;
		LogicVariable v = null;
		Term a1, a2;
		boolean waryAll = false;
		boolean waryEx = false;
		
		
		match(LBRACE);
		v1 = LT(1);
		match(IDENT);
		match(COLON);
		s=sort_id();
		a1=term();
		{
		switch ( LA(1)) {
		case WARY_ALL:
		{
			match(WARY_ALL);
			if ( inputState.guessing==0 ) {
				waryAll = true;
			}
			break;
		}
		case WARY_EX:
		{
			match(WARY_EX);
			if ( inputState.guessing==0 ) {
				waryEx  = true;
			}
			break;
		}
		case RBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(RBRACE);
		if ( inputState.guessing==0 ) {
			v = bindVar(v1, s);
		}
		a2=term60();
		if ( inputState.guessing==0 ) {
			
					    if ( waryAll )
					        result = tf.createSubstitutionTerm ( Op.WARY_SUBST_ALL,
					                                             v, a1, a2 );
					    else if ( waryEx )
					        result = tf.createSubstitutionTerm ( Op.WARY_SUBST_EX,
					                                             v, a1, a2 );
					    else
					        result = tf.createSubstitutionTerm ( Op.SUBST,
					                                             v, a1, a2 );
					    unbindVars();
				      	
		}
		return result;
	}
	
	public final Term  updateterm() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		Token  v1 = null;
		
		Term a0 = null;
		Term a1, a2;
		TermSymbol pv;
		Vector subs = new Vector();
		Vector index = new Vector();
		ArraySort as;
		int n=0;
		
		
		match(LBRACE);
		{
		boolean synPredMatched43 = false;
		if (((_tokenSet_2.member(LA(1))) && (_tokenSet_3.member(LA(2))))) {
			int _m43 = mark();
			synPredMatched43 = true;
			inputState.guessing++;
			try {
				{
				match(IDENT);
				{
				_loop42:
				do {
					if ((LA(1)==LBRACKET)) {
						match(LBRACKET);
						funcpredvarterm();
						match(RBRACKET);
					}
					else {
						break _loop42;
					}
					
				} while (true);
				}
				match(DOT);
				match(IDENT);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched43 = false;
			}
			rewind(_m43);
			inputState.guessing--;
		}
		if ( synPredMatched43 ) {
			a0=attrterm();
		}
		else if ((LA(1)==IDENT) && (LA(2)==ASSIGN||LA(2)==LBRACKET)) {
			v1 = LT(1);
			match(IDENT);
			{
			_loop45:
			do {
				if ((LA(1)==LBRACKET)) {
					match(LBRACKET);
					a0=term80();
					match(RBRACKET);
					if ( inputState.guessing==0 ) {
						index.add(a0);n++;
					}
				}
				else {
					break _loop45;
				}
				
			} while (true);
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		match(ASSIGN);
		a1=term60();
		if ( inputState.guessing==0 ) {
			
							if(n>0){
						 		as=ArraySortImpl.getArraySort(a1.sort());
						    		for(int i=1;i<n;i++){
						        		as=ArraySortImpl.getArraySort(as);
						    		}
						    		pv = progVar(v1, as);
						    		a0 = tf.createFunctionTerm(pv);
						    		a0 = tf.createArrayTerm(Op.ARRAY,a0,(Term[])index.toArray(new Term[index.size()]));
						    		n=0;
								}else if (a0 == null){
									pv = progVar(v1,a1.sort());
									a0 = tf.createFunctionTerm(pv);
						     		}
						     
						     subs.add(a0); 
						     subs.add(a1); 
						
		}
		{
		_loop47:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				a0=term60();
				match(ASSIGN);
				a1=term60();
				if ( inputState.guessing==0 ) {
					subs.add(a0); subs.add(a1);
				}
			}
			else {
				break _loop47;
			}
			
		} while (true);
		}
		match(RBRACE);
		a2=term60();
		if ( inputState.guessing==0 ) {
			
					subs.add(a2);
					result = tf.createUpdateTerm((Term[])subs.toArray(new Term[subs.size()]));			
					subs = new Vector();
				
		}
		return result;
	}
	
	public final Term  normal_dl_term() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Token  d1 = null;
		Token  d2 = null;
			JavaBlock jb=null;
			Term a1;
		
		
		switch ( LA(1)) {
		case DIAMOND:
		{
			d1 = LT(1);
			match(DIAMOND);
			if ( inputState.guessing==0 ) {
				
							jb=getJavaBlock(d1);
							HashSet progVars=progVars(jb);
							bindProgVars(progVars);
						
			}
			a1=term60();
			if ( inputState.guessing==0 ) {
				
							a = tf.createDiamondTerm(jb, a1);
							unbindProgVars();
						
			}
			break;
		}
		case BOX:
		{
			d2 = LT(1);
			match(BOX);
			if ( inputState.guessing==0 ) {
				
							jb=getJavaBlock(d2);
							HashSet progVars=progVars(jb);
							bindProgVars(progVars);
						
			}
			a1=term60();
			if ( inputState.guessing==0 ) {
				
							a = tf.createBoxTerm(jb, a1);
							unbindProgVars();
						
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return a;
	}
	
	public final ParsableVariable  attrid(
		Sort s
	) throws RecognitionException, TokenStreamException {
		ParsableVariable v = null;
		
		Token  attr = null;
		
		
		
		
		attr = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			
			v = getJavaInfo().getAttribute(attr.getText(), (ObjectSort)s);
			if ( v == null && !("length").equals(attr.getText()) ) {
				throw new NotDeclException
					("Attribute ", attr.getText(),getFilename(), 
					  getLine(), getColumn());
			
			}
			
			
		}
		return v;
	}
	
	public final Operator  varfunc_id() throws RecognitionException, TokenStreamException {
		Operator v = null;
		
		
			String varfunc_name = null;
		
		
		{
		switch ( LA(1)) {
		case IN_TYPE:
		case IS_OBJECT:
		case IS_CLONABLE:
		{
			v=expr_op();
			break;
		}
		case IDENT:
		{
			varfunc_name=id();
			if ( inputState.guessing==0 ) {
				
							v = (TermSymbol) var_ns.lookup(new Name(varfunc_name));
							if (v == null) {
							   v = (Function) func_ns.lookup(new Name(varfunc_name));
							   if(v==null) {
					v = (ProgramVariable)
					getJavaInfo().programVariables().lookup(
					new Name(varfunc_name));
				if(v==null) {
									throw new NotDeclException
									("variable or function", varfunc_name, 
									getFilename(), getLine(), getColumn());
				}
							   }
							}
				
						
			}
			break;
		}
		case META_INT_UNARY_MINUS:
		{
			match(META_INT_UNARY_MINUS);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_UNARY_MINUS ;
			}
			break;
		}
		case META_LONG_UNARY_MINUS:
		{
			match(META_LONG_UNARY_MINUS);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_UNARY_MINUS ;
			}
			break;
		}
		case META_ADD:
		{
			match(META_ADD);
			if ( inputState.guessing==0 ) {
				v = Op.META_ADD;
			}
			break;
		}
		case META_SUB:
		{
			match(META_SUB);
			if ( inputState.guessing==0 ) {
				v = Op.META_SUB;
			}
			break;
		}
		case META_MUL:
		{
			match(META_MUL);
			if ( inputState.guessing==0 ) {
				v = Op.META_MUL;
			}
			break;
		}
		case META_DIV:
		{
			match(META_DIV);
			if ( inputState.guessing==0 ) {
				v = Op.META_DIV;
			}
			break;
		}
		case META_MOD:
		{
			match(META_MOD);
			if ( inputState.guessing==0 ) {
				v = Op.META_MOD;
			}
			break;
		}
		case META_LESS:
		{
			match(META_LESS);
			if ( inputState.guessing==0 ) {
				v = Op.META_LESS;
			}
			break;
		}
		case META_GREATER:
		{
			match(META_GREATER);
			if ( inputState.guessing==0 ) {
				v = Op.META_GREATER;
			}
			break;
		}
		case META_LEQ:
		{
			match(META_LEQ);
			if ( inputState.guessing==0 ) {
				v = Op.META_LEQ;
			}
			break;
		}
		case META_GEQ:
		{
			match(META_GEQ);
			if ( inputState.guessing==0 ) {
				v = Op.META_GEQ;
			}
			break;
		}
		case META_EQ:
		{
			match(META_EQ);
			if ( inputState.guessing==0 ) {
				v = Op.META_EQ;
			}
			break;
		}
		case META_INT_ADD:
		{
			match(META_INT_ADD);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_ADD;
			}
			break;
		}
		case META_INT_SUB:
		{
			match(META_INT_SUB);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_SUB;
			}
			break;
		}
		case META_INT_MUL:
		{
			match(META_INT_MUL);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_MUL;
			}
			break;
		}
		case META_INT_DIV:
		{
			match(META_INT_DIV);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_DIV;
			}
			break;
		}
		case META_INT_MOD:
		{
			match(META_INT_MOD);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_MOD;
			}
			break;
		}
		case META_INT_AND:
		{
			match(META_INT_AND);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_AND;
			}
			break;
		}
		case META_INT_OR:
		{
			match(META_INT_OR);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_OR;
			}
			break;
		}
		case META_INT_XOR:
		{
			match(META_INT_XOR);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_XOR;
			}
			break;
		}
		case META_INT_COMPLEMENT:
		{
			match(META_INT_COMPLEMENT);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_COMPLEMENT;
			}
			break;
		}
		case META_INT_SHIFTRIGHT:
		{
			match(META_INT_SHIFTRIGHT);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_SHIFTRIGHT;
			}
			break;
		}
		case META_INT_SHIFTLEFT:
		{
			match(META_INT_SHIFTLEFT);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_SHIFTLEFT;
			}
			break;
		}
		case META_INT_UNSIGNEDSHIFTRIGHT:
		{
			match(META_INT_UNSIGNEDSHIFTRIGHT);
			if ( inputState.guessing==0 ) {
				v = Op.META_INT_UNSIGNEDSHIFTRIGHT;
			}
			break;
		}
		case META_LONG_ADD:
		{
			match(META_LONG_ADD);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_ADD;
			}
			break;
		}
		case META_LONG_SUB:
		{
			match(META_LONG_SUB);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_SUB;
			}
			break;
		}
		case META_LONG_MUL:
		{
			match(META_LONG_MUL);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_MUL;
			}
			break;
		}
		case META_LONG_DIV:
		{
			match(META_LONG_DIV);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_DIV;
			}
			break;
		}
		case META_LONG_MOD:
		{
			match(META_LONG_MOD);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_MOD;
			}
			break;
		}
		case META_LONG_AND:
		{
			match(META_LONG_AND);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_AND;
			}
			break;
		}
		case META_LONG_OR:
		{
			match(META_LONG_OR);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_OR;
			}
			break;
		}
		case META_LONG_XOR:
		{
			match(META_LONG_XOR);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_XOR;
			}
			break;
		}
		case META_LONG_COMPLEMENT:
		{
			match(META_LONG_COMPLEMENT);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_COMPLEMENT;
			}
			break;
		}
		case META_LONG_SHIFTRIGHT:
		{
			match(META_LONG_SHIFTRIGHT);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_SHIFTRIGHT;
			}
			break;
		}
		case META_LONG_SHIFTLEFT:
		{
			match(META_LONG_SHIFTLEFT);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_SHIFTLEFT;
			}
			break;
		}
		case META_LONG_UNSIGNEDSHIFTRIGHT:
		{
			match(META_LONG_UNSIGNEDSHIFTRIGHT);
			if ( inputState.guessing==0 ) {
				v = Op.META_LONG_UNSIGNEDSHIFTRIGHT;
			}
			break;
		}
		case META_IN_LONG:
		{
			match(META_IN_LONG);
			if ( inputState.guessing==0 ) {
				v = Op.META_IN_LONG;
			}
			break;
		}
		case META_IN_INT:
		{
			match(META_IN_INT);
			if ( inputState.guessing==0 ) {
				v = Op.META_IN_INT;
			}
			break;
		}
		case META_IN_CHAR:
		{
			match(META_IN_CHAR);
			if ( inputState.guessing==0 ) {
				v = Op.META_IN_CHAR;
			}
			break;
		}
		case META_IN_SHORT:
		{
			match(META_IN_SHORT);
			if ( inputState.guessing==0 ) {
				v = Op.META_IN_SHORT;
			}
			break;
		}
		case META_IN_BYTE:
		{
			match(META_IN_BYTE);
			if ( inputState.guessing==0 ) {
				v = Op.META_IN_BYTE;
			}
			break;
		}
		case META_MODULO_BYTE:
		{
			match(META_MODULO_BYTE);
			if ( inputState.guessing==0 ) {
				v = Op.META_MODULO_BYTE;
			}
			break;
		}
		case META_MODULO_SHORT:
		{
			match(META_MODULO_SHORT);
			if ( inputState.guessing==0 ) {
				v = Op.META_MODULO_SHORT;
			}
			break;
		}
		case META_MODULO_INTEGER:
		{
			match(META_MODULO_INTEGER);
			if ( inputState.guessing==0 ) {
				v = Op.META_MODULO_INTEGER;
			}
			break;
		}
		case META_MODULO_LONG:
		{
			match(META_MODULO_LONG);
			if ( inputState.guessing==0 ) {
				v = Op.META_MODULO_LONG;
			}
			break;
		}
		case STATIC_ANALYSIS:
		{
			match(STATIC_ANALYSIS);
			if ( inputState.guessing==0 ) {
				v = Op.STATIC_ANALYSIS;
			}
			break;
		}
		case META_LENGTH:
		{
			match(META_LENGTH);
			if ( inputState.guessing==0 ) {
				v = Op.META_LENGTH;
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return v;
	}
	
	public final Operator  expr_op() throws RecognitionException, TokenStreamException {
		Operator v = null;
		
		Token  id = null;
		Token  id1 = null;
		Token  id2 = null;
		
			ParsableVariable left_var0 = null;
			ParsableVariable right_var0 = null;
			ParsableVariable unary_var0 = null;
		
		
		switch ( LA(1)) {
		case IN_TYPE:
		{
			match(IN_TYPE);
			match(LPAREN);
			{
			switch ( LA(1)) {
			case IDENT:
			{
				{
				left_var0=var_id();
				{
				switch ( LA(1)) {
				case SLASH:
				case ARITH_OP:
				case IDENT:
				{
					{
					switch ( LA(1)) {
					case ARITH_OP:
					{
						id = LT(1);
						match(ARITH_OP);
						break;
					}
					case SLASH:
					{
						id1 = LT(1);
						match(SLASH);
						break;
					}
					case IDENT:
					{
						id2 = LT(1);
						match(IDENT);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					right_var0=var_id();
					break;
				}
				case RPAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
				break;
			}
			case 187:
			{
				{
				match(187);
				unary_var0=var_id();
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				
				if (id==null) id=id1;	
					   if (unary_var0!=null) {
					      // can only be unary minus
					      SchemaVariable unary_var = (SchemaVariable) unary_var0;
					      Sort type = de.uka.ilkd.key.logic.sort.Sort.FORMULA;
					      return new InTypeOperator
						(type, new de.uka.ilkd.key.java.expression.operator.Negative(unary_var));
					   }
					   else {
					      SchemaVariable left_var = (SchemaVariable) left_var0;
					      Sort type = de.uka.ilkd.key.logic.sort.Sort.FORMULA;
					      if (right_var0 != null) {
					         SchemaVariable right_var = (SchemaVariable) right_var0;
					         String op_str = (id == null ? id2.getText() : id.getText());
					   if ("+".equals(op_str)) {
						     return new InTypeOperator
						       (type, new de.uka.ilkd.key.java.expression.operator.Plus(left_var, right_var));
					         } else if ("-".equals(op_str)) {
						     return new InTypeOperator
						       (type, new de.uka.ilkd.key.java.expression.operator.Minus(left_var, right_var));
					         } else if ("*".equals(op_str)) {
						     return new InTypeOperator
						       (type, new de.uka.ilkd.key.java.expression.operator.Times(left_var, right_var));
					         } else if ("/".equals(op_str)) {
					    	     return new InTypeOperator
						       (type, new de.uka.ilkd.key.java.expression.operator.Divide(left_var, right_var));
						} else if ("%".equals(op_str)) {
					    	     return new InTypeOperator
						       (type, new de.uka.ilkd.key.java.expression.operator.Modulo(left_var, right_var));
					         } 
					      }
					      else {
					         return new InTypeOperator(type, left_var);
					      }
					   }
					
			}
			break;
		}
		case IS_OBJECT:
		{
			match(IS_OBJECT);
			match(LPAREN);
			{
			left_var0=var_id();
			}
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				
					   SchemaVariable var = (SchemaVariable) left_var0;
					   return new IsObject(de.uka.ilkd.key.logic.sort.Sort.FORMULA, var);
					
			}
			break;
		}
		case IS_CLONABLE:
		{
			match(IS_CLONABLE);
			match(LPAREN);
			{
			left_var0=var_id();
			}
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				
					   SchemaVariable var = (SchemaVariable) left_var0;
					   return new IsClonable(de.uka.ilkd.key.logic.sort.Sort.FORMULA, var);
					
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return v;
	}
	
	public final void decls() throws RecognitionException, TokenStreamException {
		
		
		{
		_loop78:
		do {
			switch ( LA(1)) {
			case SORTS:
			{
				sort_decls();
				break;
			}
			case SCHEMA:
			{
				schema_var_decls();
				break;
			}
			case PROGRAM:
			{
				prog_var_decls();
				break;
			}
			case PREDICATES:
			{
				pred_decls();
				break;
			}
			case FUNCTIONS:
			{
				func_decls();
				break;
			}
			case HEURISTICS:
			{
				heur_decls();
				break;
			}
			default:
			{
				break _loop78;
			}
			}
		} while (true);
		}
	}
	
	public final void sort_decls() throws RecognitionException, TokenStreamException {
		
		
		boolean isObjectSort=false;
		boolean isGenericSort=false;
		Sort[] sortExt=new Sort [0];
		Sort[] sortOneOf=new Sort [0];
		ListOfName sort_ids;
		
		
		match(SORTS);
		match(LBRACE);
		{
		_loop84:
		do {
			if ((LA(1)==OBJECT||LA(1)==GENERIC||LA(1)==IDENT)) {
				if ( inputState.guessing==0 ) {
					
						       isObjectSort=false; 
						       isGenericSort=false; 
						       sortExt = new Sort[0];
						       sortOneOf = new Sort[0];
						
				}
				{
				switch ( LA(1)) {
				case OBJECT:
				{
					match(OBJECT);
					if ( inputState.guessing==0 ) {
						isObjectSort=true;
					}
					sort_ids=sort_identifiers();
					break;
				}
				case GENERIC:
				{
					match(GENERIC);
					if ( inputState.guessing==0 ) {
						isGenericSort=true;
					}
					sort_ids=sort_identifiers();
					{
					switch ( LA(1)) {
					case ONEOF:
					{
						match(ONEOF);
						sortOneOf=oneof_sorts();
						break;
					}
					case EXTENDS:
					case SEMI:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					{
					switch ( LA(1)) {
					case EXTENDS:
					{
						match(EXTENDS);
						sortExt=extends_sorts();
						break;
					}
					case SEMI:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					break;
				}
				case IDENT:
				{
					sort_ids=sort_identifiers();
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SEMI);
				if ( inputState.guessing==0 ) {
					
						    Name           sort_name;
						    IteratorOfName it         = sort_ids.iterator ();
						    while ( it.hasNext () ) {
						    sort_name = it.next ();
					
						    if (sort_ns.lookup(sort_name) == null) {
							Sort s;
							if (isObjectSort) {
							    if ("Object".equals(sort_name)) {
								if (sort_ns.lookup(new Name("Object"))
								    ==null) {
					
								    s = new ClassInstanceSortImpl(sort_name);
								}
								s=(Sort)sort_ns.lookup(new Name("Object"));
							    } else {
								s = new ClassInstanceSortImpl(sort_name, 
											      (Sort)sort_ns.lookup
											      (new Name("Object")));
							    }	
							} else if (isGenericSort) {
							    int        i;
							    SetOfSort  ext   = GenericSort.EMPTY_SORT_SET;
							    SetOfSort  oneOf = GenericSort.EMPTY_SORT_SET;
					
							    for ( i = 0; i != sortExt.length; ++i )
							        ext = ext.add ( sortExt[i] );
					
							    for ( i = 0; i != sortOneOf.length; ++i )
							        oneOf = oneOf.add ( sortOneOf[i] );
					
							    try {
							        s = new GenericSort ( sort_name,
							                              ext,
							                              oneOf );
							    } catch ( GenericSupersortException e ) {
							        throw new GenericSortException ( "sort",
							                   "Illegal sort given", e.getIllegalSort (),
							                   getFilename (), getLine (), getColumn () );
							    }
							} else {
							    s = new PrimitiveSort(sort_name);
							}
							sort_ns.add(s);
							if (s instanceof NonCollectionSort) {
							    NonCollectionSort ns
								= (NonCollectionSort)s;
							    sort_ns.add(ns.getSetSort());
							    sort_ns.add(ns.getSequenceSort());
							    sort_ns.add(ns.getBagSort());
							}
							if ( s instanceof SortDefiningSymbols )
							    ((SortDefiningSymbols)s).createSymbols ( func_ns, sort_ns );
						    }
					
						    }
						
				}
			}
			else {
				break _loop84;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void schema_var_decls() throws RecognitionException, TokenStreamException {
		
		
			Sort s = null;
			boolean makeVariableSV  = false;
			boolean makeDependingSV = false; // skolem functions
			boolean rigid           = false;
			boolean listModifier    = false;
		
		
		match(SCHEMA);
		match(VARIABLES);
		match(LBRACE);
		{
		_loop113:
		do {
			if ((LA(1)==PROGRAM||LA(1)==FORMULA||LA(1)==IDENT)) {
				if ( inputState.guessing==0 ) {
					makeVariableSV = false; makeDependingSV = false; rigid = false; listModifier=false;
				}
				{
				switch ( LA(1)) {
				case PROGRAM:
				{
					{
					match(PROGRAM);
					{
					switch ( LA(1)) {
					case SVLIST:
					{
						match(SVLIST);
						if ( inputState.guessing==0 ) {
							listModifier=true;
						}
						break;
					}
					case ARRAY:
					case STATEMENT:
					case EXPRESSION:
					case STATEMENTEXPRESSION:
					case BRANCH:
					case NONSIMPLE:
					case LEFTHANDSIDE:
					case SIMPLE:
					case LOOPINIT:
					case GUARD:
					case FORUPDATES:
					case TYPE:
					case JAVABOOL:
					case VARIABLE:
					case SWITCH:
					case BOOLEANVARIABLE:
					case CATCH:
					case METHODREFERENCE:
					case SPECIAL:
					case CLASSTYPE:
					case INTERFACETYPE:
					case ARRAYTYPE:
					case METHODBODY:
					case VARIABLEINIT:
					case LABEL:
					case MULTIPLEVARDECL:
					case NEW:
					case IMPLICIT:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					{
					switch ( LA(1)) {
					case STATEMENT:
					{
						match(STATEMENT);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.STATEMENT;
												
						}
						break;
					}
					case EXPRESSION:
					{
						match(EXPRESSION);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.EXPRESSION;
												
						}
						break;
					}
					case MULTIPLEVARDECL:
					{
						match(MULTIPLEVARDECL);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.MULTIPLEVARDECL;
												
						}
						break;
					}
					case JAVABOOL:
					{
						match(JAVABOOL);
						match(EXPRESSION);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.BOOLEANEXPRESSION;
												
						}
						break;
					}
					case LEFTHANDSIDE:
					{
						match(LEFTHANDSIDE);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.LEFTHANDSIDE;
												
						}
						break;
					}
					case LOOPINIT:
					{
						match(LOOPINIT);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.LOOPINIT;
												
						}
						break;
					}
					case GUARD:
					{
						match(GUARD);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.GUARD;
												
						}
						break;
					}
					case FORUPDATES:
					{
						match(FORUPDATES);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.FORUPDATES;
												
						}
						break;
					}
					case STATEMENTEXPRESSION:
					{
						match(STATEMENTEXPRESSION);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.STATEMENTEXPRESSION;
												
						}
						break;
					}
					case LABEL:
					{
						match(LABEL);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.LABEL;
												
						}
						break;
					}
					case TYPE:
					{
						match(TYPE);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.TYPE;
												
						}
						break;
					}
					case VARIABLE:
					{
						match(VARIABLE);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.VARIABLE;
												
						}
						break;
					}
					case VARIABLEINIT:
					{
						match(VARIABLEINIT);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.VARIABLEINIT;
												
						}
						break;
					}
					case SWITCH:
					{
						match(SWITCH);
						if ( inputState.guessing==0 ) {
							
									 	s=ProgramSVSort.SWITCH;
										
						}
						break;
					}
					case BOOLEANVARIABLE:
					{
						{
						match(BOOLEANVARIABLE);
						}
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.BOOLEANVARIABLE;
												
						}
						break;
					}
					case CATCH:
					{
						{
						match(CATCH);
						}
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.CATCH;
												
						}
						break;
					}
					case METHODREFERENCE:
					{
						{
						match(METHODREFERENCE);
						}
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.METHODREFERENCE;
												
						}
						break;
					}
					case SPECIAL:
					{
						match(SPECIAL);
						match(CONSTRUCTORREFERENCE);
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.SPECIALCONSTRUCTORREFERENCE;				
												
						}
						break;
					}
					case ARRAYTYPE:
					{
						{
						match(ARRAYTYPE);
						}
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.ARRAYTYPE;
												
						}
						break;
					}
					case METHODBODY:
					{
						{
						match(METHODBODY);
						}
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.METHODBODY;
												
						}
						break;
					}
					case BRANCH:
					{
						{
						match(BRANCH);
						}
						if ( inputState.guessing==0 ) {
							
													s=ProgramSVSort.BRANCH;
												
						}
						break;
					}
					default:
						if ((LA(1)==SIMPLE) && (LA(2)==EXPRESSION)) {
							match(SIMPLE);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVABOOL)) {
							match(SIMPLE);
							match(JAVABOOL);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVABOOLEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVABYTE)) {
							match(SIMPLE);
							match(JAVABYTE);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVABYTEEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVACHAR)) {
							match(SIMPLE);
							match(JAVACHAR);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVACHAREXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVASHORT)) {
							match(SIMPLE);
							match(JAVASHORT);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVASHORTEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVAINT)) {
							match(SIMPLE);
							match(JAVAINT);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVAINTEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVALONG)) {
							match(SIMPLE);
							match(JAVALONG);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVALONGEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVABYTESHORTINT)) {
							match(SIMPLE);
							match(JAVABYTESHORTINT);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEJAVABYTESHORTINTEXPRESSION;
													
							}
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==ANYJAVATYPE)) {
							match(SIMPLE);
							match(ANYJAVATYPE);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.SIMPLEANYJAVATYPEEXPRESSION;
													
							}
						}
						else if ((LA(1)==CLASSTYPE) && (LA(2)==EXPRESSION)) {
							match(CLASSTYPE);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.CLASSTYPEEXPRESSION;
													
							}
						}
						else if ((LA(1)==INTERFACETYPE) && (LA(2)==EXPRESSION)) {
							match(INTERFACETYPE);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.INTERFACETYPEEXPRESSION;
													
							}
						}
						else if ((LA(1)==NONSIMPLE) && (LA(2)==EXPRESSION)) {
							match(NONSIMPLE);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.NONSIMPLEEXPRESSION;
													
							}
						}
						else if ((LA(1)==NONSIMPLE) && (LA(2)==JAVABOOL)) {
							match(NONSIMPLE);
							match(JAVABOOL);
							match(EXPRESSION);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.NONSIMPLEBOOLEANEXPRESSION;
													
							}
						}
						else if ((LA(1)==IMPLICIT) && (LA(2)==NEXT)) {
							match(IMPLICIT);
							match(NEXT);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.IMPLICITNEXT;
													
							}
						}
						else if ((LA(1)==IMPLICIT) && (LA(2)==REFERENCE)) {
							match(IMPLICIT);
							match(REFERENCE);
							match(FIELD);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.IMPLICITREFERENCE;
													
							}
						}
						else if ((LA(1)==NEW) && (LA(2)==IDENT)) {
							match(NEW);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.NEW;
													
							}
						}
						else if ((LA(1)==NEW) && (LA(2)==ARRAY)) {
							match(NEW);
							match(ARRAY);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.NEWARRAY;
													
							}
						}
						else if ((LA(1)==ARRAY) && (LA(2)==INITIALIZER)) {
							match(ARRAY);
							match(INITIALIZER);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.ARRAYINITIALIZER;
													
							}
						}
						else if ((LA(1)==ARRAY) && (LA(2)==LENGTH)) {
							match(ARRAY);
							match(LENGTH);
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.ARRAYLENGTH;
													
							}
						}
						else if ((LA(1)==CLASSTYPE) && (LA(2)==IDENT)) {
							{
							match(CLASSTYPE);
							}
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.CLASSTYPE;
													
							}
						}
						else if ((LA(1)==INTERFACETYPE) && (LA(2)==IDENT)) {
							{
							match(INTERFACETYPE);
							}
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.INTERFACETYPE;
													
							}
						}
						else if ((LA(1)==ARRAY) && (LA(2)==IDENT)) {
							{
							match(ARRAY);
							}
							if ( inputState.guessing==0 ) {
								
														s=ProgramSVSort.ARRAY;
													
							}
						}
					else {
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					}
					break;
				}
				case FORMULA:
				{
					match(FORMULA);
					{
					switch ( LA(1)) {
					case RIGID:
					{
						match(RIGID);
						if ( inputState.guessing==0 ) {
							rigid = true;
						}
						break;
					}
					case IDENT:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					if ( inputState.guessing==0 ) {
						
											s = Sort.FORMULA;
										
					}
					break;
				}
				case IDENT:
				{
					s=any_sort_id_check(true);
					{
					switch ( LA(1)) {
					case VARIABLES:
					{
						match(VARIABLES);
						if ( inputState.guessing==0 ) {
							makeVariableSV = true;
						}
						break;
					}
					case DEPENDING:
					{
						match(DEPENDING);
						if ( inputState.guessing==0 ) {
							makeDependingSV = true;
						}
						break;
					}
					case RIGID:
					{
						match(RIGID);
						if ( inputState.guessing==0 ) {
							rigid = true;
						}
						break;
					}
					case IDENT:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				one_schema_var_decl(s,makeVariableSV,makeDependingSV,rigid,listModifier);
				{
				_loop112:
				do {
					if ((LA(1)==COMMA)) {
						match(COMMA);
						one_schema_var_decl(s,makeVariableSV,makeDependingSV,rigid,listModifier);
					}
					else {
						break _loop112;
					}
					
				} while (true);
				}
				match(SEMI);
			}
			else {
				break _loop113;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void prog_var_decls() throws RecognitionException, TokenStreamException {
		
		
			Sort s;
		String var_name;
		
		
		match(PROGRAM);
		match(VARIABLES);
		match(LBRACE);
		{
		_loop127:
		do {
			if ((LA(1)==IDENT)) {
				s=sort_id_check(true);
				var_name=id();
				if ( inputState.guessing==0 ) {
					
									ProgramVariable pv = new ProgramVariable(
					new ProgramElementName(var_name), 
					javaInfo.getKeYJavaType(s));
									javaInfo.programVariables().add(pv);
								
				}
				match(SEMI);
			}
			else {
				break _loop127;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void pred_decls() throws RecognitionException, TokenStreamException {
		
		
			Sort[] argSorts;
			String pred_name;
		
		
		match(PREDICATES);
		match(LBRACE);
		{
		_loop117:
		do {
			if ((LA(1)==IDENT)) {
				pred_name=id();
				argSorts=arg_sorts(!skip_predicates);
				if ( inputState.guessing==0 ) {
					
								    if (!skip_predicates) {
									Name predicate = new Name(pred_name);
									if (func_ns.lookup(predicate) != null) {
									    // throw new AmbigiousDeclException
									    //("predicate "+pred_name+" ", 
									    //getLine(), getColumn());
									} else {
									    Function p = new Function(predicate,
												      Sort.FORMULA, 
												      argSorts);
									    func_ns.add(p);			
									}
								    } 
								
				}
				match(SEMI);
			}
			else {
				break _loop117;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void func_decls() throws RecognitionException, TokenStreamException {
		
		
			Sort[] argSorts;
			Sort retSort;
		String func_name;
		
		
		match(FUNCTIONS);
		match(LBRACE);
		{
		_loop120:
		do {
			if ((LA(1)==IDENT)) {
				retSort=sort_id_check(!skip_functions);
				func_name=id();
				argSorts=arg_sorts(!skip_functions);
				if ( inputState.guessing==0 ) {
					
								    if (!skip_functions) {
					
									Name fct_name = new Name(func_name);
									if (func_ns.lookup(fct_name) != null) {
									    //throw new AmbigiousDeclException
									    //("function "+func_name, 
									    //getLine(), getColumn());
									} else {
									    Function f=new Function(fct_name,
												    retSort, 
												    argSorts);
									    func_ns.add(f);
									}
								    } 
								
				}
				match(SEMI);
			}
			else {
				break _loop120;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void heur_decls() throws RecognitionException, TokenStreamException {
		
		Token  id = null;
		
		match(HEURISTICS);
		match(LBRACE);
		{
		_loop130:
		do {
			if ((LA(1)==IDENT)) {
				id = LT(1);
				match(IDENT);
				match(SEMI);
				if ( inputState.guessing==0 ) {
					
								    if (!skip_heuristics) {
									Heuristic h = new Heuristic(new Name(id.getText()));
									heur_ns.add(h);
								    }
								
				}
			}
			else {
				break _loop130;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final ListOfName  sort_identifiers() throws RecognitionException, TokenStreamException {
		ListOfName ids = SLListOfName.EMPTY_LIST;
		
		Token  id = null;
		Token  id2 = null;
		
		id = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			ids = ids.append ( new Name(id.getText()) );
		}
		{
		_loop87:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				id2 = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					ids = ids.append ( new Name(id2.getText()) );
				}
			}
			else {
				break _loop87;
			}
			
		} while (true);
		}
		return ids;
	}
	
	public final Sort[]  oneof_sorts() throws RecognitionException, TokenStreamException {
		Sort[] oneOfSorts = null;
		
		
			Vector args = new Vector();
			Sort s;
		
		
		match(LBRACE);
		s=sort_id_check(true);
		if ( inputState.guessing==0 ) {
			args.add(s);
		}
		{
		_loop93:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				s=sort_id_check(true);
				if ( inputState.guessing==0 ) {
					args.add(s);
				}
			}
			else {
				break _loop93;
			}
			
		} while (true);
		}
		match(RBRACE);
		if ( inputState.guessing==0 ) {
			
						oneOfSorts = (Sort[])args.toArray(AN_ARRAY_OF_SORTS);
					
		}
		return oneOfSorts;
	}
	
	public final Sort[]  extends_sorts() throws RecognitionException, TokenStreamException {
		Sort[] extendsSorts = null;
		
		
			Vector args = new Vector();
			Sort s;
		
		
		s=any_sort_id_check(true);
		if ( inputState.guessing==0 ) {
			args.add(s);
		}
		{
		_loop90:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				s=any_sort_id_check(true);
				if ( inputState.guessing==0 ) {
					args.add(s);
				}
			}
			else {
				break _loop90;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
						extendsSorts = (Sort[])args.toArray(AN_ARRAY_OF_SORTS);
					
		}
		return extendsSorts;
	}
	
	public final Sort  any_sort_id_check(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		Sort t;
		
		
		t=any_sort_id_check_help(checkSort);
		s=array_decls(t);
		return s;
	}
	
	public final Sort  sort_id_check(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		Sort t;
		
		
		t=sort_id_check_help(checkSort);
		s=array_decls(t);
		return s;
	}
	
	public final void one_schema_var_decl(
		Sort s, 
	            boolean makeVariableSV, 
	            boolean makeDependingSV,
	            boolean rigid, 
	            boolean listModifier
	) throws RecognitionException, TokenStreamException {
		
		Token  id = null;
		
		id = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			
					    if (!skip_schemavariables) {
						SchemaVariable v;
						if ( s == Sort.FORMULA ) {
						    v = SchemaVariable.createFormulaSV
							(new Name(id.getText()), listModifier, rigid);
						} else if ( s instanceof ProgramSVSort ) {
						    v = SchemaVariable.createProgramSV
						    (new ProgramElementName(id.getText()),(ProgramSVSort) s, listModifier);
						} else {
						    if ( makeVariableSV ) {
							v=SchemaVariable.createVariableSV
							(new Name(id.getText()), s, listModifier);
						    } else if ( makeDependingSV ) {
							v = SchemaVariable.createDependingSV
							(new Name(id.getText()), s, listModifier);
						    } else { v = SchemaVariable.createTermSV
							     (new Name(id.getText()), s, listModifier, rigid);
						    }
						}
						var_ns.add(v);
					    }
					
		}
	}
	
	public final Sort[]  arg_sorts(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort[] argSorts = null;
		
		
			Vector args = new Vector();
			Sort s;
		
		
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			s=sort_id_check(checkSort);
			if ( inputState.guessing==0 ) {
				args.add(s);
			}
			{
			_loop124:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					s=sort_id_check(checkSort);
					if ( inputState.guessing==0 ) {
						args.add(s);
					}
				}
				else {
					break _loop124;
				}
				
			} while (true);
			}
			match(RPAREN);
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
						argSorts = (Sort[])args.toArray(AN_ARRAY_OF_SORTS);
					
		}
		return argSorts;
	}
	
	public final Sort  sort_id_check_help(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		s=any_sort_id_check_help(checkSort);
		if ( inputState.guessing==0 ) {
			
			// don't allow generic sorts or collection sorts of
			// generic sorts at this point
			Sort t = s;
			while ( t instanceof CollectionSort )
			t = ((CollectionSort)t).elementSort ();
			if ( t instanceof GenericSort )
			throw new GenericSortException ( "sort",
			"Non-generic sort expected", t,
			getFilename (), getLine (), getColumn () );
			
		}
		return s;
	}
	
	public final Sort  array_decls(
		Sort p
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		int  n=0;
		
		
		{
		_loop138:
		do {
			if ((LA(1)==LBRACKET)) {
				match(LBRACKET);
				match(RBRACKET);
				if ( inputState.guessing==0 ) {
					n++;
				}
			}
			else {
				break _loop138;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			s = p;
			while(n>0){
			s=ArraySortImpl.getArraySort(s);
			n--;
			}
					
		}
		return s;
	}
	
	public final Sort  any_sort_id_check_help(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		Token  id = null;
		
		String name;
		
		
		id = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
				String idtext=(useInstead.get(id.getText()));
						s= (Sort) sort_ns.lookup(new Name(idtext));
						if (checkSort && s == null) {
						    throw 
							new NotDeclException("sort", id, 
									     getFilename());
						}
					
		}
		return s;
	}
	
	public final IdDeclaration  id_declaration() throws RecognitionException, TokenStreamException {
		 IdDeclaration idd = null ;
		
		Token  id = null;
		
		Sort s = null;
		
		
		id = LT(1);
		match(IDENT);
		{
		switch ( LA(1)) {
		case COLON:
		{
			match(COLON);
			s=sort_id_check(true);
			break;
		}
		case EOF:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			idd = new IdDeclaration ( id.getText (), s );
			
		}
		return idd;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"java\"",
		"\"array\"",
		"\"initializer\"",
		"\"statement\"",
		"\"expression\"",
		"\"statementexpression\"",
		"\"branch\"",
		"\"nonsimple\"",
		"\"lefthandside\"",
		"\"simple\"",
		"\"notsimple\"",
		"\"loopinit\"",
		"\"guard\"",
		"\"forupdates\"",
		"\"typeof\"",
		"\"type\"",
		"\"javaboolean\"",
		"\"object\"",
		"\"javabyte\"",
		"\"javashort\"",
		"\"javaint\"",
		"\"javalong\"",
		"\"javachar\"",
		"\"javabyteshortint\"",
		"\"anyjavatype\"",
		"\"number\"",
		"\"intliteral\"",
		"\"longliteral\"",
		"\"generic\"",
		"\"extends\"",
		"\"oneof\"",
		"\"variable\"",
		"\"switch\"",
		"\"booleanvariable\"",
		"\"catch\"",
		"\"methodreference\"",
		"\"constructorreference\"",
		"\"special\"",
		"\"classtype\"",
		"\"interfacetype\"",
		"\"arraytype\"",
		"\"methodbody\"",
		"\"variableinitializer\"",
		"\"label\"",
		"\"program\"",
		"\"multiplevardecl\"",
		"\"svlist\"",
		"\"all\"",
		"\"ex\"",
		"\"true\"",
		"\"false\"",
		"\"find\"",
		"\"if\"",
		"\"varcond\"",
		"\"noninteractive\"",
		"\"recursive\"",
		"\"displayname\"",
		"\"helptext\"",
		"\"new\"",
		"\"not\"",
		"\"free\"",
		"\"in\"",
		"\"depending\"",
		"\"on\"",
		"\"close\"",
		"\"goal\"",
		"\"replacewith\"",
		"\"add\"",
		"\"addrules\"",
		"\"addprogvars\"",
		"\"heuristics\"",
		"\"sorts\"",
		"\"schema\"",
		"\"variables\"",
		"\"implicit\"",
		"\"field\"",
		"\"reference\"",
		"\"next\"",
		"\"length\"",
		"\"rigid\"",
		"\"predicates\"",
		"\"functions\"",
		"\"formula\"",
		"\"rules\"",
		"\"proof\"",
		"\"rule\"",
		"\"term\"",
		"\"inst\"",
		"\"ifseqformula\"",
		"\"interactive\"",
		"\"heur\"",
		"\"problem\"",
		"\"#inType\"",
		"\"#isObject\"",
		"\"#isClonable\"",
		"\"#inLong\"",
		"\"#inInt\"",
		"\"#inChar\"",
		"\"#inShort\"",
		"\"#inByte\"",
		"\"#add\"",
		"\"#sub\"",
		"\"#mul\"",
		"\"#div\"",
		"\"#mod\"",
		"\"#less\"",
		"\"#greater\"",
		"\"#leq\"",
		"\"#geq\"",
		"\"#eq\"",
		"\"#JavaIntUnaryMinus\"",
		"\"#JavaIntAdd\"",
		"\"#JavaIntSub\"",
		"\"#JavaIntMul\"",
		"\"#JavaIntDiv\"",
		"\"#JavaIntMod\"",
		"\"#JavaIntAnd\"",
		"\"#JavaIntOr\"",
		"\"#JavaIntXor\"",
		"\"#JavaIntComplement\"",
		"\"#JavaIntShiftRight\"",
		"\"#JavaIntShiftLeft\"",
		"\"#JavaIntUnsignedShiftRight\"",
		"\"#JavaLongUnaryMinus\"",
		"\"#JavaLongAdd\"",
		"\"#JavaLongSub\"",
		"\"#JavaLongMul\"",
		"\"#JavaLongDiv\"",
		"\"#JavaLongMod\"",
		"\"#JavaLongAnd\"",
		"\"#JavaLongOr\"",
		"\"#JavaLongXor\"",
		"\"#JavaLongComplement\"",
		"\"#JavaLongShiftRight\"",
		"\"#JavaLongShiftLeft\"",
		"\"#JavaLongUnsignedShiftRight\"",
		"\"#moduloByte\"",
		"\"#moduloShort\"",
		"\"#moduloInteger\"",
		"\"#moduloLong\"",
		"\"#staticanalysis\"",
		"\"#lengthReference\"",
		"\"waryAll\"",
		"\"waryEx\"",
		"\"sameUpdateLevel\"",
		"VOCAB",
		"`;'",
		"`/'",
		"`:'",
		"`/->'",
		"`:='",
		"`.'",
		"`,'",
		"`('",
		"`)'",
		"`{'",
		"`}'",
		"`['",
		"']'",
		"`at'",
		"`|'",
		"`&'",
		"`->'",
		"`<->'",
		"`='",
		"`==>'",
		"'^'",
		"java operator",
		"white space",
		"a string in double quotes",
		"a char in single quotes",
		"ESC",
		"DIAMOND",
		"BOX",
		"BLOCK",
		"a string with double quotes",
		"a comment",
		"a comment",
		"a digit",
		"a hexadeciamal number",
		"a letter",
		"an admissible character for identifiers",
		"an identifer",
		"\"-\""
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 27021597764222976L, -4294967296L, 288309575885783039L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { -9189595039649431550L, -4294967296L, 289160562939527167L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 0L, -4294967296L, 288300744896151551L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 0L, -4294967296L, 288230385429774335L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 65538L, -4294967296L, 288232538484244479L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 65538L, 0L, 2161929617408L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 65538L, 0L, 2153339682816L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 65538L, 0L, 2162470682624L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	
	}
